/*
 # Agent.java
 # $Id: Agent.java,v 1.6 2002/06/08 08:36:46 yoshikia Exp $
 */

import java.util.*;
import rescueAgent.Generic.*;
import rescueAgent.RescueLib.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;
import Controller.*;

class Agent extends Thread implements CommandTable{
  String hostname = "localhost";
  String confFile = "AgentConf.txt";
  rescueAgent.IO.IO io;
  /** ߡ³ɤ **/
  boolean dummy = false;

  /** ͥ뤫ΥåǼѿ **/
  Vector message;
  /** ͥ뤫ΥåΥإåǼѿ **/
  int[] msg_header;
  /** ͥ뤫ΥåintǡǼѿ **/
  int[] msg_Idata;
  /** ͥ뤫ΥåbyteǡǼѿ **/
  byte[] msg_Bdata;
  /** ߥ졼Ǽ **/
  int time = -1;
  /** ߥ졼ɤλޤǤ뤫(default:300) **/
  int maxTime = 300;

  /********************************************************************/
  // 󥹥ȥ饯

  Agent(){
    io = new rescueAgent.IO.IO();
    io.connect(43,false);
  }

  /********************************************************************/

  Agent(int type){
    io = new rescueAgent.IO.IO();
    if(type%2 == 0){ // ³Civilianʤн
      io.connect(type,true);
    }
    else{
      io.connect(type,false);
    };
  }

  /********************************************************************/

  Agent(String hostname,int type,boolean dummy){
    this.hostname = hostname;
    this.dummy = dummy;
    io = new rescueAgent.IO.IO(hostname,6000);
    if(type%2 == 0){ // ³Civilianʤн
      io.connect(type,true);
    }
    else{
      io.connect(type,false);
    }

    Parameter.setParameter(confFile);
  }

  /********************************************************************/
  /**
   * եɤ߹ॳ󥹥ȥ饯
   **/

  Agent(String hostname,int type,boolean dummy,String confFile){
    // եɤ߹
    Parameter.setParameter(confFile);

    this.hostname = hostname;
    this.dummy = dummy;
    io = new rescueAgent.IO.IO(hostname,6000);
    if(type%2 == 0){ // ³Civilianʤн
      io.connect(type,true);
    }
    else{
      io.connect(type,false);
    };
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  public void run(){
    Controller controller;
    maxTime = Parameter.MAX_SIMULATION_TIME; // ߥ졼֤򥻥å
    //System.out.print("Agent Simulation is continued until "+maxTime);
    //System.out.println(" steps.");

    message = io.receive();
    msg_header = (int[])message.get(0);
    msg_Idata = (int[])message.get(1);

    if(msg_header[0] != CommandTable.KA_CONNECT_OK){
      // KA_CONNECT_OKʳȥå
      //System.err.println("Agent.run() Error Code : " + msg_header[0]);
      return;
    }

    if(msg_Idata[0]==ServerSetting.TYPE_CIVILIAN){
      controller = new CivilianController(msg_header[3],io,
					  msg_header,msg_Idata);
    }
    else if(msg_Idata[0]==ServerSetting.TYPE_FIREBRIGADE){
      // TODO : ľ
      controller = new FireBrigadeController(msg_header[3],io,
					     msg_header,msg_Idata);
    }
    else if(msg_Idata[0]==ServerSetting.TYPE_AMBULANCETEAM){
      controller = new AmbulanceTeamController(msg_header[3],io,
					       msg_header,msg_Idata);
    }
    else if(msg_Idata[0]==ServerSetting.TYPE_POLICEFORCE){
      controller = new PoliceForceController(msg_header[3],io,
					     msg_header,msg_Idata);
    }
    else if(msg_Idata[0]==ServerSetting.TYPE_FIRESTATION){
      controller = new FireStationController(msg_header[3],io,
					     msg_header,msg_Idata);
    }
    else if(msg_Idata[0]==ServerSetting.TYPE_AMBULANCECENTER){
      controller = new AmbulanceCenterController(msg_header[3],io,
						 msg_header,msg_Idata);
    }
    else if(msg_Idata[0]==ServerSetting.TYPE_POLICEOFFICE){
      controller = new PoliceOfficeController(msg_header[3],io,
					      msg_header,msg_Idata);
    }
    else{
      //System.out.println("Unknown Agent Init(Agent.run())");
      controller = new CivilianController(msg_header[3],io,
					  msg_header,msg_Idata);
    }
    io.sendAck();

    if(dummy){ // ߡ³ʤ饹åɽλ
      return;
    }

    // Debug Use
    //controller.messageOutput(message, -1); // -1ϺǸޤɽ

    while(time <= maxTime){ // ߥ졼λȶ˹ưλ
      message = io.receive();
      msg_header = (int[])message.get(0); // åإå
      int command = msg_header[0];

      // åɽ[ǥХå]
      //controller.messageOutput(message, -1); // -1ϺǸޤɽ

      switch(command){
      // ***** ʪKA_SENSE *****
      case KA_SENSE:

	msg_Idata = (int[])message.get(1); // åǡ
	time = msg_header[3]; // Υå
	//System.out.println("time = "+time);
	// ư곫(Ʊ,֤ͤAgentViewerѤSense󤬽и)
	int[] tempUpSense = controller.decideCommand(msg_header,msg_Idata);

	break;

      // ***** ʪKA_HEAR,KA_HEAR_SAY,KA_HEAR_TELL *****
      case KA_HEAR:
	break; // KA_HEAR ϵʤΤ̵뤹롣
      case KA_HEAR_SAY:
      case KA_HEAR_TELL:
	msg_Bdata = (byte[])message.get(1); // åǡ
	// ȯʬϳ(Ʊ,֤ͤAgentViewerѤSense󤬽и)
	int[] tempUpHear = controller.receiveHear(msg_header,msg_Bdata);

	break;

      // ***** ʳ *****
      // Kernel褿å(Networkκ?)
      default:
	//System.err.print("KA_Message Error!! MessageHeader:" + command);
	break;
      }// end switch(command)
      this.yield();

    }
    io.flushAllLog();
    //System.out.println("time = "+time+", simulation finished.");
  }

  /********************************************************************/
  /*
  void setConfFile(String confFile){
    this.confFile = confFile;
  }
  */
  /********************************************************************/
}
