/*
  # Controller/Controller.java
  # Copyright (c) 2001-2002 Yoshiki Asai(yoshikia@phaser.elcom.nitech.ac.jp)
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  # $Id: Controller.java,v 1.18 2002/06/08 08:36:24 yoshikia Exp $
  */
package Controller;

import java.io.*;
import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueObject.*;
import rescueAgent.AreaMap.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼ǥȤ򥳥ȥ뤹륯饹<BR>
 * Controller:
 * Controll Rescue Agent in Rescue simulation
 **/
public abstract class Controller implements AACommand, KKCommand, CommandTable{

  /** ʬID **/
  int id;
  /** ߻ **/
  int time;
  /** route buffer for moving **/
  int[] route;

  /** interface for kernel **/
  IO io;
  /** Manager of all object **/
  ObjectManager objectManager;
  /** Manager of the send Messages **/
  MessageManager_NEW messageManager_new;
  /** Parser of the KA_HEAR_* Messages **/
  HearInfoParser hearInfoParser;
  /** Parser of the KA_SENSE Messages **/
  SenseInfoParser senseInfoParser;

  /** ľΥåμ **/
  int prevMsgTime = -1;
  /** Ʊ˼å **/
  int rcvMsgCount = 0;

  /** åإå(msg_dataŬ) **/
  int[] msg_header; // ̿ǤϤ⤦Ȥʤ

  /** ٤Ƥ򤳤ΥХåե˵Ͽdelay **/
  String sayBuffer;

  /********************************************************************/
  // 󥹥ȥ饯

  public Controller(int id, IO io, int[] msg_header, int[] msg_data){
    this.io = io;
    this.id = id;

    objectManager = new ObjectManager(id);
    ObjectDatabase objectDB = objectManager.getObjectDatabase();
    senseInfoParser = objectManager.getSenseInfoParser();
    hearInfoParser = new HearInfoParser(objectDB,senseInfoParser);

    init(msg_header,msg_data);

    //System.out.println("Init End");

    // Debug Use
    // objectManager.printDB();
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  // ֥ȥ饯ȥ饹
  /** βϤȾγǼ<BR>
   * ºݤμ <i>MovingObjectController.java</i> 
   * <i>MovelessObjectController.java</i> ǹԤʤ
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected abstract void init(int[] msg_header, int[] msg_data);

  /** SENSE (Kernel to Agentå)
   * Ф륨ȤΤդޤ(ư)򵭽Ҥ᥽åɡ<BR>
   * ºݤμ <i>MovingObjectController.java</i> 
   * <i>MovelessObjectController.java</i> ǹԤʤ<BR><BR>
   * @param msg_header kernelƤåإå
   * @param msg_data kernelƤåǡ
   * @return ưη̹Τä֥ȤSenseǡ
   *         AgentViewer饹ǻȤ롣
   **/
  public abstract int[] decideCommand(int[] msg_header, int[] msg_data);

  /** HEAR (Agent to Agentå)
   * Ф륨ȤΤդޤ(ȯʬ)򵭽Ҥ᥽åɡ<BR>
   * ºݤμ <i>MovingObjectController.java</i> 
   * <i>MovelessObjectController.java</i> ǹԤʤ<BR><BR>
   * @param msg_header kernelƤåإå
   * @param msg_data kernelƤåǡ
   * @return Hearη̹Τä֥ȤSenseǡ
   *         AgentViewer饹ǻȤ롣
   **/
  public abstract int[] receiveHear(int[] msg_header, byte[] msg_data);

  // ֥ȥ饯ȥ饹 ޤ
  /********************************************************************/
  /** ޤ˥ǥХåѤΥ᥽åɡͥ뤫褿Ϥ <BR>
   * header...åإå(), data...åǡ <BR>
   * աˤϤΥ᥽åɤȤϾäۤ⡩ <BR><BR>
   * @param message åͤޤäVectorѿ
   * @param outputLength Ϥåǡbyte(-1ƽ)
   **/
  public void messageOutput(Vector message, int outputLength){

    try{
      int[] header = (int[])message.get(0);
      //System.out.print("message(t="+time+"):[(header) "+header[0]);
      for(int i=1; i<header.length; i++){
	//System.out.print(", "+header[i]);
      }
      //System.out.print("]");
      if(message.get(1) instanceof int[]){
	int[] data = (int[])message.get(1);
        int length = data.length;
          if(outputLength > 0 && outputLength < length){
            length = outputLength;
          }
	  //System.out.print("[(intdata) "+data[0]);
          for(int i=1 ; i<length ;i++){
            //System.out.print(", "+data[i]);
          }
          //System.out.print("]");
      }
      else if(message.get(1) instanceof byte[]){
	byte[] data = (byte[])message.get(1);
        int length = data.length;
          if(outputLength > 0 && outputLength < length){
            length = outputLength;
          }
	  //System.out.print("[(bytedata) "+data[0]);
          for(int i=1 ; i<length ;i++){
            //System.out.print(", "+data[i]);
          }
          //System.out.print("]");
      }
      else{
	  //System.out.print("[(data) Illegal Message Data!! datatype:");
	  //System.out.print((message.get(1)).getClass()+" ]");
      }
      //System.out.println();
    }
    catch(Exception e){
      e.printStackTrace();
      //System.err.println("Illegal Message!!");
    }
  }

  /********************************************************************/
  /** ١headerdataʬ䤷åƤӷ礹᥽å <BR>
   * dataint[]Ǥ뤳Ȥ󡣤Ĥޤꡢ󥹾ΤȤΤߡ
   * Υ᥽åɤƤӽФ롣<BR><BR>
   * @param header åإå
   * @param data åǡ
   * @return إåȥǡ礵줿int󷿥å
   **/
  public int[] mergeMessage(int[] header, int[] data){
    int[] msg = new int[header.length + data.length];
    System.arraycopy(header,0,msg,0,header.length);
    System.arraycopy(data,0,msg,header.length,data.length);
    return msg;
  }

  /********************************************************************/
  /** ĤSenseǡĤˤޤȤ롣<BR>
   * ħȤ, ɤʤΤǤäƤ⥨顼֤ʤͤˤʤäƤ롣
   * <BR><BR>
   * @param src 縵Senseǡ
   * @param senseData 礹Senseǡ
   * @return 礵줿intSenseǡɤϤnullä
   *         null֤
   **/
  protected int[] mergeSenseData(int[] src, int[] senseData){
    if(src == null){
      return senseData;
    }
    else if(senseData == null){
      return src;
    }
    else{
      // mergeκݤˣܤSenseǡνü򣱤ļ
      int[] mergeData = new int[src.length + senseData.length -1];
      System.arraycopy(src,0,mergeData,0,(src.length)-1);
      System.arraycopy(senseData,0,mergeData,(src.length)-1,senseData.length);
      return mergeData;
    }
  }

  /********************************************************************/
  /** Ƽ拾ޥɤȯԼԤʸString֤<BR><BR>
   * @param commnad AACommand
   * @return ȯԼ(FB,FS,AT,AC,PF,POΤ줫)פʤnull
   **/
  protected String getCommandPublisher(int command){
    String publisher;
    switch(command){
    case AA_SENSE_FB:                // ( 1) FBФ󥹾ѥޥ
    case AA_EXTINGUISH:              // (10) ò(FB)
    case AA_EXTINGUISH_FIN:          // (11) òФˤòФ(FB)
    case AA_REFILL:                  // (12) (FB)
    case AA_REFILL_FIN:              // (13) 崰λ(FB)
    case AA_MOVE_FB:                 // (14) ư
    case AA_REST_FB:                 // (15) ⤷ʤ
    case AA_BURIED_MYSELF_FB:        // (20) ʬʪޤäƤ
    case AA_BURIED_CIVILIAN_FB:      // (21) ̱ʪޤäƤ
    case AA_HEAR_BURIED_CIVILIAN_FB: // (22) ʪޤäƤ̱
                                     //      ƤǤʹ
    case AA_HALT_FB:       // (23) ʬϩĺɤˤưʤʤäƤ
    case AA_CONGESTED_FB:  // (24) ĺɰʳθưʤ(ڡ)
    case AA_BLOCKADE_FB:   // (25) ĺɤƤƻϩȯ
    case AA_JUST_FIRE_FB:  // (26) äвФ(Ƥ)ʪȯ
    case AA_MOVE_ASIDE_FB: // (27) ɤ
      publisher = "FB";
      break;
    case AA_SENSE_FS:                // ( 2) FSФ󥹾ѥޥ
    case AA_HEAR_BURIED_CIVILIAN_FS: // (30) ʪޤäƤ̱
                                     //      ƤǤʹ
    case AA_JUST_FIRE_FS:  // (31) äвФ(Ƥ)ʪȯ
      publisher = "FS";
      break;
    case AA_SENSE_AT:                // ( 3) ATФ󥹾ѥޥ
    case AA_RESCUE:                  // (40) ߽(AT)
    case AA_RESCUE_FIN:              // (41) ߽дλ(AT)
    case AA_LOAD:                    // (42) ô(AT)
    case AA_LOADING:                 // (43) (AT)
    case AA_UNLOAD:                  // (44) (AT)
    case AA_MOVE_AT:                 // (45) ư
    case AA_REST_AT:                 // (46) ⤷ʤ
    case AA_BURIED_MYSELF_AT:        // (50) ʬʪޤäƤ
    case AA_BURIED_CIVILIAN_AT:      // (51) ̱ʪޤäƤ
    case AA_HEAR_BURIED_CIVILIAN_AT: // (52) ʪޤäƤ̱
                                     //      ƤǤʹ
    case AA_HALT_AT:       // (53) ʬϩĺɤˤưʤʤäƤ
    case AA_CONGESTED_AT:  // (54) ĺɰʳθưʤ(ڡ)
    case AA_BLOCKADE_AT:   // (55) ĺɤƤƻϩȯ
    case AA_JUST_FIRE_AT:  // (56) äвФ(Ƥ)ʪȯ
    case AA_MOVE_ASIDE_AT: // (57) ɤ
      publisher = "AT";
      break;
    case AA_SENSE_AC:                // ( 4) ACФ󥹾ѥޥ
    case AA_HEAR_BURIED_CIVILIAN_AC: // (60) ʪޤäƤ̱
                                     //      ƤǤʹ
    case AA_JUST_FIRE_AC:  // (61) äвФ(Ƥ)ʪȯ
      publisher = "AC";
      break;
    case AA_SENSE_PF:                // ( 5) PFФ󥹾ѥޥ
    case AA_CLEAR:                   // (70) (PF)
    case AA_CLEAR_FIN:               // (71) (PF)
    case AA_MOVE_PF:                 // (72) ư
    case AA_REST_PF:                 // (73) ⤷ʤ
    case AA_BURIED_MYSELF_PF:        // (80) ʬʪޤäƤ
    case AA_BURIED_CIVILIAN_PF:      // (81) ̱ʪޤäƤ
    case AA_HEAR_BURIED_CIVILIAN_PF: // (82) ʪޤäƤ̱
                                     //      ƤǤʹ
    case AA_HALT_PF:       // (83) ʬϩĺɤˤưʤʤäƤ
    case AA_CONGESTED_PF:  // (84) ĺɰʳθưʤ(ڡ)
    case AA_BLOCKADE_PF:   // (85) ĺɤƤƻϩȯ
    case AA_JUST_FIRE_PF:  // (86) äвФ(Ƥ)ʪȯ
    case AA_MOVE_ASIDE_PF: // (87) ɤ
      publisher = "PF";
      break;
    case AA_SENSE_PO:                // ( 6) POФ󥹾ѥޥ
    case AA_HEAR_BURIED_CIVILIAN_PO: // (90) ʪޤäƤ̱
                                     //      ƤǤʹ
    case AA_JUST_FIRE_PO:  // (91) äвФ(Ƥ)ʪȯ
      publisher = "PO";
      break;
    default:
      //System.err.print("ޥȯԼԤǤޤ");
      //System.err.println("[getCommandPublisher()]: command="+command);
      publisher = null;
    }
    return publisher;
  }

  /********************************************************************/
  /** Integer饹Υ֥IDǼ줿VectoråȤФ,
   * νʣID롣<BR>
   * ֤ͤȤVector֤ΤǤϤʤ, Ϳ줿Vector
   * åȤȤľܽ񤭴Τդɬס<BR><BR>
   * @param objIDset Integer饹Υ֥IDǼ줿Vectorå
   **/
  protected void removeOverlapID(Vector objIDset){
    int length = objIDset.size();
    for(int i=0; i<length-1; i++){
      for(int j=i+1; j<length; j++){
	Integer int1 = (Integer)objIDset.get(i);
	Integer int2 = (Integer)objIDset.get(j);
	if(int1.equals(int2)){
	  objIDset.remove(j);
	  j--;
	  length--;
	}
      }
    }
  }

  /********************************************************************/
  /** ƤMsgSetΤMsgSetإǡܤѤ롣<BR>
   * ºݤϰܤѤΤǤϤʤԡƤ롣ȤΤ,
   * ׻ѤƤХȿϳͤǤ, ޤ,
   * Senseޥɤ, ư̵̤ʶƤޤ,
   * ޤ, ǡη»ǽ뤿Ǥ롣<BR><BR>
   * @param overMsgSet ܤѤȤʤ, Ƥåå
   * @param underMsgSet ܤѤȤʤ, Τåå
   * @param underMsgSetSize ܤѤΥååȤθߤ(Хȿ)
  **/
  protected void sizeOptimize(Vector overMsgSet,
			    Vector underMsgSet, int underMsgSetSize){

    int aboutTELLMAX = Parameter.TELL_MAX_BYTE - 10; // 褽θ³
    int overMsgSetSize = 0; // ܤѤΥåȤΥХȿ򥫥
    boolean isFullAll = false; // ܤѤΥåȤ³Ķɤ
    Iterator it = overMsgSet.iterator();
    while(it.hasNext() && isFullAll == false){
      Message mes = (Message)it.next();
      overMsgSetSize += mes.getMsgLength(); // Хȿ
      // СåΤ߰ܤѤ
      // â, ưǤϤʤ虜ȥԡˤ롣(ʣƤǤ)
      if(overMsgSetSize > aboutTELLMAX){
	int[] tmpData = new int[(mes.getMessage()).length];
	System.arraycopy(mes.getMessage(),0,tmpData,0,tmpData.length);
	Message mesClone = new Message(mes.getDataTime(),
				       mes.getImportance(),
				       mes.getMsgLength(),
				       mes.getCommand(),tmpData);
	underMsgSet.add(mesClone);
	underMsgSetSize += mesClone.getMsgLength();
	if(underMsgSetSize > Parameter.TELL_MAX_BYTE){
	  isFullAll = true; // ˤʤä롼׽λ
	}
      }
    }
  }

  /********************************************************************/
  /**
   * å <BR><BR>
   * @deprecated ʤǸƤäƤ⤤(02-11-25) 
   * @param type ʬΥȥס
   * @param selfID ʬID
   * @param destID ϩ
   * @param objective 
   * @param target åȡ
   * @return å(String)
   **/

  protected String getMsgString(String type,int selfID,int[] destID,
				String objective,int[] target){
    StringBuffer ret = new StringBuffer("(");
    ret.append(type);
    ret.append(" ");
    ret.append(id);
    // ʣΥåȤ
    ret.append(" (");
    for(int i=0;i<destID.length;i++){
      if(i!=0)
	ret.append(" ");
      ret.append(destID[i]);
    };
    ret.append(") ");
    // ʣΥåȤ ޤ
    ret.append(objective);
    // ʣΥåȤ
    ret.append(" (");
    for(int i=0;i<target.length;i++){
      if(i!=0)
	ret.append(" ");
      ret.append(target[i]);
    };
    ret.append("))");
    // ʣΥåȤ ޤ
    return ret.toString();
  }

  /********************************************************************/
  /**
   * å(RoboCup2002)<BR>
   * Todo : ߷Ūˤ <BR><BR>
   * @deprecated ʤǸƤäƤ⤤
   * @param command AACommand.java줿ޥ
   * @param target Ƽ勵åID
   * @return å(String)
   **/
  
  protected String getMsgString(int command,int[] target){
    int[] buffer = new int[10];
    int index = buffer.length-1;
    StringBuffer msg = new StringBuffer();
    
    // commandʬ
    msg.append((char)(command/10+0x30)); //ASCII Ѵ
    msg.append((char)(command%10+0x30)); //ASCII Ѵ
     
    // 
    // TODO : ID η 10 ʾξ꤬
    //  Υ쥹塼㤢ꤨʤ...
    //   äƤ iiiiiiiiii եɤ꤭ʤ
    for (int i=0;i<target.length;i++){
      // оݤȤʤ ID
      int tmp = target[i];
      // ¸
      int digit = 0;
      do{
	if(index < 0){
	  // 10 ӥåȤۤ,ҤʬХåե
	  // Ƥ
	  for (int j=0;j<digit;j++){
	    buffer[j] = 0;
	  }
	  // index , ID ɤߤˤ
	  index = digit-1;
	  digit = 0;
	  break;
	}
	buffer[index--] = tmp%10;
	tmp /= 10;
	digit++;
      }
      while(tmp != 0);
      if (index == -1){
	// ξ֤Ƿ񤭹ȼԤΤ,Ҥʬ
	for (int j=0;j<digit;j++){
	  buffer[j] = 0;
	}
	// index , ID ɤߤˤ
	index = digit-1;
	digit = 0;	    
      }
      if (digit != 0){
	// ϥХåե˽񤭹
	buffer[index--] = digit;
      }
    }
    
    // IDºݤ˽񤭹
    for (int i=0;i<buffer.length;i++){
      msg.append((char)(buffer[i]+0x30)); // ASCII Ѵ 
    }
    return msg.toString();
  }

  /********************************************************************/
}
