/*
  # Controller/FireStationController.java
  # Copyright (c) 2000-2002 Nagoya Institute of Technology Wada Laboratory
  # Copyright (c) 2000-2002 Taku Sakushima , Tetsuya Esaki
  # Copyright (c) 2001-2002 Yoshiki Asai(yoshikia@phaser.elcom.nitech.ac.jp)
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  #
  # $Id: FireStationController.java,v 1.12 2002/06/08 08:36:24 yoshikia Exp $
 */
package Controller;

import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueObject.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼Ǿɽ𥨡Ȥ򥳥ȥ뤹륯饹<BR>
 * FireStationController:
 * Controll FireStation Agent in Rescue simulation
 **/
public class FireStationController extends MovelessObjectController{

  /********************************************************************/
  // 󥹥ȥ饯

  public FireStationController(int id,IO io,int[] msgH, int[] msgD){
    super(id,io,msgH,msgD);
    
    // Debug Use
    /*
    System.out.println("(FB)ο : "
		       +objectManager.getFireBrigadeObjectNum());
    System.out.println("ɽ(FS)ο : "
		       +objectManager.getFireStationObjectNum());
    System.out.println("ߵ޽(AC)ο : "
		       +objectManager.getAmbulanceCenterObjectNum());
    System.out.println("ٻ(PO)ο : "
		       +objectManager.getPoliceOfficeObjectNum());
    System.out.println("(FS+AC+PO)ο : "
		       +objectManager.getRescueCenterObjectNum());
    */
    System.gc(); // ١쥯μ¹
    //System.out.println("My ID: "+ id);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /**
   * βϤȾγǼ(SubClassܺٵʬ)
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected void init(int[] msg_header, int[] msg_data){
    // ޤsuperƤ, 󥿡ȶ̤ν¹
    super.init(msg_header,msg_data);
    // ʲǾɽͭν򤹤(Ǥϲ⤷ʤ)
  }

  /********************************************************************/
  /** Tellåμ˴ؤ,
   * Ƹĥ󥿡ȸͭνԤʤ<BR>
   * , ̤κŬޤ᤿ƥꥸ󥹤ʽ򤷤,
   * Ȥꤢ, žפʥåäˤƤ
   * <BR><BR>
   * @param tellMsgSet1 ܤ io.tell() ѥåѥåå
   * @param tellMsgSet1 ܤ io.tell() ѥåѥåå
   **/
  protected void uniqueDecidingForMessageSelect(Vector tellMsgSet1,
						Vector tellMsgSet2){
    Vector[] data = new Vector[2];
    data[0] = tellMsgSet1;
    data[1] = tellMsgSet2;
    for(int i=0; i<data.length; i++){
      int length = data[i].size();
      for(int j=0; j<length; j++){
	Message mes = (Message)data[i].get(j);
	int command = mes.getCommand();
	if(needToForward(command) == false){
	  data[i].remove(j);
	  length--;
	  j--;
	}
      }
    }
  }

  /********************************************************************/
  /** AACommand žɬפ뤫ɤȽǡ<BR><BR>
   * @param command AACommand
   * @return žɬפ뤫ɤ(true..., false...ʤ)
   **/
  private boolean needToForward(int command){
    boolean bool;
    switch(command){
    case AA_SENSE_FB:
    case AA_SENSE_FS:
    case AA_SENSE_AT:
    case AA_SENSE_AC:
    case AA_SENSE_PF:
    case AA_SENSE_PO:
      bool = true;
      break;
    case AA_MOVE_FB:
    case AA_MOVE_AT:
    case AA_MOVE_PF:
    case AA_REST_FB:
    case AA_REST_AT:
    case AA_REST_PF:
      bool = false;
      break;
    case AA_BURIED_MYSELF_FB:
    case AA_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FS:
      bool = true;
      break;
    case AA_BURIED_MYSELF_AT:
    case AA_BURIED_MYSELF_PF:
    case AA_BURIED_CIVILIAN_AT:
    case AA_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_AT:
    case AA_HEAR_BURIED_CIVILIAN_AC:
    case AA_HEAR_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_PO:
      bool = false;
      break;
    case AA_HALT_FB:
      bool = true;
      break;
    case AA_HALT_AT:
    case AA_HALT_PF:
      bool = false;
      break;
    case AA_CONGESTED_FB:
    case AA_CONGESTED_AT:
    case AA_CONGESTED_PF:
    case AA_BLOCKADE_FB:
    case AA_BLOCKADE_AT:
    case AA_BLOCKADE_PF:
    case AA_JUST_FIRE_FB:
    case AA_JUST_FIRE_FS:
    case AA_JUST_FIRE_AT:
    case AA_JUST_FIRE_AC:
    case AA_JUST_FIRE_PF:
    case AA_JUST_FIRE_PO:
    case AA_MOVE_ASIDE_FB:
    case AA_MOVE_ASIDE_AT:
    case AA_MOVE_ASIDE_PF:
      bool = true;
      break;
    case AA_WOULD_GROUP:
    case AA_GROUP_RECIP:
    case AA_GROUP_REJCT:
    case AA_GROUP_MAKED:
    case AA_GROUP_BROKE:
    case AA_GROUP_RELEASE:
      bool = false;
      break;
    case AA_EXTINGUISH:
    case AA_EXTINGUISH_FIN:
    case AA_REFILL:
    case AA_REFILL_FIN:
      bool = false;
      break;
    case AA_RESCUE:
    case AA_RESCUE_FIN:
    case AA_LOAD:
    case AA_LOADING:
    case AA_UNLOAD:
      bool = false;
      break;
    case AA_CLEAR:
      bool = false;
      break;
    case AA_CLEAR_FIN:
      bool = true;
      break;
    default:
      //System.err.println("̤ޥɤǤ:[needToForward()]");
      bool = false;
    }

    return bool;
  }

  /********************************************************************/
  /** Ƹĥ󥿡ȤˤȤä,٤åɤȽꤹ롣
   * <BR><BR>
   * @param msg_header åإå
   * @return åtrue, Ǥʤfalse
   **/
  protected boolean shouldReadMessage(int[] msg_header){
    boolean isReceive = false;
    int senderID = msg_header[3];
    if(getMyMovingObjectNum() == 0){ // ưAgentʤ, 
      if(msg_header[0] == KA_HEAR_SAY &&  // HearSayλ, 
	 objectManager.hasCivilianObject(senderID) &&
	 !objectManager.hasRescueManObject(senderID)){ // ̱
	isReceive = true; // Ĥޤ,̱HearSayʹʤ
      }
    }
    else{ // Agent, 
      if(msg_header[0] == KA_HEAR_TELL){ // HearTellλ, 
	if(objectManager.hasFireBrigadeObject(senderID) || 
	   objectManager.hasRescueCenterObject(senderID)){ // FB,AC,PO
	  isReceive = true; // Ĥޤ,꤫HearTellʹʤ
	}
      }
    }
    return isReceive;
  }

  /********************************************************************/
  /** ߽, ⤷ϻ꤫åϤ,
   * Ƹĥ󥿡ȸͭΥåԤʤ<BR>
   * , ϤåФ, ž٤ɤȽԤʤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message Messageå
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForRescueAgent(int ka_command,
					      int senderID, Message message){

    String comPublisher = getCommandPublisher(message.getCommand());
    if(ka_command == KA_HEAR_TELL){
      // ľܤԤFBλž
      if(objectManager.hasFireBrigadeObject(senderID)){
	messageManager_new.storeTellMessage(message,2); // 2 ϥ󥿡Agent
      }
      // ľܤԤ¾λ,
      else if(objectManager.hasRescueCenterObject(senderID)){
	// , ޥɤȯԼԤFB,FSǤʤž
	if(!comPublisher.equals("FB") && !comPublisher.equals("FS")){
	  messageManager_new.storeTellMessage(message,1); // 1 Ͼ
	}
      }
    }
    return null; // ͤǤϹԤʤʤΤnull֤
  }
  
  /********************************************************************/
  /** ̱åϤ,
   * Ƹĥ󥿡ȸͭΥåԤʤ<BR>
   * ߤΤȤ, Υ᥽åɤǼ¹Ԥ뤳ȤϤʤΤǲ⤷ʤ֤롣
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message ʸ󷿥å
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/  
  protected int[] uniqueHearingForCivilian(int ka_command,
					   int senderID, String message){
    return null; // ߤϲ⤷ʤΤnull֤
  }

  /********************************************************************/
}
