/*
  # Controller/MovelessObjectController.java
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  # $Id: MovelessObjectController.java,v 1.4 2004/05/10 12:48:10 K.Honji Exp $
  */

package Controller;

import java.io.*;
import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueObject.*;
import rescueAgent.RescueLib.ServerSetting;
import rescueAgent.AreaMap.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼ǥ󥿡Ȥ򥳥ȥ뤹륯饹<BR>
 * MovelessObjectController:
 * Controll Rescue Moveless Agent in Rescue simulation
 **/
public abstract class MovelessObjectController extends Controller{

  /********************************************************************/
  // 󥹥ȥ饯

  public MovelessObjectController(int id, IO io, int[] msgH, int[] msgD){
    super(id,io,msgH,msgD);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  // ֥ȥ饯ȥ饹
  /** Tellåμ˴ؤ,
   * Ƹĥ󥿡ȸͭνԤʤ<BR>
   * ϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param tellMsgSet1 ܤ io.tell() ѥåѥåå
   * @param tellMsgSet1 ܤ io.tell() ѥåѥåå
   **/
  protected abstract void uniqueDecidingForMessageSelect(Vector tellMsgSet1,
							 Vector tellMsgSet2);

  /** Ƹĥ󥿡ȤˤȤä,٤åɤȽꤹ롣
   * <BR> ȽϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param msg_header åإå
   * @return åtrue, Ǥʤfalse
   **/
  protected abstract boolean shouldReadMessage(int[] msg_header);

  /** ߽, ⤷ϻ꤫åϤ,
   * Ƹĥ󥿡ȸͭΥåԤʤ<BR>
   * ϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message Messageå
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected abstract int[] uniqueHearingForRescueAgent(int ka_command,
						       int senderID,
						       Message message);

  /** ̱åϤ,
   * Ƹĥ󥿡ȸͭΥåԤʤ<BR>
   * ϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message ʸ󷿥å
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected abstract int[] uniqueHearingForCivilian(int ka_command,
						    int senderID,
						    String message);

  // ֥ȥ饯ȥ饹 ޤ
  /********************************************************************/
  /**
   * βϤȾγǼ(SuperClassʬ)
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected void init(int[] msg_header, int[] msg_data){
    // ǡ١ιۤ򤹤(γˤȤʤ)
    senseInfoParser.parseSenseInfo(msg_header, msg_data);

    // å
    // (1)ޤϽưAgentοǽʥå򥻥å
    int movingObjNum = getMyMovingObjectNum();
    Parameter.setMessageNum(movingObjNum);
    String type = ServerSetting.getAgentType(msg_data[0],true); // 2ʸString
    //System.out.print("("+type+")ǤMessage Send...");
    //System.out.print(Parameter.MAX_CENTER_SNDMSG_NUM +", Recieve...");
    //System.out.println(Parameter.MAX_CENTER_RCVMSG_NUM);
    // (2)MessageManagerι
    ObjectDatabase objectDB = objectManager.getObjectDatabase();    
    messageManager_new = new MessageManager_NEW(1,2,id,objectDB,io);
  }

  /********************************************************************/
  /** ʬƤưΥ(㤨, FSʤFB)¸߿֤<BR>
   * ⤤ʤ, ֤롣<BR><BR>
   * @return ƤưΥȤ¸߿
   **/
  public int getMyMovingObjectNum(){

    int movingObjNum = 0;
    if(objectManager.hasFireStationObject(id)){
      movingObjNum = objectManager.getFireBrigadeObjectNum();
    }
    else if(objectManager.hasAmbulanceCenterObject(id)){
      movingObjNum = objectManager.getAmbulanceTeamObjectNum();
    }
    else if(objectManager.hasPoliceOfficeObject(id)){
      movingObjNum = objectManager.getPoliceForceObjectNum();
    }
    else{
      //System.err.print("ȤλIDǤ: ID="+id);
    }
    return movingObjNum;
  }

  /********************************************************************/
  /** SENSE (Kernel to Agentå) Ф,
   * 󥿡ȤΤդޤ(ư)򵭽Ҥ롣<BR>
   * ƥͭεư,̤ݥ᥽åɤǼ¸롣<BR>
   * 㤨, <i>protected abstract void uniqueDeciding()</i> Ȥ<BR><BR>
   * @param msg_header kernelƤåإå
   * @param msg_data kernelƤåǡ
   * @return ưη̹Τä֥ȤSenseǡ
   *         AgentViewer饹ǻȤ롣
   **/
  public int[] decideCommand(int[] msg_header, int[] msg_data){
    // ˤϥ󥿡ȶ̤ιư򵭽Ҥ롣
    //
    // ʾι
    //   1-1.Senseβ senseInfoParser.parseSenseInfo(msg_header,
    //                                                        msg_data);
    //   1-2.ФȳǼ time = objectManager.getTime();
    //   1-3.MessageManager_newλǡ
    //       messageManager_new.updateNowTime(time);
    //   1-4-1.ϤSenseΤ줿֥Ȥξ
    //         senseInfoParser.getRenewObjectsID()ѤФSense
    //         åѴưʲΥ᥽åɤ¹ԡ
    //         Message msg = messageManager_new.makeSenseMessage(senseData);
    //         messageManager_new.storeTellMessage(msg,0);
    //   1-4-2. 嵭ƱAA_BLOCKADE,AA_JUST_FIREγƼå
    //         (senseInfoParser.getRenewObjectsID()Ѥ)
    // Say & Tell ޥɤȯư
    //    ޤǤ˺줿Message򸵤ˤơSay & Tellå
    //    ܤǽŪSay & Tellޥɤȯư롣
    // ƼParserιꥹȤκ
    //    senseInfoParser.clearRenewObjectsID();
    //    hearInfoParser.clearRenewObjectsID();
    // ֤ͤκ
    //    Senseˤ󹹿Ȥ̤Υ֥ȹäˡ
    //    int[] returnData ֤Ѥξ󤬳ǼƤǤϡ
    //    Ǻ줿 returnData ɬפղþդơ(ղþ
    //    ʤϤΤޤ)֤ͤȤ֤Ƥ롣ʤnull

    // Senseβ
    senseInfoParser.parseSenseInfo(msg_header,msg_data);

    // ФȳǼ
    time = objectManager.getTime();

    // MessageManager_newλǡ
    messageManager_new.updateNowTime(time);

    // ϤSenseΤ, 줿֥Ȥξ
    // senseInfoParser.getRenewObjectsID()ѤФ, ɬפʤΤΤ
    // AA_SENSE_* åѤѴ, MessageSetɲá
    // Ʊ AA_JUST_FIRE å
    int[] returnData = null; // AgentViewer Senseǡ
    int[] sendSenseMsgData = null; // AA_SENSE_* ѥåǡ
    Vector updateIDset = senseInfoParser.getRenewObjectsID();
    removeOverlapID(updateIDset); // IDʣƤΤ
    if(updateIDset != null){
      if(updateIDset.size() > 0){
	Iterator it = updateIDset.iterator();
	while(it.hasNext()){
	  int upID = ((Integer)it.next()).intValue();
	  // ʪλν(ޤǤޤäɤ)
	  if(objectManager.hasBuildingObject(upID)){
	    Building b = objectManager.getBuildingObject(upID);
	    if(b.getFieryness() == 1){
	      int[] tmpData = {ServerSetting.TYPE_BUILDING,upID,
			       ObjectProperty.PROPERTY_FIERYNESS,
			       b.getFieryness(),0,0};
	      // sendSenseMsgDatatmpDataɲ
	      sendSenseMsgData = mergeSenseData(sendSenseMsgData,tmpData);
	      if(b.getIgnitionTime() == time){ // вФ?(ԴγФΤ)
		Message mes = messageManager_new.makeJustFireMessage(upID);
		if(mes != null){
		  messageManager_new.storeTellMessage(mes,1); // 1Ŭ
		}
	      }
	    }
	  }
	  else{ // ¾
	    // ⤷ʤ
	  }
	}
      }
    }
    if(sendSenseMsgData != null){
      Message mes = messageManager_new.makeSenseMessage(sendSenseMsgData);
      if(mes != null){
	messageManager_new.storeTellMessage(mes,1); // 1Ŭ
      }
    }

    // Tell ޥȯư
    // ɬפʥǡפʥǡMessageʬơפʤΤϺ
    Vector tellMsgSet1 = messageManager_new.getTellMessageSet(1);
    Vector tellMsgSet2 = messageManager_new.getTellMessageSet(2);
    int tmpMsgSet1Size = messageManager_new.getTellMessageSetSize(1);
    int tmpMsgSet2Size = messageManager_new.getTellMessageSetSize(2);
    int sendNumPlan = 2; // 򵭲
    // μ򤬳ƥ󥿡ȸͭˤʤ롣
    uniqueDecidingForMessageSelect(tellMsgSet1,tellMsgSet2);

    // ̤Υå
    // ĤΥååȤפ Parameter.TELL_MAX_BYTE ̤ʤ
    if((tmpMsgSet1Size + tmpMsgSet2Size) < Parameter.TELL_MAX_BYTE){
      if(tellMsgSet2 != null){
	if(tellMsgSet2.size() > 0){
	  Iterator it = tellMsgSet2.iterator();
	  while(it.hasNext()){
	    Message mes = (Message)it.next();
	    tellMsgSet1.add(mes);
	  }
	  tellMsgSet2.clear();
	}
      }
      sendNumPlan = 1;
    }

    // ̤Ĵ(١ַסʲϰĤβ򼨤)
    int order1 = MessageConverter.SORT_BY_MESSAGE_SIZE_LARGER;
    int order2 = MessageConverter.SORT_BY_TIME;
    int order3 = MessageConverter.SORT_BY_IMPORTANCE;
    MessageConverter mc = new MessageConverter();
    mc.sortMessage(tellMsgSet1,order1); // 饽Ȥ sortMessage()
    mc.sortMessage(tellMsgSet1,order2); // Ǥϰʤ,
    mc.sortMessage(tellMsgSet1,order3); // ʬƥȤ򤹤
    mc.sortMessage(tellMsgSet2,order1); // 饽Ȥ sortMessage()
    mc.sortMessage(tellMsgSet2,order2); // Ǥϰʤ,
    mc.sortMessage(tellMsgSet2,order3); // ʬƥȤ򤹤
    int aboutTELLMAX = Parameter.TELL_MAX_BYTE - 10;
    if((tmpMsgSet1Size > aboutTELLMAX) &&
       (tmpMsgSet2Size < aboutTELLMAX)){
      // Ŭᥤ롼
      sizeOptimize(tellMsgSet1,tellMsgSet2,tmpMsgSet2Size);
    }
    else if((tmpMsgSet2Size > aboutTELLMAX) &&
	    (tmpMsgSet1Size < aboutTELLMAX)){
      // Ŭᥤ롼
      sizeOptimize(tellMsgSet2,tellMsgSet1,tmpMsgSet1Size);
    }

    // Tell ޥȯư
    int order = MessageConverter.NO_SORT;
    int sendNum = messageManager_new.sendAllTellMessage(order);
    if(sendNum != sendNumPlan){
      // ToDo:¾˲ޤϤ
      //System.err.println("Ǥʤäߤ,Ȥꤢ̵롣");
      messageManager_new.clearAllTellMessageSet();
    }

    // ƼParserιꥹȤκ
    senseInfoParser.clearRenewObjectsID();
    hearInfoParser.clearRenewObjectsID();

    // ֤ͤκ(äˤʾ뤳ȤʤΤ, äΤ򤽤Τޤ֤)
    return returnData;
  }

  /********************************************************************/
  /** HEAR (Agent to Agentå) Ф,
   * 󥿡ȤΤդޤ(ȯʬ)򵭽Ҥ롣<BR>
   * ƥͭεư,̤ݥ᥽åɤǼ¸롣<BR>
   * 㤨, <i>protected abstract void uniqueHearing()</i> Ȥ<BR><BR>
   * @param msg_header kernelƤåإå
   * @param msg_data kernelƤåǡ
   * @return Hearη̹Τä֥ȤSenseǡ
   *         AgentViewer饹ǻȤ롣
   **/
  public int[] receiveHear(int[] msg_header, byte[] msg_data){
    // ˤϥ󥿡ȶ̤ʬϤ򵭽Ҥ롣

    int senderID = msg_header[3]; // Ԥ
    int[] returnData = null; // AgentViewer Senseǡ(֤)

    // åΥॹפ򸫤
    if(prevMsgTime != time){
      rcvMsgCount = 0; 
    }
    if(rcvMsgCount < Parameter.MAX_CENTER_RCVMSG_NUM && senderID != id){
      // ٤åɤ(ºݤȽϳƥȤ̤˹Ԥʤ)
      if(shouldReadMessage(msg_header)){

	// åȻϿ      
	prevMsgTime = time;
	rcvMsgCount++;

	// ˼åϤMessageǡƤ
	// ºݤˤ, ߽⤫ƤMessageProtocol˽äå
	// Ǥʤ(㤨л̱褿å)rcvMsgSet϶Ǥ롣
	returnData = hearInfoParser.parseHearInfo(msg_header,msg_data,time);
	Vector rcvMsgSet = hearInfoParser.getJustNowMessageSet();
	io.writeHearLog(msg_header[0],senderID,rcvMsgSet);

	// .Ԥ߽⤷ϻλν(åϤ)
	if(objectManager.hasRescueManObject(senderID) ||
	   objectManager.hasRescueCenterObject(senderID)){
	  // MessageProtocol˽äåǤʤ,
	  // ʲΣĤifʸΤɤ餫Ƥ롣
	  if(rcvMsgSet != null){
	    if(rcvMsgSet.size() != 0){
	      Iterator it = rcvMsgSet.iterator();
	      while(it.hasNext()){
		Message mes = (Message)it.next();

		// 1-1.󥿡ȶʬε
		// åHearSayä
		if(msg_header[0] == KA_HEAR_SAY){
		  // ⤬, ⤷ϵ崰λǤΤä
		  // ξϸϤǤᤤˤϤ
		  if(mes.getCommand() == AA_REFILL ||
		     mes.getCommand() == AA_REFILL_FIN){
		    int dataTime = mes.getDataTime();
		    int[] mesData = mes.getMessage();
		    int fbID = mesData[0];
		    // ϤǤᤤID
		    int nearestRefugeID = objectManager.getNearestRefugeID(id);
		    int[] throwSenseHeader = {msg_header[0],-1,-1,dataTime};
		    int[] throwSenseData = {ServerSetting.TYPE_FIREBRIGADE,
					    fbID,6,nearestRefugeID,7,0,0,0};
		    Vector vec = new Vector();
		    senseInfoParser.parseSenseInfo(throwSenseHeader,
						   throwSenseData,vec);
		    if(vec.size() == 1){
		      // returnDatathrowSenseDataɲ
		      returnData = mergeSenseData(returnData,throwSenseData);
		    }
		  }
		  // ߵ⤬̱˲ȤΤä
		  // εߵȻ̱ϸϤǤᤤˤϤ
		  else if(mes.getCommand() == AA_UNLOAD){
		    int dataTime = mes.getDataTime();
		    int[] mesData = mes.getMessage();
		    int atID = mesData[0];
		    int cvID = mesData[1];
		    // ϤǤᤤID
		    int nearestRefugeID = objectManager.getNearestRefugeID(id);
		    int[] throwSenseHeader = {msg_header[0],-1,-1,dataTime};
		    int[] throwSenseDataAT = {ServerSetting.TYPE_AMBULANCETEAM,
					      atID,6,nearestRefugeID,7,0,0,0};
		    int[] throwSenseDataCV = {ServerSetting.TYPE_CIVILIAN,
					      cvID,6,nearestRefugeID,7,0,0,0};
		    int[] throwSenseDataALL = mergeSenseData(throwSenseDataAT,
							     throwSenseDataCV);
		    Vector vec = new Vector();
		    senseInfoParser.parseSenseInfo(throwSenseHeader,
						   throwSenseDataALL,vec);
		    if(vec.size() == 2){
		      // returnDatathrowSenseDataɲ
		      returnData = mergeSenseData(returnData,
						  throwSenseDataALL);
		    }
		    else if(vec.size() == 1){
		      // returnDatathrowSenseDataΤΤäID
		      // ξΤߤɲ
		      int manID = ((Integer)vec.get(0)).intValue();
		      // ATξΤ߹줿
		      if(objectManager.hasAmbulanceTeamObject(manID)){
			returnData = mergeSenseData(returnData,
						    throwSenseDataAT);
		      }
		      // CVξΤ߹줿
		      else if(!objectManager.hasRescueManObject(manID) &&
			      objectManager.hasCivilianObject(manID)){
			returnData = mergeSenseData(returnData,
						    throwSenseDataCV);
		      }
		      // ,뤳ȤϤꤨʤ
		      else{
			//System.err.print("ꤨʤˤ衪");
			//System.err.print("(ʸ:ߵ⤬̱");
			//System.err.print("ȤΤä):");
			//System.err.println("[receiveHear()]");
		      }
		    }
		  }
		}

		// 1-2.󥿡ȳƸĤε
		int[] tmpRetData = uniqueHearingForRescueAgent(msg_header[0],
							       senderID,mes);
		// returnDatatmpRetDataɲ;
		returnData = mergeSenseData(returnData,tmpRetData);
	      }
	    }
	  }
	}

	// .嵭ʳԤ̱λν(ưAgentʤΤ)
	else if(objectManager.hasCivilianObject(senderID)){
	  // 2-1.󥿡ȶʬε
	  int length = (((int)msg_data[0] & 0xFF) << 24) | 
	               (((int)msg_data[1] & 0xFF) << 16) | 
	               (((int)msg_data[2] & 0xFF) <<  8) | 
	                ((int)msg_data[3] & 0xFF); // 4Bytes
	  String cvMsg = new String(msg_data,4,length);
	  if(cvMsg.equals("help_me")){
	    Message mes = messageManager_new.makeHearBuriedCivilianMessage(senderID);
	    // ¾λ(ߵ޽λϵߵˤΤ餻Ƥ) 1Ŭ
	    if(mes != null){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	  }
	  else if(cvMsg.equals("What_a_relief!")){
	    int dataTime = time; // ߻
	    // ϤǤᤤID
	    int nearestRefugeID = objectManager.getNearestRefugeID(id);
	    int[] throwSenseHeader = {KA_HEAR_SAY,-1,-1,dataTime};
	    int[] throwSenseData = {232,senderID,6,nearestRefugeID,7,0,0,0};
	    Vector vec = new Vector();
	    senseInfoParser.parseSenseInfo(throwSenseHeader,
					   throwSenseData,vec);
	    if(vec.size() == 1){
	      // returnDatathrowSenseDataɲ
	      returnData = mergeSenseData(returnData,throwSenseData);
	    }
	    Message mes = messageManager_new.makeSenseMessage(throwSenseData);
	    // ¾λ(ߵ޽λϵߵˤΤ餻Ƥ) 1Ŭ
	    if(mes != null){
	      messageManager_new.storeTellMessage(mes,1);
	    }
	  }
	  else{ // ̱Τ¾ȯ
	    // ǤǤʤȯʤΤǲ⤷ʤ
	  }

	  // 2-2.󥿡ȳƸĤε
	  int[] tmpReturnData = uniqueHearingForCivilian(msg_header[0],
							 senderID,cvMsg);
	  // returnDatatmpReturnDataɲ
	  returnData = mergeSenseData(returnData,tmpReturnData);
	}

        // .ϵĤΤ, Υåʬʤ
	else{
	  // äƲ⤷ʤ
	}
      }
    }
    return returnData;
  }

  /********************************************************************/
}
