/*
  # Controller/MovingObjectController.java
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  # $Id: MovingObjectController.java,v 1.4 2004/04/30 14:08:30 K.Honji Exp $
  */
package Controller;

import java.io.*;
import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueObject.*;
import rescueAgent.RescueLib.ServerSetting;
import rescueAgent.AreaMap.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.IO.*;

/**
 * Rescueߥ졼ǰưΥȤ򥳥ȥ뤹륯饹<BR>
 * MovingObjectController:
 * Controll Rescue Moving Agent in Rescue simulation
 **/
public abstract class MovingObjectController extends Controller{

  /** ʬȤΥ饹Ǽѿ <BR>
   * ºݤ˳ControllerǤ,ʬȤObjectClass˥㥹ȤƻȤȤˤʤ롣
   * (㤨, FB֤餦Ȥ self.getPosition() ,
   * ̤餦Ȥ ((FireBrigade)self).getWaterQuantity() 
   * ȥ㥹ȤƻȤȤˤʤ롣) <BR><BR>
   **/
  protected Civilian self;
  /** ľˤ(Υ֥ID) **/
  protected int prevPos;
  /** ߤ(Υ֥ID) **/
  protected int nowPos;
  /** оɸʪIDѿ **/
  protected int target = -1;


  /** 2 ܤƱ Road ä[checkConfusion()᥽åѿ] **/
  private int sameRouteCount = 0;
  /** ڤƤƻΥꥹ(־) **/
  protected Vector confusionRoad = new Vector();
  /** ڤƤͽ¬ƻ **/
  protected int tmp_confusionRoad = -1;
  /** ưƤʤƥå׿ **/
  protected int cantMoveCount = 0;
  /** ɸ(refuge)ƤΥƥå׿ **/
  protected int dontArriveRefugeCount = 0;

  // ư(decideCommand)ѳƼե饰(ף)
  /** ʬޤäƤ뤫ɤ<BR>
   * true...ޤäƤ, false...ޤäƤʤ <BR><BR>
   **/
  protected boolean isBuriedMyself;
  /** ʬϩΩƤ뤫ɤ<BR>
   * true...ΩƤ, false...ΩƤʤ <BR><BR>
   **/
  protected boolean isHaltedMyself;
  /** Ȥβζ礬狼ɤ<BR>
   * true...Ǥ, false...Ǥʤ <BR><BR>
   **/
  protected boolean isDamageSeriously;
  /** 볦ϰޤäƤ̱ or ʬʳε߽⤬뤫ɤ<BR>
   * true..., false...ʤ <BR><BR>
   **/
  protected boolean discoverBuriedCVorRM;
  /** ưλɤ<BR>
   * true...λ, false...λƤʤ <BR><BR>
   **/
  protected boolean alreadyActioned;
  /** Τιư꤬褿ɤ<BR>
   * true...Ǥ, false...ǤƤʤ <BR><BR>
   **/
  protected boolean collectInformation;


  // ȯʬ(receiveHear)ѳƼѿ(ף)
  /** Ʊ˻̱HearSayʹɤ **/
  protected boolean hearSayMsgByCivilian = false;
  /** ƱʹƱΰưAgentHearSayåο򵭲 **/
  protected int rcvHearSayMsgByRescueManCount = 0;
  /** ƱʹHearTellåο򵭲 **/
  protected int rcvHearTellMsgCount = 0;
  /** ƱľޤǤ˼HearSayˤMessage
   * receiveHear()ǻȤѿ
   **/
  protected int rcvHearSayMsgNum = 0;
  /** ƱľޤǤ˼HearTellˤMessage
   * receiveHear()ǻȤѿ
   **/
  protected int rcvHearTellMsgNum = 0;

  /********************************************************************/
  // 󥹥ȥ饯

  public MovingObjectController(int id, IO io, int[] msgH, int[] msgD){
    super(id,io,msgH,msgD);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  // ֥ȥ饯ȥ饹
  /** ưΥȸͭιưԤʤ<BR>
   * ϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected abstract int[] uniqueDeciding(int[] msg_header, int[] msg_data);

  /** ƸİưΥȤˤȤä,٤åɤȽꤹ롣
   * <BR> ȽϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param msg_header åإå
   * @return åtrue, Ǥʤfalse
   **/
  protected abstract boolean shouldReadMessage(int[] msg_header);

  /** ߽, ⤷ϻ꤫åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * ϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message Messageå
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected abstract int[] uniqueHearingForRescueAgent(int ka_command,
						       int senderID,
						       Message message);

  /** ̱åϤ,
   * ƸİưΥȸͭΥåԤʤ<BR>
   * ϳƥȤǰ㤦Τ, ǤabstractƤ
   * <BR><BR>
   * @param ka_command KA_HEAR* ޥ̾(KA_HEAR_SAY or KA_HEAR_TELL)
   * @param senderID åľܤ
   * @param message ʸ󷿥å
   * @return åˤꥪ֥ȤιԤʤ줿,
   *         饪֥ȤSenseǡ֤롣ʤänull
   **/
  protected abstract int[] uniqueHearingForCivilian(int ka_command,
						    int senderID,
						    String message);

  // ֥ȥ饯ȥ饹 ޤ
  /********************************************************************/
  /**
   * βϤȾγǼ(SuperClassʬ)
   * <BR><BR>
   * @param msg_header kernelƤåΥإåʬ
   * @param msg_data kernelƤåΥǡʬ
   **/
  protected void init(int[] msg_header, int[] msg_data){
    // ǡ١ȥ롼ƥ󥰥ơ֥ιۤ򤹤(γˤȤʤ)
    // objectManager.parseSenseInfo(msg_header, msg_data);
    senseInfoParser.parseSenseInfo(msg_header, msg_data);
    objectManager.makeRouteTable();

    // å
    // (1)ޤϽưAgentοǽʥå򥻥å
    String type = ServerSetting.getAgentType(msg_data[0],true); // 2ʸString
    //System.out.print("߽("+type+")ǤMessage Send...");
    //System.out.print(Parameter.MAX_AGENT_SNDMSG_NUM +", Recieve...");
    //System.out.println(Parameter.MAX_AGENT_RCVMSG_NUM);
    // (2)MessageManagerι
    ObjectDatabase objectDB = objectManager.getObjectDatabase();    
    messageManager_new = new MessageManager_NEW(1,2,id,objectDB,io);

    // Debug Use
    // objectManager.printRouteHash();
  }

  /********************************************************************/
  /** ʬν°륻󥿡(FBʤFS)¸ߤ뤫ɤȽꤹ롣<BR><BR>
   * @return true¸ߤ,false¸ߤʤ
   **/
  public boolean hasMyCenterObject(){
    boolean existCenter = false;
    if(objectManager.hasFireBrigadeObject(id)){
      if(objectManager.getFireStationObjectNum() != 0){
      	existCenter = true;
      }
      else{
	existCenter = false;
      }
    }
    else if(objectManager.hasAmbulanceTeamObject(id)){
      if(objectManager.getAmbulanceCenterObjectNum() != 0){
	existCenter = true;
      }
      else{
	existCenter = false;
      }
    }
    else if(objectManager.hasPoliceForceObject(id)){
      if(objectManager.getPoliceOfficeObjectNum() != 0){
	existCenter = true;
      }
      else{
	existCenter = false;
      }
    // ToDo:FBATPFʤȤ(=CV)falseϤ?)
    }
    return existCenter;
  }

  /********************************************************************/
  /** SENSE (Kernel to Agentå) Ф,
   * ưΥȤΤդޤ(ư)򵭽Ҥ롣<BR>
   * ƥͭεư,̤ݥ᥽åɤǼ¸롣<BR>
   * 㤨, <i>protected abstract void uniqueDeciding()</i> Ȥ<BR><BR>
   * @param msg_header kernelƤåإå
   * @param msg_data kernelƤåǡ
   * @return ưη̹Τä֥ȤSenseǡ
   *         AgentViewer饹ǻȤ롣ʤnull
   **/
  public int[] decideCommand(int[] msg_header, int[] msg_data){
    // ˤϰưΥȶ̤ιư򵭽Ҥ롣
    //
    // ʾι
    //   1-1.Senseβ senseInfoParser.parseSenseInfo(msg_header,
    //                                                        msg_data);
    //   1-2.ФȳǼ time = objectManager.getTime();
    //   1-3.MessageManager_newλǡ
    //       messageManager_new.updateNowTime(time);
    //   1-4.ȤΥ֥Ȥι, ϤΥ֥Ȥμ
    //       self = (Civilian)senseInfoParser.getSelfInfo();
    //       RescueObject rsob = objectManager.getObject(self.getPosition());
    //   1-5-1.ϤSenseΤ줿֥Ȥξ
    //         senseInfoParser.getRenewObjectsID()ѤФSense
    //         åѴưʲΥ᥽åɤ¹ԡ
    //         Message msg = messageManager_new.makeSenseMessage(senseData);
    //         messageManager_new.storeSayMessage(msg,0);
    //         messageManager_new.storeTellMessage(msg,0);
    //   1-5-2. 嵭ƱAA_BLOCKADE,AA_JUST_FIRE, AA_BURIED_CIVILIAN_*
    //          γƼå(senseInfoParser.getRenewObjectsID()
    //          Ѥ)
    //      AA_BURIED_CIVILIAN_* η̤ϼιư discoverBuriedCVorRM
    //        ե饰ˤƶ)
    //   1-6.߰֡ľ֤ι prevPos = nowPos;
    //                                nowPos = self.getPosition();
    //   1-7.Ƥʤνڤå
    //    1-7-1.˽ڤȽƻξ󤬸Ťʤå
    //    1-7-2.ߤνھΥå
    //   1-8.롼Ⱦι int[] nextRoute =
    //                               objectManager.recycleRoute(route,nowPos); 
    //                          if(nextRoute != null){
    //                            route = nextRoute;
    //                          }
    // ư
    //   2-1.ʬޤäƤ뤫ɤ(ޤäƤϵ߽
    //       [Ƶ߽θ̥᥽åɤǼ]ޤäƤե饰ON)
    //   2-2.ʬϩΩƤ(ưʤʤäƤ)ɤ
    //       (ΩƤϷ[Ƶ߽θ̥᥽åɤǼ]
    //       ΩƤե饰ON)
    //   2-3.Ȥβζ礬狼ɤĤޤꡢDamageʾ
    //       ɤ(ʾäض۵ްư
    //       Ͷ۵ե饰ON)
    //   2-4.볦ϰޤäƤ̱orʬʳε߽⤬뤫ɤ
    //       (ϵ߽[Ƶ߽θ̥᥽åɤǼ]
    //       ޤäƤͤ򸫤Ĥե饰ON)
    //       ʬ1-5-2.ǼºݤȽ꤬ԤʤΤ,Ǥϲ⤷ʤ
    //   2-5.Ƶ߽θ̹ư᥽åɤȯưǤ2-12-4줿
    //       ե饰[Globalѿ]򸵤˳ƸĹưꤹ롣(㤨С
    //       ̾ʤ2-3Υե饰ONˤʤäƤ¾ιưȤʤΤǡ
    //       ⤷ʤǤν򽪤)ơΥ᥽åǲ餫
    //       ưȤäˤϡưλե饰[Globalѿ]ONˤʤ롣
    //       ֤ͤȤAgentViewer֤äƤΤǤγǼ⤹롣
    //   2-6.۵ե饰(2-3)ȹưλե饰(2-5)OFF(=false)λ
    //       פʤɤǳưʤä뤤Ƥγưλ(㤨С
    //       ˤȤäơкҤòФȤ֤Ƥγư
    //       λȤ̣)ǤΤǡ¾ε߽Τ
    //       [˾Τιưꡣ椨(2-1)(2-2)Υե饰
    //       ONʤдŪˤǤⲿ⤹뤳Ȥʤ]Ԥʤ
    //       ¸Ǥϡե饰ONˤʤ롣
    //   2-7.ե饰(2-6)OFFäϡǥ०
    //       ȯư롣
    // Say & Tell ޥɤȯư
    //    ޤǤ˺줿Message򸵤ˤơSay & Tellå
    //    ܤǽŪSay & Tellޥɤȯư롣
    // ƼParserιꥹȤκ
    //    senseInfoParser.clearRenewObjectsID();
    //    hearInfoParser.clearRenewObjectsID();
    // ֤ͤκ
    //    Senseˤ󹹿Ȥ̤Υ֥ȹäˡ
    //    int[] returnData ֤Ѥξ󤬳ǼƤǤϡ
    //    Ǻ줿 returnData ɬפղþդơ(ղþ
    //    ʤϤΤޤ)֤ͤȤ֤Ƥ롣ʤnull


    // . ʾι
    // 1-0.ưǻȤե饰discoverBuriedCVorRM򤳤ǥꥻåȡ
    //     ȤΤ, 1-5.ǤΥե饰åȤ뤿ᡣ
    discoverBuriedCVorRM = false; // 볦ϰޤäƤ̱
                                  // or ʬʳε߽⤬뤫ɤ

    // 1-1.Senseβ
    senseInfoParser.parseSenseInfo(msg_header,msg_data);

    // 1-2.ФȳǼ
    time = objectManager.getTime();

    // 1-3.MessageManager_newλǡ
    messageManager_new.updateNowTime(time);

    // 1-4.ȤΥ֥Ȥι, ϤΥ֥Ȥμ
    self = (Civilian)senseInfoParser.getSelfInfo();
    RescueObject rsob = objectManager.getObject(self.getPosition());

    // 1-5.ϤSenseΤ줿֥Ȥξ
    // senseInfoParser.getRenewObjectsID()ѤФSense
    // åѴɬפʤMessage
    // Ʊ AA_JUST_FIRE, AA_BLOCKADE_*, AA_BURIED_CIVILIAN_*
    // γƼå(AA_BURIED_CIVILIAN_* η̤ϼιư
    // discoverBuriedCVorRM ե饰ˤƶ)
    int[] returnData = null; // AgentViewer Senseǡ
    int[] sendSenseMsgData = null; // AA_SENSE_* ѥåǡ
    Vector updateIDset = senseInfoParser.getRenewObjectsID();
    removeOverlapID(updateIDset); // IDʣƤΤ
    if(updateIDset != null){
      if(updateIDset.size() > 0){
	Iterator it = updateIDset.iterator();
	while(it.hasNext()){
	  int upID = ((Integer)it.next()).intValue();
	  // ʪλν(ޤǤޤäɤ)
	  if(objectManager.hasBuildingObject(upID)){
	    Building b = objectManager.getBuildingObject(upID);
	    if(b.getFieryness() == 1){
	      int[] tmpData = {ServerSetting.TYPE_BUILDING,upID,
			       ObjectProperty.PROPERTY_FIERYNESS,
			       b.getFieryness(),0,0};
	      // sendSenseMsgDatatmpDataɲ
	      sendSenseMsgData = mergeSenseData(sendSenseMsgData,tmpData);
	      if(b.getIgnitionTime() == time){ // вФ?(ԴγФΤ)
		// AA_JUST_FIRE_* åι
		Message mes = messageManager_new.makeJustFireMessage(upID);
		if(mes != null){
		  // ʬν°륻󥿡, Tell
		  if(hasMyCenterObject()){
		    messageManager_new.storeTellMessage(mes,1);
		  }
		  // Sayɬ
		  messageManager_new.storeSayMessage(mes,1);
		}
	      }
	    }
	  }
	  // ƻϩΤȤν
	  else if(objectManager.hasRoadObject(upID)){
	    Road r = objectManager.getRoadObject(upID);
	    if(r.getBlock() > 0){ // ĺɤ
	      // AA_BLOCKADE_* åι
	      Message mes = messageManager_new.makeBlockadeMessage(upID);
	      if(mes != null){
		// ʬν°륻󥿡, Tell
		if(hasMyCenterObject()){
		  messageManager_new.storeTellMessage(mes,1);
		}
		// Sayɬ
		messageManager_new.storeSayMessage(mes,1);
	      }
	    }
	  }
	  // ߽ޤϻ̱ΤȤν(ߤζ̤Ϥʤ)
	  else if(objectManager.hasCivilianObject(upID)){
	    Civilian cv = objectManager.getCivilianObject(upID);
	    int cvPosition = cv.getPosition(); // Position
	    int cvPosEX = (int)(cv.getPositionExtra()*1000); // PosEX
	    int cvHP = cv.getHP(); // HP
	    int cvDamage = cv.getDamage(); // Damage
	    int cvBuriedness = cv.getBuriedness(); // Buriedness
	    // AA_INJURED_CIVILIAN_* ʤץȥ뤬ʤΤsense
	    // :̱,ĥ᡼50ʾ,ޤäƤʤ,
	    //      Ƥ,ļʬǤʤ
	    //  ʬޤäƤνϹư˹ԤʤΤǡ
	    //  TODO:ifʸȺ!
	    if(!objectManager.hasRescueManObject(upID) && cvDamage > 50
	       && cvBuriedness == 0 && cvHP > 0 && upID != id){ // 50Ŭ
	      int[] tmpData = {ServerSetting.TYPE_CIVILIAN,upID,
			       ObjectProperty.PROPERTY_POSITION,cvPosition,
			       ObjectProperty.PROPERTY_POSITION_EXTRA,cvPosEX,
			       ObjectProperty.PROPERTY_DAMAGE,cvDamage,0,0};
	      // sendSenseMsgDatatmpDataɲ
	      sendSenseMsgData = mergeSenseData(sendSenseMsgData,tmpData);
	    }
	    // ޤäƤ, Ƥ(ʬʳ)
	    if(cvBuriedness > 0 && cvHP > 0 && upID != id){
	      discoverBuriedCVorRM = true; // ե饰ON (ưǻȤ)
	      io.writeMiscLog("Discover Buried Civilian or RescueMan!!"
			      +" BuriedID:"+upID+", Pos:"+cvPosition+", HP:"
			      +cvHP+", Damage:"+cvDamage+", Buriedness:"
			      +cvBuriedness);
	      // AA_BURIED_CIVILIAN_* åι
	      Message mes = messageManager_new.makeBuriedCivilianMessage
		                                          (upID,cvPosition);
	      if(mes != null){
		// ʬν°륻󥿡, Tell
		if(hasMyCenterObject()){
		  messageManager_new.storeTellMessage(mes,1);
		}
		// Sayɬ
		messageManager_new.storeSayMessage(mes,1);
	      }
	    }
	  }
	  else{ // ¾(ΤȤNode?)
	    // ⤷ʤ
	  }
	}
      }
    }

    // 1-6.߰֡ľ֤ι
    prevPos = nowPos;
    nowPos = self.getPosition();
    io.writeMiscLog("nowPos(ID):"+nowPos+", prevPos(ID):"+prevPos);
    io.writeSelfLog(self.getPosition(),self.getPositionExtra());

    // 1-7.Ƥʤνڤå
    // 1-7-1.˽ڤȽƻξ󤬸Ťʤå
    // ΤˤϾ󤬣ƥåפΤΤ򤹤
    if(confusionRoad != null){
      // confusionRoad鸡ΤϡݤĤ
      for(int i=confusionRoad.size()-1; i>=0; i--){
	// Integerλ־intѴsenseTime˳Ǽ
	int senseTime = ((int[])confusionRoad.get(i))[1];
	if(time - senseTime > 15){ // 15stepŤϺ
	  int[] info = (int[])confusionRoad.remove(i);
	  io.writeMiscLog("ڥꥹȤ:RoadID="+info[0]
			  +",SenseTime="+info[1]);
	}
      }
    }
    // 1-7-2.ߤνھΥå
    if (checkConfusion(rsob)){
      // ǽڤ
      int[] info = new int[2];
      info[0] = tmp_confusionRoad;
      info[1] = time;
      confusionRoad.add(info);
      // AA_CONGESTED_* åι
      Message mes = messageManager_new.makeCongestedMessage(info[0]);
      if(mes != null){
	// ʬν°륻󥿡, Tell
	if(hasMyCenterObject()){
	  messageManager_new.storeTellMessage(mes,1);
	}
	// Sayɬ
	messageManager_new.storeSayMessage(mes,1);
      }
      route = null; // confusionRoadޤ᤿routeκͭˤ뤿
      // todo confusionRoadˤʤȡե졼ˤƵո
      io.writeMiscLog("ǽڤƤ RoadID:"+info[0]);
      //System.out.println("ǽڤƤ  RoadID:"+info[0]);
    }

    // 1-8.롼Ⱦι
    int[] nextRoute = objectManager.recycleRoute(route,nowPos); 
    if(nextRoute != null){
      route = nextRoute;
    }


    // . ư
    // 2-0.Ƽե饰Υꥻå(discoverBuriedCVorRMϴ˥ꥻåȢͥåȺ)
    isBuriedMyself = false;       // ʬޤäƤ뤫ɤ
    isHaltedMyself = false;       // ʬϩΩƤ뤫ɤ
    isDamageSeriously = false;    // Ȥβζ礬狼ɤ
    alreadyActioned = false;      // ưλɤ
    collectInformation = false;   // Τιư꤬褿ɤ

    // 2-1.ʬޤäƤ뤫ɤ(ޤäƤϵ߽
    //     ޤäƤե饰ON)
    isBuriedMyself = isBuriedMyself();
    if(isBuriedMyself){
      io.writeMiscLog("Buried!! MyID:"+id+", MyPos:"+nowPos+", MyHP:"
		      +self.getHP()+", MyDamage:"+self.getDamage()
		      +", MyBuriedness:"+self.getBuriedness());
    }

    //   2-2.ʬϩΩƤ(ưʤʤäƤ)ɤ
    //       (ΩƤϷ[Ƶ߽θ̥᥽åɤǼ]
    //       ΩƤե饰ON)
    isHaltedMyself = checkHalt(rsob);
    if(isHaltedMyself){
      io.writeMiscLog("Halt!! MyID:"+id+", MyPos:"+nowPos);
    }

    //   2-3.Ȥβζ礬狼ɤĤޤꡢDamageʾ
    //       ɤ(ʾäض۵ްư
    //       Ͷ۵ե饰ON)
    isDamageSeriously = needToCure();
    if(isDamageSeriously){
      io.writeMiscLog("Damage is Serious!! MyID:"+id+", MyPos:"+nowPos
		      +", MyHP:"+self.getHP()+", MyDamage:"+self.getDamage());
      // ĶƤΤ˶۵ްư!!
      //  ˴ˤȤư٤ǤϤʤΤio.rest()ȯư
      if(objectManager.hasRefugeObject(nowPos)){
	io.setPrefixActLog("Curing"); // ܺ٥ޥɤΥå
	io.rest(nowPos);
	io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ"
			+" -> ˤ -> ٷ");
	// AA_REST_* åι
	Message mes = messageManager_new.makeRestMessage();
	if(mes != null){
	  // ʬν°륻󥿡, Tell
	  if(hasMyCenterObject()){
	    messageManager_new.storeTellMessage(mes,1);
	  }
	  // Sayɬ
	  messageManager_new.storeSayMessage(mes,1);
	}
	dontArriveRefugeCount = 0; // ȤΥꥻå
	alreadyActioned = true;
      }
      //  ˤʤȤgoToRefuge()˰ư
      else{
	// goToRefuge()֤ͤio.move()褿ɤ
	alreadyActioned = goToRefuge(); // ֤ͤľalreadyActioned
      }
    }

    //   2-4.볦ϰޤäƤ̱orʬʳε߽⤬뤫ɤ
    //       (ϵ߽[Ƶ߽θ̥᥽åɤǼ]
    //       ޤäƤͤ򸫤Ĥե饰ON)
    //  Ǥϲ⤷ʤ

    //   2-5.Ƶ߽θ̹ư᥽åɤȯưǤ2-12-4줿
    //       ե饰[Globalѿ]򸵤˳ƸĹưꤹ롣(㤨С
    //       ̾ʤ2-3Υե饰ONˤʤäƤ¾ιưȤʤΤǡ
    //       ⤷ʤǤν򽪤)ơΥ᥽åǲ餫
    //       ưȤäˤϡưλե饰[Globalѿ]ONˤʤ롣
    //       ֤ͤȤAgentViewer֤äƤΤǤγǼ⤹롣
    if(isBuriedMyself == false && alreadyActioned == false){
      int[] tmpData = uniqueDeciding(msg_header,msg_data);
      // returnDatatmpDataɲ
      returnData = mergeSenseData(returnData,tmpData);
      alreadyActioned = true; // Ȥꤢ
    }

    //   2-6.۵ե饰(2-3)ȹưλե饰(2-5)OFF(=false)λ
    //       פʤɤǳưʤä뤤Ƥγưλ(㤨С
    //       ˤȤäơкҤòФȤ֤Ƥγư
    //       λȤ̣)ǤΤǡ¾ε߽Τ
    //       [˾Τιưꡣ椨(2-1)(2-2)Υե饰
    //       ONʤдŪˤǤⲿ⤹뤳Ȥʤ]Ԥʤ
    //       ¸Ǥϡե饰ONˤʤ롣
    //  ̤

    //   2-7.ե饰(2-6)OFFäϡǥ०
    //       ȯư롣
    if(isBuriedMyself == false && alreadyActioned == false && collectInformation == false){
      randomWalk();
    }


    // . Say & Tell ޥɤȯư
    //    ޤǤ˺줿Message򸵤ˤơSay & Tellå
    //    ܤǽŪSay & Tellޥɤȯư롣
    //   3-0.Say & Tell ޥȯư(ºݤ˽[=Ŭ]ΤTellΤ)
    Vector tellMsgSet1 = messageManager_new.getTellMessageSet(1);
    Vector tellMsgSet2 = messageManager_new.getTellMessageSet(2);
    int tmpMsgSet1Size = messageManager_new.getTellMessageSetSize(1);
    int tmpMsgSet2Size = messageManager_new.getTellMessageSetSize(2);
    int sendNumPlan = 2; // 򵭲
    int order1 = MessageConverter.SORT_BY_MESSAGE_SIZE_LARGER;
    int order2 = MessageConverter.SORT_BY_TIME;
    int order3 = MessageConverter.SORT_BY_IMPORTANCE;
    MessageConverter mc = new MessageConverter();
    mc.sortMessage(tellMsgSet1,order1); // 饽Ȥ sortMessage()
    mc.sortMessage(tellMsgSet1,order2); // Ǥϰʤ,
    mc.sortMessage(tellMsgSet1,order3); // ʬƥȤ򤹤
    mc.sortMessage(tellMsgSet2,order1); // 饽Ȥ sortMessage()
    mc.sortMessage(tellMsgSet2,order2); // Ǥϰʤ,
    mc.sortMessage(tellMsgSet2,order3); // ʬƥȤ򤹤
    int aboutTELLMAX = Parameter.TELL_MAX_BYTE - 10;
    if((tmpMsgSet1Size > aboutTELLMAX) &&
       (tmpMsgSet2Size < aboutTELLMAX)){
      // Ŭᥤ롼
      sizeOptimize(tellMsgSet1,tellMsgSet2,tmpMsgSet2Size);
    }
    else if((tmpMsgSet2Size > aboutTELLMAX) &&
	    (tmpMsgSet1Size < aboutTELLMAX)){
      // Ŭᥤ롼
      sizeOptimize(tellMsgSet2,tellMsgSet1,tmpMsgSet1Size);
    }

    //   3-1.Say & Tell ޥɤȯư
    int orderSay = MessageConverter.SORT_BY_IMPORTANCE_AND_TIME_AND_SIZE_LARGER;
    int orderTell = MessageConverter.NO_SORT;
    int sendSayNum = messageManager_new.sendAllSayMessage(orderSay);
    int sendTellNum = messageManager_new.sendAllTellMessage(orderTell);
    io.writeMiscLog("Say & Tellåȯư!! [λ:Say..."
		    +sendSayNum+",Tell..."+sendTellNum+"]");
    messageManager_new.clearAllSayMessageSet();
    messageManager_new.clearAllTellMessageSet();


    // . ƼParserιꥹȤκ
    senseInfoParser.clearRenewObjectsID();
    hearInfoParser.clearRenewObjectsID();


    // . ֤ͤκ
    //    Senseˤ󹹿Ȥ̤Υ֥ȹäˡ
    //    int[] returnData ֤Ѥξ󤬳ǼƤǤϡ
    //    Ǻ줿 returnData ɬפղþդơ(ղþ
    //    ʤϤΤޤ)֤ͤȤ֤Ƥ롣ʤnull
    //  äˤʾ뤳ȤʤΤ, äΤ򤽤Τޤ֤
    return returnData;
  }

  /********************************************************************/
  /** SENSE (Kernel to Agentå) Ф,
   * ưΥȤΤդޤ(ư)򵭽Ҥ롣<BR>
   * ƥͭεư,̤ݥ᥽åɤǼ¸롣<BR>
   * 㤨, <i>protected abstract void uniqueDeciding()</i> Ȥ<BR><BR>
   * @fdeprecated public int[] decideCommand(int[] msg_header, int[] msg_data)
                 ذܹͽꡣ
   * @fparam message kernelƤå
   **/
    /*
  public void decideCommand(Vector message){

  }
    */
  /********************************************************************/
  /** HEAR (Agent to Agentå) Ф,
   * ưΥȤΤդޤ(ȯʬ)򵭽Ҥ롣<BR>
   * ƥͭεư,̤ݥ᥽åɤǼ¸롣<BR>
   * 㤨, <i>protected abstract void uniqueHearing()</i> Ȥ<BR><BR>
   * @param msg_header kernelƤåإå
   * @param msg_data kernelƤåǡ
   * @return Hearη̹Τä֥ȤSenseǡ
   *         AgentViewer饹ǻȤ롣
   **/
  public int[] receiveHear(int[] msg_header, byte[] msg_data){
    // ˤϰưΥȶ̤ʬϤ򵭽Ҥ롣

    int senderID = msg_header[3]; // Ԥ
    int[] returnData = null; // ֤ѤΥǡ

    // åΥॹפ򸫤
    if(prevMsgTime != time){
      hearSayMsgByCivilian = false;
      rcvHearSayMsgByRescueManCount = 0;
      rcvHearTellMsgCount = 0;
      rcvMsgCount = 0;
    }
    if(rcvMsgCount < Parameter.MAX_AGENT_RCVMSG_NUM && senderID != id){
      // ٤åɤ(ºݤȽϳƥȤ̤˹Ԥʤ)
      if(shouldReadMessage(msg_header)){

	// åȻϿ      
	prevMsgTime = time;
	rcvMsgCount++;

	// ˼åϤMessageǡƤ
	returnData = hearInfoParser.parseHearInfo(msg_header,msg_data,time);
	Vector rcvMsgSet = hearInfoParser.getJustNowMessageSet();
	io.writeHearLog(msg_header[0],senderID,rcvMsgSet);

	// .Ԥ߽⤷ϻλν(åϤ)
	if(objectManager.hasRescueManObject(senderID) ||
	   objectManager.hasRescueCenterObject(senderID)){
	  // MessageProtocol˽äåǤʤ,
	  // ʲΣĤifʸΤɤ餫Ƥ롣
	  if(rcvMsgSet != null){
	    if(rcvMsgSet.size() != 0){
	      Iterator it = rcvMsgSet.iterator();
	      while(it.hasNext()){
		Message mes = (Message)it.next();

		// 1-1.ưΥȶʬε
		// åHearSayä
		if(msg_header[0] == KA_HEAR_SAY){
		  // ⤬, ⤷ϵ崰λǤΤä
		  // ξϸϤǤᤤˤϤ
		  if(mes.getCommand() == AA_REFILL ||
		     mes.getCommand() == AA_REFILL_FIN){
		    int dataTime = mes.getDataTime();
		    int[] mesData = mes.getMessage();
		    int fbID = mesData[0];
		    // ϤǤᤤID
		    int nearestRefugeID = objectManager.getNearestRefugeID(id);
		    int[] throwSenseHeader = {msg_header[0],-1,-1,dataTime};
		    int[] throwSenseData = {ServerSetting.TYPE_FIREBRIGADE,
					    fbID,6,nearestRefugeID,7,0,0,0};
		    Vector vec = new Vector();
		    senseInfoParser.parseSenseInfo(throwSenseHeader,
						   throwSenseData,vec);
		    if(vec.size() == 1){
		      // returnDatathrowSenseDataɲ
		      returnData = mergeSenseData(returnData,throwSenseData);
		    }
		  }
		  // ߵ⤬̱˲ȤΤä
		  // εߵȻ̱ϸϤǤᤤˤϤ
		  else if(mes.getCommand() == AA_UNLOAD){
		    int dataTime = mes.getDataTime();
		    int[] mesData = mes.getMessage();
		    int atID = mesData[0];
		    int cvID = mesData[1];
		    // ϤǤᤤID
		    int nearestRefugeID = objectManager.getNearestRefugeID(id);
		    int[] throwSenseHeader = {msg_header[0],-1,-1,dataTime};
		    int[] throwSenseDataAT = {ServerSetting.TYPE_AMBULANCETEAM,
					      atID,6,nearestRefugeID,7,0,0,0};
		    int[] throwSenseDataCV = {ServerSetting.TYPE_CIVILIAN,
					      cvID,6,nearestRefugeID,7,0,0,0};
		    int[] throwSenseDataALL = mergeSenseData(throwSenseDataAT,
							     throwSenseDataCV);
		    Vector vec = new Vector();
		    senseInfoParser.parseSenseInfo(throwSenseHeader,
						   throwSenseDataALL,vec);
		    if(vec.size() == 2){
		      // returnDatathrowSenseDataɲ
		      returnData = mergeSenseData(returnData,
						  throwSenseDataALL);
		    }
		    else if(vec.size() == 1){
		      // returnDatathrowSenseDataΤΤäID
		      // ξΤߤɲ
		      int manID = ((Integer)vec.get(0)).intValue();
		      // ATξΤ߹줿
		      if(objectManager.hasAmbulanceTeamObject(manID)){
			returnData = mergeSenseData(returnData,
						    throwSenseDataAT);
		      }
		      // CVξΤ߹줿
		      else if(!objectManager.hasRescueManObject(manID) &&
			      objectManager.hasCivilianObject(manID)){
			returnData = mergeSenseData(returnData,
						    throwSenseDataCV);
		      }
		      // ,뤳ȤϤꤨʤ
		      else{
			//System.err.print("ꤨʤˤ衪");
			//System.err.print("(ʸ:ߵ⤬̱");
			//System.err.print("ȤΤä):");
			//System.err.println("[receiveHear()]");
		      }
		    }
		  }
		}

		// 1-2.ưΥȳƸĤε
		int[] tmpRetData = uniqueHearingForRescueAgent(msg_header[0],
							       senderID,mes);
		// returnDatatmpRetDataɲ;
		returnData = mergeSenseData(returnData,tmpRetData);
	      }
	    }
	  }
	}

	// .嵭ʳԤ̱λν
	else if(objectManager.hasCivilianObject(senderID)){
	  // 2-1.ưΥȶʬε
	  int length = (((int)msg_data[0] & 0xFF) << 24) | 
	               (((int)msg_data[1] & 0xFF) << 16) | 
	               (((int)msg_data[2] & 0xFF) <<  8) | 
	                ((int)msg_data[3] & 0xFF); // 4Bytes
	  String cvMsg = new String(msg_data,4,length);
	  if(cvMsg.equals("help_me")){
	    // AA_HEAR_BURIED_CIVILIAN_* åι
	    Message mes = messageManager_new.makeHearBuriedCivilianMessage
		                                                  (senderID);
	    if(mes != null){
	      // ʬν°륻󥿡, Tell
	      if(hasMyCenterObject()){
		messageManager_new.storeTellMessage(mes,1);
	      }
	      // Sayɬ롣ʤߤ, 󹹿ʤɤεߵ
	      // Ūʽ, uniqueHearingForCivilian()
	      messageManager_new.storeSayMessage(mes,1);
	    }
	  }
	  else if(cvMsg.equals("What_a_relief!")){
	    int dataTime = time; // ߻
	    // ϤǤᤤID
	    int nearestRefugeID = objectManager.getNearestRefugeID(id);
	    int[] throwSenseHeader = {KA_HEAR_SAY,-1,-1,dataTime};
	    int[] throwSenseData = {232,senderID,6,nearestRefugeID,7,0,0,0};
	    Vector vec = new Vector();
	    senseInfoParser.parseSenseInfo(throwSenseHeader,
					   throwSenseData,vec);
	    if(vec.size() == 1){
	      // returnDatathrowSenseDataɲ
	      returnData = mergeSenseData(returnData,throwSenseData);
	    }
	    // AA_SENSE_* åι
	    Message mes = messageManager_new.makeSenseMessage(throwSenseData);
	    if(mes != null){
	      // ʬν°륻󥿡, Tell
	      if(hasMyCenterObject()){
		messageManager_new.storeTellMessage(mes,1);
	      }
	      // Sayɬ
	      messageManager_new.storeSayMessage(mes,1);
	    }
	  }
	  else{ // ̱Τ¾ȯ
	    // ǤǤʤȯʤΤǲ⤷ʤ
	  }

	  // 2-2.ưΥȳƸĤε
	  int[] tmpReturnData = uniqueHearingForCivilian(msg_header[0],
							 senderID,cvMsg);
	  // returnDatatmpReturnDataɲ
	  returnData = mergeSenseData(returnData,tmpReturnData);
	}

        // .ϵĤΤ, Υåʬʤ
	else{
	  // äƲ⤷ʤ
	}
      }
    }
    return returnData;
  }

  /********************************************************************/
  /** Ƥʤνڤå<BR>
   * 3 ƥåװʾƱƻ̤ȤƼԤƤ <BR>
   * ̩ : Position Ʊ,route Τμ road Ʊ 
   * -> ƻ̤Τ򤢤¾̤뤳 <BR><BR>
   * @param rsob RescueObject
   * @return ڤƤ뤫ɤ[Ƥtrue,Ƥʤfalse]
   **/
  protected boolean checkConfusion(RescueObject rsob){
    if(rsob.getType().equals("Road") || rsob.getType().equals("Node")){
      if(nowPos == prevPos){
	int second_rd = -1;
	if (route != null){
	  if (route.length > 1){
	    RescueObject rt = objectManager.getObject(route[1]);
	    if(rt.getType().equals("Road")){
	      // nowPos  Node Ǽ Road
	      second_rd = ((Road)rt).getID();
	    }
	    else{
	      if (route.length > 2){
		RescueObject rt2 = objectManager.getObject(route[2]);
		if(rt2.getType().equals("Road")){
		  // nowPos  Road Ǽ Node Ǽ Road
		  second_rd = ((Road)rt2).getID();
		}
		else{
		  io.writeMiscLog("checkConfusion error : node - node - node ");
		}
	      }
	      else{
		io.writeMiscLog("checkConfusion error : route.length <= 2");
	      }
	    }
	  }
	  if (second_rd != -1){
	    if (tmp_confusionRoad == second_rd){
	      sameRouteCount++;
	    }
	    else{
	      tmp_confusionRoad = second_rd;
	      sameRouteCount = 0;
	    }
	  }
	  else{
	    // 2 ܤ Road ʤ
	    io.writeMiscLog("checkConfusion error : node - node - node ");
	  }
	}
	else{
	  // Route ʤ
	  tmp_confusionRoad = -1;
	  sameRouteCount = 0;
	}
	if (sameRouteCount > 1){ // 3stepϿˤ sameRouteCount > 1
	  sameRouteCount = 0;
	  return true;
	}
      }
      else{
	// Ȱ֤㤦Τ,ϰưƤ
	tmp_confusionRoad = -1;
	sameRouteCount = 0;
      }
    }
    return false;
  }
  
  /********************************************************************/
  /** ʬޤäƤ뤫ɤΥå<BR>
   * ޤäƤˤ, AA_BURIED_MYSELF_* å<BR><BR>
   * @return ʬޤäƤ뤫[ޤäƤtrue,ޤäƤʤfalse]
   **/
  protected boolean isBuriedMyself(){
    boolean flag;
    if(self.getBuriedness() > 0){
      flag = true;
      // AA_BURIED_MYSELF_* åι
      Message mes = messageManager_new.makeBuriedMyselfMessage(self.getPosition());
      if(mes != null){
	// ʬν°륻󥿡, Tell
	if(hasMyCenterObject()){
	  messageManager_new.storeTellMessage(mes,1);
	}
	// Sayɬ
	messageManager_new.storeSayMessage(mes,1);
      }
    }
    else{
      flag = false;
    }

    return flag;
  }

  /********************************************************************/
  /** ʬϩΩƤ(ưʤʤäƤ)ɤΥå<BR>
   * ΩƤˤ, AA_HALT_* å<BR><BR>
   * @param rsob RescueObject
   * @return ʬϩΩƤ뤫[Ƥtrue,Ƥʤfalse]
   **/
  protected boolean checkHalt(RescueObject rsob){
    boolean flag = false;
    if(rsob.getType().equals("Road")){
      Road rd =(Road)rsob;
      if(!rd.isThroughable()){ // ̹ǽ
	flag = true;
      }
    }
    else if(rsob.getType().equals("Node")){
      Node nd = (Node)rsob;
      int[] edge = nd.getEdge();
      boolean throughable = false;
      for(int i=0;i<edge.length;i++){
	RescueObject rt = objectManager.getObject(edge[i]);
	if(rt.getType().equals("Road")){
	  Road rd = (Road)rt;
	  if(rd.isThroughable()){ // ̹Բǽƻä롼פȴ
	    throughable = true;
	    break;
	  }
	}
      } //end for(int i=0;i<edge.length;i++)
      if(!throughable){ // ̹ԲǽǤʤ
	flag = true;
      }
    }

    // HALTåȯ뤫ɤ
    if(flag == true){
      // AA_HALT_* åι
      Message mes = messageManager_new.makeHaltMessage();
      if(mes != null){
	// ʬν°륻󥿡, Tell
	if(hasMyCenterObject()){
	  messageManager_new.storeTellMessage(mes,1);
	}
	// Sayɬ
	messageManager_new.storeSayMessage(mes,1);
      }
    }

    return flag;
  }

  /********************************************************************/
  /** (Damage)(HP)ξ֤˹Ԥäƽɬפ
   * 뤫ɤȽꤹ᥽åɡǤȽꤷʤºݤ
   * ư(Refuge񤹤Ȥư)̤Υ᥽åɤ롣<BR>
   * ToDo:Υ᥽å̾ŬʤΤǥޥ˥᥽å̾ͤ뤳!<BR><BR>
   * @return ˤɬפ뤫ɤ[true,ʤfalse]
   **/
  protected boolean needToCure(){
    boolean shouldCure = false;
    // ʬ
    // ΤޤޤΥ᡼³ȡ300step˻Ǥޤ
    //     (㡧t=2ǡHP9500Damage90λ)
    // HPФơ1%ʾΥ᡼Ƥ()
    //     (㡧HP3000λDamage30ʾˤʤätrue˹Ԥ)
    // ǤξǤϤʤHP1000ڤäкҲȲˤʤ
    //     褦ˤ褤!!(ִĥ⡼ɡפνλ)
    // ˤǤξǤϤʤtrueäΤˡ
    //     Ԥʤ褦ʾ(Ĥޤĺor)ˤͥٺĺɲ
    //     ȡΥȡ֤ɤ!򤷤ɤ!!
    int myHP = self.getHP();
    int myDamage = self.getDamage();
    int reduceHP = myDamage*((Parameter.MAX_SIMULATION_TIME+1)-time);
    if(myHP-reduceHP <= 0){
      shouldCure = true;
    }
    if(myHP <= (myDamage*100)){
      shouldCure = true;
    }
    return shouldCure;
  }

  /********************************************************************/
  /** ذư<BR> Ǥذưͳ͡Ǥ뤳Ȥա
   * ĤޤꤳΥ᥽åɤϽذư᥽åɤǤ롣<BR><BR>
   * @return ºݤ˰ưȤActionɤ
   *         true...io.move()λ, false...ˤ뤫,
   *         ưʤư˼Ԥ, ⤷꼫Τʤ
   **/
  protected boolean goToRefuge(){
    // IDᤤ˼
    int[] refugeIDList = objectManager.getRefugeIDbyNearerOrder(id);
    if(refugeIDList == null){
      io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ"
		      +" -> ꤬ʤ!! -> ³");
      return false;
    }

    // ƻϩΥ
    if(confusionRoad != null){
      Iterator it = confusionRoad.iterator();
      String st = "routeκ ڤƤ RoadID:";
      while (it.hasNext()){
	int cRoad = ((int[])it.next())[0];
	st += cRoad+" ";
      }
      io.writeMiscLog(st);
    }
    else{
      io.writeMiscLog("routeκ ڤƤ RoadID:ʤ");
    }

    // ؤΥ롼Ȥ
    for(int i=0;i<refugeIDList.length;i++){
      // route̤ or ظrouteǤʤ -> ĺɳǧФ
      if(route == null || 
	 !objectManager.hasRefugeObject(route[route.length-1])){
      }
      else{
	// routeĺɳǧ
	if(objectManager.isRouteClear(route) && 
	   route[0] != route[route.length-1]){
	  // routeĺɤʤ -> ư -> λ
	  io.setPrefixActLog("ForCuring"); // ܺ٥ޥɤΥå
	  io.move(route,self.getPosition());
	  String buffer = "";
	  for (int j=0;j<route.length;j++){
	    buffer = buffer + route[j] + " ";
	  }
	  io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ"
			  +" -> ˤʤ -> route ĺɤʤ -> "
			  +"ư (ϩ:" + buffer +")");
	  dontArriveRefugeCount++;
	  if(nowPos == prevPos){
	    cantMoveCount++;
	    io.writeMiscLog("ưΤưʤƥå׿:"+cantMoveCount);
	  }
	  else{
	    cantMoveCount = 0;
	    io.writeMiscLog("ư褦ˤʤä");
	  }
	  if(cantMoveCount>4){ // 5ƥåưʤä饿åؤ
	    cantMoveCount = 0;
	    return false;
	  }
	  // 5ƥårefugeˤɤ失ʤä饿åȡ롼Ȥꥻå
	  // ˤ꼡̥롼Ȥꤵ
	  if(dontArriveRefugeCount>4){
	    io.writeMiscLog("routeեå");
	    dontArriveRefugeCount = 0;
	    route = null;
	  }
	  return true; // ưƽλ
	}
	else{
	  // routeĺɤ -> ΥåȤ
	}
      }

      // route(routeη׻)
      route = objectManager.goToDest(self.getPosition(),
				     refugeIDList[i],true,confusionRoad);
      // targetڤؤäΤǥȤꥻå
      dontArriveRefugeCount = 0;

    } //end for(int i=0;i<refugeIDList.length;i++)

    // ˤʤȤʤ,ϩʤ
    // ToDo : ۥȤ˺³ԤǤΤ(Τޤޤȳμ¤˻)
    io.writeMiscLog("Τޤޤȳμ¤˻ǤޤΤ"
		    +" -> ˤʤ -> ĺɤäƤɤˤ⤤ʤ"
		    +" -> ³");
    return false;
  }

  /********************************************************************/
  /** ०Ԥʤ<BR>
   * Ūˤ, ʬʪˤentranceޤǽФ, Ǥʤ,
   * ŬɸϤꤷƤޤǤΰưߤ롣<BR><BR>
   **/
  protected void randomWalk(){
    // ʪˤȤꤢentranceޤǽФ
    if(objectManager.hasBuildingObject(self.getPosition())){
      Building b = objectManager.getBuildingObject(self.getPosition());
      int[] beside = {b.getEntrance()};
      io.setPrefixActLog("FromBuildingToEntrance"); // ܺ٥ޥɤΥå
      io.move(beside,self.getPosition());
    }
    else{
      route = objectManager.getRandomWalkRoute(self);
      target = -1; // åȤꥻå

      if(route != null){
	io.setPrefixActLog("Random"); // ܺ٥ޥɤΥå
	io.move(route,self.getPosition());
      }
      else{
	// ToDo : ΤޤޤǤϿưǤʤʤäƤޤ
	io.setPrefixActLog("CannotMoving"); // ܺ٥ޥɤΥå
	io.rest(self.getPosition());
	io.writeMiscLog("randomWalk()  null ֤Ĵ");
	//System.err.println("randomwalk error");
	// AA_REST_* åι
	Message mes = messageManager_new.makeRestMessage();
	if(mes != null){
	  // ʬν°륻󥿡, Tell
	  if(hasMyCenterObject()){
	    messageManager_new.storeTellMessage(mes,1);
	  }
	  // Sayɬ
	  messageManager_new.storeSayMessage(mes,1);
	}
      }
    }
  }

  /********************************************************************/
}
