#! /bin/sh

#rm -f log/*.log

SERVER="$1"
FB="$2" ; FS="$3"
AT="$4" ; AC="$5"
PF="$6" ; PO="$7"
MEM="$8"
OPT="$9"

OUTPUT="/dev/stdout"
DATETIME=`date +%y%m%d-%H%M%S`
CONF_FILE="AgentConf.txt"

READY="YES"

if [ -z $MEM ] ; then
  READY="NO"
  else if [ $MEM = "default" ] ; then
    echo "Memory Size is default."
    MEM="-1"
    else if [ $MEM -lt 64 ] ; then
      echo "Illegal Memory: "$MEM"[MB]"
      READY="NO"
      else if [ $MEM -gt 1024 ] ; then
        echo "Illegal Memory: "$MEM"[MB]"
	READY="NO"
      else
        echo "Memory Size is "$MEM"[MB]."
      fi
    fi
  fi
  if [ $FS -gt 1 ] ; then
    READY="NO"
  fi
  if [ $AC -gt 1 ] ; then
    READY="NO"
  fi
  if [ $PO -gt 1 ] ; then
    READY="NO"
  fi
  if [ ! -z $OPT ] ; then
    if [ $OPT = "noOut" -o $OPT = "debug" ] ; then
      OUTPUT="/dev/null"
    else
      READY="NO"
    fi
  fi
fi

if [ $READY = "NO" ] ; then
  echo "Usage :  ./Start_Agent.sh [ServerName] [FB] [FS] [AT] [AC] [PF] [PO] [MEM] (noOut | debug)"
  echo "   [ServerName] : Connect Server name"
  echo "           [FB] : Connect FireBrigade Num     (0~15)"
  echo "           [FS] : Connect FireStation Num     (0~ 1)"
  echo "           [AT] : Connect AmburanceTeam Num   (0~ 8)"
  echo "           [AC] : Connect AmburanceCenter Num (0~ 1)"
  echo "           [PF] : Connect PoliceForce Num     (0~15)"
  echo "           [PO] : Connect PoliceOffice Num    (0~ 1)"
  echo "          [MEM] : MAX Memory used JavaVM     (default | 64~1024[MB])"
  echo "          noOut : If you want not to output text log, input 'noOut'."
  echo "          debug : If you want to make the file of all kinds agent for outputing text log, input 'debug'."
  exit
fi

if [ ! -z $OPT ] ; then
  if [ $OPT = "debug" ] ; then
    if [ $FB -gt 0 ] ;then
      echo "Connecting(Debug Mode) 1 FB."
      java Main -h $SERVER -f $CONF_FILE -FB 1 >& script"$DATETIME"FB.log &
      sleep 1
      FB=$(expr $FB - 1)
    fi
    if [ $FS -gt 0 ] ;then
      echo "Connecting(Debug Mode) 1 FS."
      java Main -h $SERVER -f $CONF_FILE -FS 1 >& script"$DATETIME"FS.log &
      sleep 1
      FS=$(expr $FS - 1)
    fi
    if [ $AT -gt 0 ] ;then
      echo "Connecting(Debug Mode) 1 AT."
      java Main -h $SERVER -f $CONF_FILE -AT 1 >& script"$DATETIME"AT.log &
      sleep 1
      AT=$(expr $AT - 1)
    fi
    if [ $AC -gt 0 ] ;then
      echo "Connecting(Debug Mode) 1 AC."
      java Main -h $SERVER -f $CONF_FILE -AC 1 >& script"$DATETIME"AC.log &
      sleep 1
      AC=$(expr $AC - 1)
    fi
    if [ $PF -gt 0 ] ;then
      echo "Connecting(Debug Mode) 1 PF."
      java Main -h $SERVER -f $CONF_FILE -PF 1 >& script"$DATETIME"PF.log &
      sleep 1
      PF=$(expr $PF - 1)
    fi
    if [ $PO -gt 0 ] ;then
      echo "Connecting(Debug Mode) 1 PO."
      java Main -h $SERVER -f $CONF_FILE -PO 1 >& script"$DATETIME"PO.log &
      sleep 1
      PO=$(expr $PO - 1)
    fi
  fi
fi

echo "Connecting $FB FB, $FS FS, $AT AT, $AC AC, $PF PF, $PO PO."
if [ $MEM -ne -1 ] ; then
  echo "java -Xmx"$MEM"m Main -h $SERVER -f $CONF_FILE -FB $FB -FS $FS -AT $AT -AC $AC -PF $PF -PO $PO > $OUTPUT"
  java "-Xmx"$MEM"m" Main -h $SERVER -f $CONF_FILE -FB $FB -FS $FS -AT $AT -AC $AC -PF $PF -PO $PO > $OUTPUT &
else
  echo "java Main -h $SERVER -f $CONF_FILE -FB $FB -FS $FS -AT $AT -AC $AC -PF $PF -PO $PO > $OUTPUT"
  java Main -h $SERVER -f $CONF_FILE -FB $FB -FS $FS -AT $AT -AC $AC -PF $PF -PO $PO > $OUTPUT &
fi
