package rescueAgent.AreaMap;

import rescueAgent.RescueObject.*;

class Destination{
  char sucType; // ȯϤΥ
  int dID;
  char type; // ŪϤΥ(U:unknown, N:Node, R:Road, B:Building)
  int visitCount ; // ˬ줿ʤǤ˲
  int aliveLaneF = 99; // Ƥ졼 Ԥ
  int aliveLaneR = 99; // Ƥ졼 
  int width = 0; // ƻ
  double x; // ŪϤXɸ(Roadξ)
  double y; // ŪϤYɸ
  RealObject src; // ȯϤ򼨤RescueObject
  RealObject robj; // ŪϤ򼨤RescueObject

  int onObstacleTime; // 㳲ʪ¸ߤƤǿλ
  final int obstacleDiff = 3; // 㳲ʪͭȤ

  /********************************************************************/
  // 󥹥ȥ饯

  Destination(RealObject srcObj,RealObject destObj){
    src = srcObj;
    robj = destObj;
    this.sucType = getObjectType(src);
    this.type = getObjectType(robj);
    this.dID = robj.getID();
    this.onObstacleTime = 0;
    if(this.sucType == 'N'){
      Node n = (Node)srcObj;
      x = n.getX();
      y = n.getY();
      if (robj instanceof Road){
	Road r = (Road)destObj;
	this.width = r.getWidth();
      }
    }
    else if(this.sucType == 'R' && this.type == 'N'){
      Node n = (Node)destObj;
      x = n.getX();
      y = n.getY();
      Road r = (Road)srcObj;
      this.width = r.getWidth();
    }
    else{
      System.err.println("Destination init Err");
      x = -1;
      y = -1;
    };
  }

  /********************************************************************/

  Destination(char scetype,int node,char type){
    this.sucType = scetype;
    this.dID = node;
    visitCount = 0;
    this.type = type;
    this.onObstacleTime = 0;
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  char getObjectType(RescueObject r){
    if(r instanceof Node)
      return 'N';
    else if(r instanceof Road)
      return 'R';
    else if(r instanceof Building)
      return 'B';
    else{
      System.err.println("Destination Unknown Type");
      return 'U';
    }
  }

  /********************************************************************/

  void setType(char t){
    type = t;
  }

  /********************************************************************/

  void setSourceType(char t){
    sucType = t;
  }

  /********************************************************************/

  char getSourceType(){
    return sucType;
  }

  /********************************************************************/
  // defaultǤ̹Բǽ

  void setAliveLane(){
    Road r;
    if(type == 'R'){
      r = (Road)robj;
    }
    else if(type == 'N'){
      if(sucType == 'R'){
	r = (Road)src;
      }
      else{
	this.aliveLaneF = 99;
	this.aliveLaneR = 99;
	return;
      };
    }
    else{
      this.aliveLaneF = 99;
      this.aliveLaneR = 99;
      return;
    };

    this.aliveLaneF = r.getAliveLaneToTail();
    this.aliveLaneR = r.getAliveLaneToHead();
  }

  /********************************************************************/
  // defaultǤ̹Բǽ(ʬ)

  void setAliveLaneAsStart(double posEx){
    Road r;
    if(type == 'R'){
      r = (Road)robj;
    }
    else if(type == 'N'){
      if(sucType == 'R'){
	r = (Road)src;
      }
      else{
	this.aliveLaneF = 99;
	this.aliveLaneR = 99;
	return;
      };
    }
    else{
      this.aliveLaneF = 99;
      this.aliveLaneR = 99;
      return;
    };

    this.aliveLaneF = r.getAliveLaneToTail();
    this.aliveLaneR = r.getAliveLaneToHead();

    // PositionExtra ̤ȴ
    if (aliveLaneF == 0 && aliveLaneR == 0){
      if (r != null){
	double road_length = r.getLength();
	if (road_length/2.0 > posEx){
	  // ŪϤ id   road  head ä
	  if (r.getHead() == robj.getID()){
	    aliveLaneF = 1;
	  }
	}
	else if (road_length/2.0 < posEx){
	  // ŪϤ id   road  head ä
	  if (r.getTail() == robj.getID()){
	    aliveLaneR = 1;
	  }
	}
	else{
	  System.err.println("fatel error(road_length/2.0 == posEx) : Destination.java");
	}
      }
      else{
	System.err.println("fatel error(road object equals null) : Destination.java");
      }
    }
  }

  /********************************************************************/

  int getAliveLane(){
    if(aliveLaneF > aliveLaneR)
      return aliveLaneF;
    else
      return aliveLaneR;
  }

  /********************************************************************/

  int getDestID(){
    return dID;
  }

  /********************************************************************/

  char getType(){
    return type;
  }

  /********************************************************************/

  void visit(){
    visitCount++;
  }

  /********************************************************************/

  int getVisitCount(){
    return visitCount;
  }

  /********************************************************************/

  int getWidth(){
    return width;
  }

  /********************************************************************/

  boolean isThroughRoute(int time){
    setAliveLane(); // Υ᥽åɤƤӽФ˾󹹿 !!!!
    if(aliveLaneF > 0 && aliveLaneR > 0 && 
       time - onObstacleTime > obstacleDiff)
      // ξ졼̹Բǽ  㳲ʪ¸ߤǶǤʤ
      return true;
    else
      return false;
  }

  /********************************************************************/

  boolean isThroughRouteAsStart(double posEx,int time){
    setAliveLaneAsStart(posEx); // Υ᥽åɤƤӽФ˾󹹿 !!!!
    if ( (aliveLaneF > 0 || aliveLaneR > 0) && 
	 time - onObstacleTime > obstacleDiff){
      // ξ졼̹Բǽ  㳲ʪ¸ߤǶǤʤ
      return true;
    }
    else{
      return false;
    }
  }

  /********************************************************************/

  boolean isNode(){
    if(type == 'N')
      return true;
    else
      return false;
  }


  /********************************************************************/

  boolean isRoad(){
    if(type == 'R')
      return true;
    else
      return false;
  }


  /********************************************************************/

  boolean isBuilding(){
    if(type == 'B')
      return true;
    else
      return false;
  }

  /********************************************************************/

  boolean isUnknown(){
    if(type == 'U')
      return true;
    else
      return false;
  }


  /********************************************************************/

  boolean equals(Destination comp){ // IDƱɤȽ
    if(dID == comp.getDestID())
      return true;
    else
      return false;
  }

  /********************************************************************/

  double getX(){
    return x;
  }

  /********************************************************************/

  double getY(){
    return y;
  }

  /********************************************************************/

  RescueObject getDestObject(){
    return robj;
  }

  /********************************************************************/

  void setObstacleTime(int time){
    this.onObstacleTime = time;
  }

  /********************************************************************/
}

