package rescueAgent.AreaMap;

import rescueAgent.RescueObject.*;

class DestinationSet{
  int sourceID; // ȯϤIDʥ
  double srcX,srcY;
  static final int DEST_MAX = 16;
  Destination[] destSet = new Destination[DEST_MAX];
  int number;
  RescueObject robj; // ȯϤɽRescueObject

  /********************************************************************/
  // 󥹥ȥ饯

  DestinationSet(RescueObject robj){
    this.robj = robj;
    sourceID = robj.getID();
    number = 0;

    if(robj instanceof Node){
      srcX = ((Node)robj).getX();
      srcY = ((Node)robj).getY();
    }
    else if(robj instanceof Road){
      srcX = -1;
      srcY = -1;
    }
    else{
      srcX = -1;
      srcY = -1;
      System.err.println("DestinationSet Unknown Type");
    };
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  int getSourceID(){
    return sourceID;
  }

  /********************************************************************/

  void addDest(Destination d){
    for(int i=0;i<number;i++){
      if(destSet[i].equals(d)){ // Ʊʪääʤ
	if(destSet[i].getType() == 'U' && d.getType() != 'U'){
	  // ƱʪǤ䴰ǤФ
	  destSet[i].setType(d.getType());
	}
	else if(destSet[i].getSourceType() == 'U' &&
		d.getSourceType() != 'U'){
	  // ƱʪǤ䴰ǤФ
	  destSet[i].setSourceType(d.getSourceType());
	};
	return;
      };
    };
    destSet[number] = d;
    number++;
  }

  /********************************************************************/
  // ĺ٤򥻥å

  void setBlocked(int destID){
    for(int i=0;i<number;i++){
      if(destSet[i].getDestID()==destID){
	destSet[i].setAliveLane();
	return;
      };
    };
  }

  /********************************************************************/

  int hasDestNum(){
    return number - 1;
  }

  /********************************************************************/

  int getDestNum(){
    return number;
  }

  /********************************************************************/

  Destination getDest(int num){
    return destSet[num];
  }

  /********************************************************************/
  // ԤΤǤˬ줿ξʤʪ
  // index֤(Road,NodeΤо)

  int minVisitDest(){
    int mvNum = 99;
    int index = -1;

    for(int i=0;i<number;i++){
      /*
      System.out.print("(" + destSet[i].getDestID() + "/");
      System.out.print(destSet[i].getVisitCount() + ":");      
      System.out.print(destSet[i].getType() + ")");      
      */
      if(destSet[i].isRoad() || destSet[i].isNode()){
	if(destSet[i].getVisitCount() < mvNum){
	  mvNum = destSet[i].getVisitCount();
	  index = i;
	}
	else if(destSet[i].getVisitCount() == mvNum){
	  // ΤȤ̤
	};
      }
      else{
	System.err.println("DestinationSet: dest != Road or Node " +
			   destSet[i].getDestID() + "/" +
			   destSet[i].getDestObject().getType());
      };
    };

    //System.out.println("DestSet.index = " + index);
    return index;
  }

  /********************************************************************/

  double getX(){
    return srcX;
  }

  /********************************************************************/

  double getY(){
    return srcY;
  }

  /********************************************************************/
}
