package rescueAgent.AreaMap;

import java.util.*;
import rescueAgent.RescueObject.*;
import rescueAgent.Generic.*;

class HashDijkstra {
  private int start,next;
  
  Hashtable route;
  Hashtable cv_table;
  Hashtable map;
  int[] exRoute = new int[DestinationSet.DEST_MAX];
  Vector tmpVec = new Vector(); // temporary Vector

  // ڤƤ id
  // int dont_use_id = -1;
  // ڤƤ id (Vector)
  Vector dont_use_id = new Vector(); // פid 03-06-21ѹ

  // ߥ졼󥹥ƥåס¾ΥȤξο뤿
  int time = -1;
  
  /********************************************************************/
  // Element of RouteNode

  class RouteElement{
    int key;
    int previous;
    int weight;
    boolean visited;

    /****************************************************************/
    // 󥹥ȥ饯

    RouteElement(int key){
      this.key = key;
      previous = -1;
      weight = -1;
      visited = false;
    }

    // 󥹥ȥ饯ޤ
    /****************************************************************/

    void init(){
      previous = -1;
      visited = false;      
    }

    /****************************************************************/
  }
  /********************************************************************/
  // 󥹥ȥ饯
  HashDijkstra(Hashtable routeTable,int time) {
    route =  routeTable;
    Enumeration rt = routeTable.keys();
    map = new Hashtable();

    //---------------------------initialize
    while(rt.hasMoreElements()){
      Integer key = (Integer)rt.nextElement();
      RouteElement re = new RouteElement(key.intValue());
      map.put(key,re);
    }

    // 
    this.time = time;
  }

  // Ȥΰ֤θ륳󥹥ȥ饯
  HashDijkstra(Hashtable routeTable,Hashtable CVTable,int time) {
    route =  routeTable;
    Enumeration rt = routeTable.keys();
    map = new Hashtable();

    //---------------------------initialize
    while(rt.hasMoreElements()){
      Integer key = (Integer)rt.nextElement();
      RouteElement re = new RouteElement(key.intValue());
      map.put(key,re);
    }

    // ȤΥϥåơ֥κ
    cv_table = new Hashtable(25);
    Enumeration enum = CVTable.elements();
    while (enum.hasMoreElements()){
      Civilian cv = (Civilian)enum.nextElement();
      if (cv instanceof FireBrigade || cv instanceof PoliceForce){
	Integer pos = new Integer(cv.getPosition());
	cv_table.put(pos,cv);
      }
    }

    // 
    this.time = time;
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  // initialize

  void init(){
    Object[] l = map.values().toArray();
    for(int i=0;i<l.length;i++){
      RouteElement re = (RouteElement)l[i];
      re.init();
    }
  }

  /********************************************************************/
  //Method --- Set start node
  // block = true : ĺɤͤ / false : ͤʤ 

  void setStartingNode(int s,double startPosEx,int time,boolean block) {
    //---------------------------initialize
    start = s; // <- ºݤID
    next = s;
    
    //---------------------------Dijkstra's algorithm STEP1(initialize)
    RouteElement re = (RouteElement)map.get(new Integer(start));
    re.visited = true;
    re.weight = 0;

    //---------------------------(Relax)

    //Object[] exst = getExistRouteN(start,block);
    int[] exst = getExistRouteFirst(start,startPosEx,time,block);

    for(int i=0;i<exst.length && exst[i]>0 ;i++){
      RouteElement re2 = (RouteElement)map.get(new Integer(exst[i]));
      re2.previous = start;
      //re2.weight = 1;
      //re2.weight = calcWeight(start,exst[i]);
      re2.weight = calcWeightByLaneAndWidth(start,exst[i]);
    }

    //---------------------------(Extract-Min)
    Object[] list = map.values().toArray();
    for(int i=0;i<list.length;i++){
      RouteElement re3 = (RouteElement)list[i];
      if(re3.visited == false && re3.weight>0){
	if(next == start){
	  next = re3.key;
	}
	else{
	  RouteElement nre = (RouteElement)map.get(new Integer(next));
	  if(nre.weight > re3.weight){
	    next = re3.key;
	  }
	}
      }
    }

    //---------------------------Dijkstra's algorithm STEP2
    for(int i=0;i<map.size();i++){
      RouteElement nre = (RouteElement)map.get(new Integer(next));
      nre.visited = true;
      int p = next;
      //---------------------------(Relax)

      //Object[] exst2 = getExistRouteN(next,block);
      int[] exst2 = getExistRoute(next,time,block);
      
      for(int j=0;j<exst2.length && exst[j]>0 ;j++){
	//RouteElement sre = (RouteElement)map.get((Integer)exst2[j]);
	RouteElement sre = (RouteElement)map.get(new Integer(exst2[j]));
	if(nre.weight+1 < sre.weight || sre.weight < 0){
	  sre.previous = next;
	  //sre.weight = nre.weight+1;
	  //sre.weight = nre.weight+calcWeight(next,exst[j]);
	  sre.weight = nre.weight+calcWeightByLaneAndWidth(next,exst[j]);
	}
      }

      //---------------------------(Extract-Min)
      for(int j=0;j<list.length;j++){
	RouteElement re4 = (RouteElement)list[j];
	if(re4.visited == false && re4.weight > 0){
	  next = re4.key;
	  break;
	}
      }
      for(int j=0;j<list.length;j++){
	RouteElement re5 = (RouteElement)list[j];
	if(re5.visited == false && re5.weight > 0){
	  RouteElement nre3 = (RouteElement)map.get(new Integer(next));
	  if(nre3.weight > re5.weight)
	    next = re5.key;
	}
      }
      if(next == p){
	break;
      }
    }
  }
  
  /********************************************************************/

  int[] getExistRoute(int x,int time,boolean block){
    DestinationSet ds = (DestinationSet)route.get(new Integer(x));
    int count = 0;
    
    for(int i=0;i<ds.getDestNum();i++){
      Destination d = ds.getDest(i);
      if( d.isThroughRoute(time) || !block ){
	// ĺͤͰʲǤС롼Ȥ˲ä
	  
	// â!! ڸΤ˰ääRoadääʤ!! 03-06-22 
	boolean flag = false; // ڤΤɤ
	if (dont_use_id != null){ // 03-06-21ѹ(ifreturn 999ޤ)
	  Iterator it = dont_use_id.iterator();
	  while (it.hasNext()){
	    int id = ((Integer)it.next()).intValue();
	    if(d.getDestID() == id){
	      flag = true;
	      //System.out.print("ڸΤ˰ääΤǥ롼Ȥ˲äʤ");
	      //System.out.println(" ExceptID:"+d.getDestID());
	    }
	  }
	}
	if(flag == false){
	  exRoute[count] = d.getDestID();
	  count++;
	}
      }
    }
    exRoute[count] = -1;

    return exRoute;
  }

  /********************************************************************/

  int[] getExistRouteFirst(int x,double posEx,int time,boolean block){
    DestinationSet ds = (DestinationSet)route.get(new Integer(x));
    int count = 0;

    for(int i=0;i<ds.getDestNum();i++){
      Destination d = ds.getDest(i);
      if( d.isThroughRouteAsStart(posEx,time) || !block ){
	// ĺͤͰʲǤХ롼Ȥ˲ä
	exRoute[count] = d.getDestID();
	count++;
      }
    }
    exRoute[count] = -1;

    return exRoute;
  }

  /********************************************************************/

  /*
  Object[] getExistRouteN(int x,boolean block){
    DestinationSet ds = (DestinationSet)route.get(new Integer(x));

    tmpVec.clear();
    for(int i=0;i<ds.getDestNum();i++){
      Destination d = ds.getDest(i);
      if(d.isThroughRoute() || !block){
	// ĺͤͰʲǤХ롼Ȥ˲ä
	tmpVec.add(new Integer(d.getDestID()));
      };
    };

    return tmpVec.toArray();
  }
  */
  /********************************************************************/

  int[] getRouteTo(int goal){
    int size = map.size();
    int[] tmp_route = new int[size];

    try{
      RouteElement gel = (RouteElement)map.get(new Integer(goal));
      int p = gel.previous;
      tmp_route[0] = goal;
      for(int i=0;i<size-1;i++){
	if(p >= 0){
	  tmp_route[i+1]=p;
	  RouteElement nel = (RouteElement)map.get(new Integer(p));
	  p = nel.previous;
	};
      };
    }
    catch(Exception e){
      //System.out.println("goal id = "+goal);
      e.printStackTrace();
      System.exit(0);
    }
    
    // ˽Ϥ褦ˤʤӤ
    int routeCount = 0;
    while(tmp_route[routeCount]>0){
      routeCount++;
    };
    
    int[] ret = new int[routeCount];
    for(int i=0;i<ret.length;i++,routeCount--){
      ret[i]=tmp_route[routeCount-1];
    };
    
    return ret;    
  }

  /********************************************************************/

  int[] getRoute(int start,double startPosEx,int goal,int time,boolean block){
    setStartingNode(start,startPosEx,time,block);
    return getRouteTo(goal);
  }
  /********************************************************************/
  
  public void setDontUseRoad(Vector dont_use_id){ // 03-06-21 ѹ
  // ա Localѿdont_use_idIntegerΣ
    if(dont_use_id != null){
      Vector temp = new Vector();
      Iterator it = dont_use_id.iterator();
      while(it.hasNext()){
	int[] tmp = (int[])it.next(); // tmp[0]=RoadID,tmp[1]=StoreTime
	temp.add(new Integer(tmp[0]));
      }
      this.dont_use_id = temp;
    }
    else{
      this.dont_use_id = null;
    }
  }
  /********************************************************************/
  /* ƻˤꥦȤݤ 

  int calcWeight(int src,int dest){
    DestinationSet ds = (DestinationSet)route.get(new Integer(src));
    
    for(int i=0;i<ds.getDestNum();i++){
      Destination d = ds.getDest(i);
      if(d.getDestID()==dest && d.getAliveLane()>0){
	return 6/d.getAliveLane();
      };
    };

    return 6;    
  }

  */
  /********************************************************************/
  // ˤꥦȤݤ

  int calcWeight(int src,int dest){
    DestinationSet ds = (DestinationSet)route.get(new Integer(src));

    if (dont_use_id != null){ // 03-06-21ѹ(ifreturn 999ޤ)
      Iterator it = dont_use_id.iterator();
      while (it.hasNext()){
	int id = ((Integer)it.next()).intValue();
	if(dest == id){
	  //System.out.println("ƻϽڤΤϤ(HashDijkstra.java)");
	  return 999;
	}
      }
    }
    if (cv_table == null){
      for(int i=0;i<ds.getDestNum();i++){
	Destination d = ds.getDest(i);
	if(d.getDestID()==dest && d.getAliveLane()>0){
	  return 6/d.getAliveLane();
	}
      }
    }
    else{
      // ¾ΥȤξ󤬤
      Civilian cv = (Civilian)cv_table.get(new Integer(dest));
      if (cv == null){
	// Ԥˤ¾ΥȤϤʤä
	for(int i=0;i<ds.getDestNum();i++){
	  Destination d = ds.getDest(i);
	  if(d.getDestID()==dest && d.getAliveLane()>0){
	    return 6/d.getAliveLane();
	  }
	}
      }
      else{
	// ϩ¾ΥȤ
	// Ͽ󤫥å,5 ƥåװʾŤ̵
	if (time != -1 && (time-cv.getTime()) > 4){
	  for(int i=0;i<ds.getDestNum();i++){
	    Destination d = ds.getDest(i);
	    if(d.getDestID()==dest && d.getAliveLane()>0){
	      return 6/d.getAliveLane();
	    }
	  }
	}
	else{
	  for(int i=0;i<ds.getDestNum();i++){
	    Destination d = ds.getDest(i);
	    if(d.getDestID()==dest && d.getAliveLane()>0){
	      //System.out.println("¾ΥȤ褱롣");
	      return 6/d.getAliveLane()+3;
	    }
	  }	
	}
      }
    }

    return 6;    
  }

  /********************************************************************/
  // ƻˤꥦȤݤ

  int calcWeightByLaneAndWidth(int src,int dest){
    DestinationSet ds = (DestinationSet)route.get(new Integer(src));

    if (dont_use_id != null){ // 03-06-21ѹ(ifreturn 999ޤ)
      Iterator it = dont_use_id.iterator();
      while (it.hasNext()){
	int id = ((Integer)it.next()).intValue();
	if(dest == id){
	  //System.out.println("ƻϽڤΤϤ(HashDijkstra.java)");
	  return 999;
	}
      }
    }
    if (cv_table == null){
      for(int i=0;i<ds.getDestNum();i++){
	Destination d = ds.getDest(i);
	if(d.getDestID()==dest && d.getAliveLane()>0){
	  if (d.getWidth() > 0){
	    return 6/d.getAliveLane()+(int)14/d.getWidth();
	  }
	  else{
	    return 6/d.getAliveLane()+7;
	  }
	}
      }
    }
    else{
      // ¾ΥȤξ󤬤
      Civilian cv = (Civilian)cv_table.get(new Integer(dest));
      if (cv == null){
	// Ԥˤ¾ΥȤϤʤä
	for(int i=0;i<ds.getDestNum();i++){
	  Destination d = ds.getDest(i);
	  if(d.getDestID()==dest && d.getAliveLane()>0){
	    if (d.getWidth() > 0){
	      return 6/d.getAliveLane()+(int)14/d.getWidth();
	    }
	    else{
	      return 6/d.getAliveLane()+7;
	    }
	  }
	}
      }
      else{
	// ϩ¾ΥȤ
	// Ͽ󤫥å,5 ƥåװʾŤ̵
	if (time != -1 && (time-cv.getTime()) > 4){
	  for(int i=0;i<ds.getDestNum();i++){
	    Destination d = ds.getDest(i);
	    if(d.getDestID()==dest && d.getAliveLane()>0){
	      if (d.getWidth() > 0){
		return 6/d.getAliveLane()+(int)14/d.getWidth();
	      }
	      else{
		return 6/d.getAliveLane()+7;
	      }
	    }
	  }
	}
	else{
	  for(int i=0;i<ds.getDestNum();i++){
	    Destination d = ds.getDest(i);
	    if(d.getDestID()==dest && d.getAliveLane()>0){
	      //System.out.println("¾ΥȤ褱롣");
	      if (d.getWidth() > 0){
		return 6/d.getAliveLane()+(int)14/d.getWidth()+3;
	      }
	      else{
		return 6/d.getAliveLane()+7+3;
	      }
	    }
	  }	
	}
      }
    }

    return 13;    
  }
}
    
    

