package rescueAgent.AreaMap;

import java.util.*;
import rescueAgent.RescueObject.*;
import rescueAgent.ObjectSet.ObjectDatabase;

/**
 * Ȥΰưϩ󶡤륯饹
 **/
public class RoutingTable{
  ObjectDatabase objectDB;
  Hashtable routeTable = new Hashtable(2879);

  boolean isContBuilding = true; // Ͽ޾ְʤ

  boolean verbose = false;

  /********************************************************************/
  // 󥹥ȥ饯

  public RoutingTable(ObjectDatabase d){
    objectDB = d;
  }

  /********************************************************************/

  public RoutingTable(boolean build){
    isContBuilding = build;
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /**
   * Ͽޤ롣
   **/

  public void makeTable(ObjectDatabase d){
    objectDB = d;
    makeTable();
  }

  /********************************************************************/
  /**
   * Ͽޤ롣
   **/

  public void makeTable(){
    Enumeration roadList = objectDB.getRoadTable().elements();

    while(roadList.hasMoreElements()){ // Road򸡺
      Road r = (Road)roadList.nextElement();
      // RoadľNode褦ˤ
      updateTable(r.getHead(),'N',r.getID(),'R',r);
      updateTable(r.getID(),'R',r.getHead(),'N',r);
      updateTable(r.getTail(),'N',r.getID(),'R',r);
      updateTable(r.getID(),'R',r.getTail(),'N',r);
      // R.Head <-> Node  -1ƻäƤ
      // R.Tail <-> Node
    };
  }

  /********************************************************************/
  //(ȯ,ȯϤΥ,Ū,ŪϤΥ)
  // ƻϩĺɾդξ

  void updateTable(int srcID,char srcType,int destID,char destType,
		   Road road){
    // ηΤTableʤ
    if(srcID<1 || destID<1){
      return;
    };

    RealObject srcObj = (RealObject)objectDB.getObject(srcID);
    RealObject destObj = (RealObject)objectDB.getObject(destID);    
    Destination dest = new Destination(srcObj,destObj);

    Integer pos = new Integer(srcID); // 
    
    if(routeTable.containsKey(pos)){
      // srcIDΥ롼Ȥ˰İʾ狼äƤ
      DestinationSet gDest = (DestinationSet)routeTable.get(pos);
      gDest.addDest(dest);
      gDest.setBlocked(destID); 
      // ĺͤ
      routeTable.put(pos,gDest);	  
    }
    else{
      // srcIDΥ롼ȤĤ狼ʤ
      DestinationSet dSet = new DestinationSet(srcObj);
      dSet.addDest(dest);
      dSet.setBlocked(destID); 
      // ĺͤ
      routeTable.put(pos,dSet);
    };
  }

  /********************************************************************/
  /**
   * ŪϤޤǤηϩ֤
   **/

  public int[] goToDest(int startPoint,double startPosEx,int destPoint,boolean block){
    int[] route;

    if(!objectDB.hasBuildingObject(startPoint)){
      if(!objectDB.hasBuildingObject(destPoint)){ // both != building
	route = generateRoute(startPoint,startPosEx,destPoint,block);
      }
      else{ // goal = building
	Building b = objectDB.getBuildingObject(destPoint);
	int prevPoint = b.getEntrance();
	int[] subRoute = generateRoute(startPoint,startPosEx,prevPoint,block);
	route = new int[subRoute.length+1];
	route[subRoute.length] = destPoint;
	System.arraycopy(subRoute,0,route,0,subRoute.length);
      }
    }
    else{ // start = building
      if(!objectDB.hasBuildingObject(destPoint)){ // start = building
	Building bs = objectDB.getBuildingObject(startPoint);
	int nextPoint = bs.getEntrance();
	int[] subRoute = generateRoute(nextPoint,startPosEx,destPoint,block);
	route = new int[subRoute.length+1];
	route[0] = startPoint;
	route[route.length-1] = destPoint;
	System.arraycopy(subRoute,0,route,1,subRoute.length);
      }
      else{ // both == building
	Building bs = objectDB.getBuildingObject(startPoint);
	Building bg = objectDB.getBuildingObject(destPoint);
	int nextPoint = bs.getEntrance();
	int prevPoint = bg.getEntrance();
	int[] subRoute = generateRoute(nextPoint,startPosEx,prevPoint,block);
	route = new int[subRoute.length+2];
	route[0] = startPoint;
	route[route.length-1] = destPoint;
	System.arraycopy(subRoute,0,route,1,subRoute.length);
      }
    };

    /*
    if(route != null && route[0] == startPoint)
      return route;
    else
      return null;
      */
    return route;
  }

  /********************************************************************/
  /**
   * ŪϤޤǤηϩ֤
   **/

  public int[] goToDest(int startPoint,double startPosEx,int destPoint,boolean block,Vector dont_use_id){
    int[] route;

    if(!objectDB.hasBuildingObject(startPoint)){
      if(!objectDB.hasBuildingObject(destPoint)){ // both != building
	route = generateRoute(startPoint,startPosEx,destPoint,block,dont_use_id);
      }
      else{ // goal = building
	Building b = objectDB.getBuildingObject(destPoint);
	int prevPoint = b.getEntrance();
	int[] subRoute = generateRoute(startPoint,startPosEx,prevPoint,block,dont_use_id);
	route = new int[subRoute.length+1];
	route[subRoute.length] = destPoint;
	System.arraycopy(subRoute,0,route,0,subRoute.length);
      }
    }
    else{ // start = building
      if(!objectDB.hasBuildingObject(destPoint)){ // start = building
	Building bs = objectDB.getBuildingObject(startPoint);
	int nextPoint = bs.getEntrance();
	int[] subRoute = generateRoute(nextPoint,startPosEx,destPoint,block,dont_use_id);
	route = new int[subRoute.length+1];
	route[0] = startPoint;
	route[route.length-1] = destPoint;
	System.arraycopy(subRoute,0,route,1,subRoute.length);
      }
      else{ // both == building
	Building bs = objectDB.getBuildingObject(startPoint);
	Building bg = objectDB.getBuildingObject(destPoint);
	int nextPoint = bs.getEntrance();
	int prevPoint = bg.getEntrance();
	int[] subRoute = generateRoute(nextPoint,startPosEx,prevPoint,block,dont_use_id);
	route = new int[subRoute.length+2];
	route[0] = startPoint;
	route[route.length-1] = destPoint;
	System.arraycopy(subRoute,0,route,1,subRoute.length);
      }
    };

    /*
    if(route != null && route[0] == startPoint)
      return route;
    else
      return null;
      */
    return route;
  }

  /********************************************************************/

  int[] generateRoute(int start,double startPosEx,int goal,boolean block){
    //Hashtable CVtable = objectDB.getCivilianTable();
    //HashDijkstra hdj = new HashDijkstra(routeTable,CVtable,objectDB.getTime());
    
    HashDijkstra hdj = new HashDijkstra(routeTable,objectDB.getTime());
    return hdj.getRoute(start,startPosEx,goal,objectDB.getTime(),block);
  }

  /********************************************************************/

  int[] generateRoute(int start,double startPosEx,int goal,boolean block,Vector dont_use_id){
    //Hashtable CVtable = objectDB.getCivilianTable();
    //HashDijkstra hdj = new HashDijkstra(routeTable,CVtable,objectDB.getTime());
    HashDijkstra hdj = new HashDijkstra(routeTable,objectDB.getTime());
    if (dont_use_id != null){
      hdj.setDontUseRoad(dont_use_id);
    }
    return hdj.getRoute(start,startPosEx,goal,objectDB.getTime(),block);
  }

  /********************************************************************/

  int[] generateRouteA(int start,int goal,boolean block){
    AStar as = new AStar(routeTable);
    double dx;
    double dy;
    RescueObject r = objectDB.getObject(goal);

    if(r instanceof Node){
      dx = ((Node)r).getX();
      dy = ((Node)r).getY();
    }
    else if(r instanceof Road){
      Node n = objectDB.getNodeObject(((Road)r).getHead());
      dx = n.getX();
      dy = n.getY();
    }
    else{
      System.err.println("RoutingTable.generateA Error " + r.getType());
      dx = 0;
      dy = 0;
    };

    return as.AStarSearch(start,goal,dx,dy,objectDB.getTime());
  }

  /********************************************************************/
  /**
   * Ͽ(table)ƤϤ롣
   **/

  public void printHash(){
    // HashƤɽ
    Enumeration e = routeTable.keys();

    while(e.hasMoreElements()){
      Integer key = (Integer)e.nextElement();
      DestinationSet v = (DestinationSet)routeTable.get(key);
      System.out.print("PRS " + key.toString() + " -> ");
      int count = v.hasDestNum();
      while(count >= 0){
	Destination d = v.getDest(count);
	char type = d.getType();
	char to = d.getSourceType();
	int next = d.getDestID();
	System.out.print("(" + to + "," + type + ")" + next + " , ");	
	count--;
      };
      System.out.println();
    };

  }

  /********************************************************************/

  DestinationSet getDSet(int i){
    Integer it = new Integer(i);
    return (DestinationSet)routeTable.get(it);
  }

  /********************************************************************/
  /********************************************************************/
  /**
   * ưΥ롼Ȥ֤
   **/
  
  public int[] getRandomWalkRoute(Civilian self){
    int selfPos = self.getPosition(); // ʬΰ
    final int prevCount = 10; // 롼Ȥɤߺ
    int[] routeTmp = new int[prevCount];
    
    int prevPos1=-99; // 1ļID
    int prevPos2=-99; // 2ļID
    
    // ʬε֤ӥξentrance
    RescueObject rob = objectDB.getObject(self.getPosition());
    if(rob instanceof Building){
      Building b = (Building)rob;
      selfPos = b.getEntrance();
    };
    
    DestinationSet ds = getDSet(selfPos);
    // ʬλϿޤ鼫ʬΰ֤ꤤŪϤФ
    
    int count = ds.hasDestNum(); // 餤ؤθο
    prevPos1 = selfPos;

    // RoutingTable롼Ȥ򸡺,ꤷint˳Ǽ
    for(int index=0;index<8;index++){
      int mvd = ds.minVisitDest(); // ԤäξʤФ
      
      if(mvd == -1){ // 顼
	System.err.println("RoutingTable.getRandomWalkRoute mvd = -1");
	break;
      }
      else{
	Destination d = ds.getDest(mvd); // ϿޤŪϤIDФ
	int nodeID = d.getDestID();
	
	if(noVisit(nodeID,routeTmp)){
	  routeTmp[index] = nodeID;
	  
	  //d.visit(); // ˬ줿ȤϿ
	  int sID = ds.getSourceID();
	  incPassCount(sID,d);
	  
	  prevPos2 = prevPos1;
	  prevPos1 = nodeID;//???
	  
	  // 򸡺뤿˰ưIDHashҤ
	  //Integer key = new Integer(nodeID);
	  ds = getDSet(nodeID);
	  //count = ds.hasDestNum();
	}
	else{
	  break;
	};
      };
    }; // while(index)

    int arraycount=0;
    for(int i=0;i<routeTmp.length;i++){
      if(routeTmp[i]==0){
	arraycount=i;
	break;
      }
    }

    if(arraycount == 0){
      return null;
    }
    else{
      int[] new_route = new int[arraycount];
      System.arraycopy(routeTmp,0,new_route,0,arraycount);
      return new_route;
    }
  }

  /********************************************************************/
  // route˻ꤷIDäƤ뤫ɤå
  
  boolean noVisit(int pointID,int[] rarray){
    for(int i=0;i<rarray.length;i++){
      if(rarray[i] == pointID) 
	return false;
    };
    return true;
  }
  
  /********************************************************************/
  // ƻαϩ,ϩξ򥫥ȥå
  
  void incPassCount(int srcID,Destination dest){
    dest.visit(); // ˬ줿ȤϿ
    DestinationSet destSet = getDSet(dest.getDestID());
    int num = destSet.hasDestNum();
    for(int i=0;i<=num;i++){
      Destination d = destSet.getDest(i);
      if(d.getDestID() == srcID){
	d.visit();
      };
    }
  }
  
  /********************************************************************/
  /**
   * 㳲ʪ(agent)¸ߤ륪֥Ȥĺɤȸʤ,󹹿
   *  <BR><BR>
   *  @param nowTime    ߤλ
   *  @param diffTime   ƥåפ򻲾ȤĺɤȤ뤫
   **/

  public void setObstacleRoute(int nowTime,int diffTime){
    HashSet ct = new HashSet();
    Enumeration ce = (objectDB.getCivilianTable()).elements();

    while(ce.hasMoreElements()){
      Civilian cv = (Civilian)ce.nextElement();
      //     ʬǤʤ
      if((nowTime - cv.getTime() < diffTime) && 
	 (cv instanceof FireBrigade || cv instanceof AmbulanceTeam || 
	  cv instanceof PoliceForce) && cv.getID() != objectDB.getID()){
	RescueObject obj = objectDB.getObject(cv.getPosition());
	if(obj instanceof Road){
	  Road rd = (Road)obj;
	  // 
	  DestinationSet dsf = 
	    (DestinationSet)routeTable.get(new Integer(rd.getHead()));
	  for(int i=0;i<dsf.getDestNum();i++){
	    Destination d = dsf.getDest(i);
	    if(d.getDestID()==rd.getTail()){
	      d.setObstacleTime(objectDB.getTime());
	      break;
	    };
	  };
	  // 
	  DestinationSet dsr = 
	    (DestinationSet)routeTable.get(new Integer(rd.getTail()));
	  for(int i=0;i<dsr.getDestNum();i++){
	    Destination d = dsr.getDest(i);
	    if(d.getDestID()==rd.getHead()){
	      d.setObstacleTime(objectDB.getTime());
	      break;
	    };
	  };
	};
      };
    };
  }

  /********************************************************************/
}
