/*
  # Parameter.java
  # $Id: Parameter.java,v 1.6 2002/06/08 06:25:28 yoshikia Exp $
  */

package rescueAgent.Generic;

import java.util.StringTokenizer;
import java.io.*;

/**
 * 쥹塼ߥ졼ˤ͡¤
 **/
public class Parameter{
  /** ⤬٤ǽʺ̡(default:1000)**/
  public static int MAX_WATER_QUANT = 1000;

  /** ⤬󥯤Ƥκ̡(default:15000)**/
  public static int MAX_TANK_QUANT = 15000;

  /** ⤬òвǽʺΥ[m](default:30) **/
  public static double MAX_EXTINGUISH_RANGE = 30;

  /** ۡ򿭤ФȤǤĹ[m](default:1) **/
  public static double MAX_STREATCH_LENGTH = 1;

  /** ٤˵ߵ⤬ƤǤ̱ο(default:1) **/
  public static int MAX_LOAD_NUM = 1;

  /** ưȲǽȯÿ(default:4) **/
  public static int MAX_AGENT_SNDMSG_NUM = 4;

  /** ưȲǽ(default:4) **/
  public static int MAX_AGENT_RCVMSG_NUM = 4;

  /** ꤬1ߥ졼󥹥ƥå˲ǽʺȯÿ
   * (default:³ȿߣ)
   **/
  public static int MAX_CENTER_SNDMSG_NUM = 0;

  /** ꤬1ߥ졼󥹥ƥå˲ǽʺå
   * (default:³ȿߣ)
   **/
  public static int MAX_CENTER_RCVMSG_NUM = 0;

  /** SAYǽʺåĹ[byte] (default:256) **/
  public static int SAY_MAX_BYTE = 256;

  /** TELLǽʺåĹ[byte] (default:256) **/
  public static int TELL_MAX_BYTE = 256;

  /** ߥ졼Ԥʤ[step | min.] (default:300) **/
  public static int MAX_SIMULATION_TIME = 300;

  /** ǥХåѥӥ塼AgentViewerפҤ뤫ɤ (default:false) **/
  public static boolean USE_AGENT_VIEWER = false;

  /** ưlogϤ뤫 (default:true) **/
  public static boolean ACTION_LOG = true;

  /** ̿ʼlogϤ뤫(default:true) **/
  public static boolean HEAR_LOG = true;

  /** ʾlogϤ뤫(default:true) **/
  public static boolean SELF_LOG = true;

  /** ¾logϤ뤫(default:true) **/
  public static boolean MISC_LOG = true;

  /** ưlogprefix **/
  public static String ACTION_LOG_PREFIX = "log/action";

  /** ̿logprefix **/
  public static String HEAR_LOG_PREFIX = "log/hear";

  /** ʾlogprefix **/
  public static String SELF_LOG_PREFIX = "log/self";

  /** ¾logprefix **/
  public static String MISC_LOG_PREFIX = "log/misc";

  public static boolean verbose = false;
  // ǥХåѥå

  /********************************************************************/

  public static void setParameter(String fileName){
    try{
      File f = new File(fileName);
      if(!f.isFile()){ // ե뤬¸ߤ뤫
	System.err.println(f.getName() + " is not fount");
	return;
      };

      FileReader fr = new FileReader(f);
      BufferedReader br = new BufferedReader(fr);

      String s;
      while((s=br.readLine()) != null){
	parseParameter(s);
      };

      fr.close();
      fr=null;
    }
    catch(Exception e){
      e.printStackTrace();
    }
  }

  /********************************************************************/

  static void parseParameter(String str){
    StringTokenizer stz = new StringTokenizer(str);
    String s;
    while(stz.hasMoreTokens()){
      s = stz.nextToken();
      if(s.startsWith("#")){
	return;
      }
      else if(s.equals("MAX_WATER_QUANT")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_WATER_QUANT = Integer.parseInt(s);
      }
      else if(s.equals("MAX_TANK_QUANT")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_TANK_QUANT = Integer.parseInt(s);
      }
      else if(s.equals("MAX_EXTINGUISH_RANGE")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_EXTINGUISH_RANGE = Integer.parseInt(s);
      }
      else if(s.equals("MAX_STREATCH_LENGTH")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_STREATCH_LENGTH = Integer.parseInt(s);
      }
      else if(s.equals("MAX_LOAD_NUM")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_LOAD_NUM = Integer.parseInt(s);
      }
      else if(s.equals("MAX_AGENT_SNDMSG_NUM")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_AGENT_SNDMSG_NUM = Integer.parseInt(s);
      }
      else if(s.equals("MAX_AGENT_RCVMSG_NUM")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_AGENT_RCVMSG_NUM = Integer.parseInt(s);
      }
      else if(s.equals("MAX_CENTER_SNDMSG_NUM")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_CENTER_SNDMSG_NUM = Integer.parseInt(s);
      }
      else if(s.equals("MAX_CENTER_RCVMSG_NUM")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_CENTER_RCVMSG_NUM = Integer.parseInt(s);
      }
      else if(s.equals("SAY_MAX_BYTE")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  SAY_MAX_BYTE = Integer.parseInt(s);
      }
      else if(s.equals("TELL_MAX_BYTE")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  TELL_MAX_BYTE = Integer.parseInt(s);
      }
      else if(s.equals("MAX_SIMULATION_TIME")){
	s = stz.nextToken();
	if(Character.isDigit(s.charAt(0)))
	  MAX_SIMULATION_TIME = Integer.parseInt(s);
      }
      else if(s.equals("USE_AGENT_VIEWER")){
	s = stz.nextToken();
	if(s.equals("true"))
	  USE_AGENT_VIEWER = true;
	else if(s.equals("false"))
	  USE_AGENT_VIEWER = false;
	else
	  System.err.println("Illigal Parameter : Generic.Parameter fail to parse USE_AGENT_VIEWER");
      }
      else if(s.equals("ACTION_LOG")){
	s = stz.nextToken();
	if(s.equals("true"))
	  ACTION_LOG = true;
	else if(s.equals("false"))
	  ACTION_LOG = false;
	else
	  System.err.println("Illigal Parameter : Generic.Parameter fail to parse ACTION_LOG");
      }
      else if(s.equals("HEAR_LOG")){
	s = stz.nextToken();
	if(s.equals("true"))
	  HEAR_LOG = true;
	else if(s.equals("false"))
	  HEAR_LOG = false;
	else
	  System.err.println("Illigal Parameter : Generic.Parameter fail to parse HEAR_LOG");
      }
      else if(s.equals("SELF_LOG")){
	s = stz.nextToken();
	if(s.equals("true"))
	  SELF_LOG = true;
	else if(s.equals("false"))
	  SELF_LOG = false;
	else
	  System.err.println("Illigal Parameter : Generic.Parameter fail to parse SELF_LOG");
      }
      else if(s.equals("MISC_LOG")){
	s = stz.nextToken();
	if(s.equals("true"))
	  MISC_LOG = true;
	else if(s.equals("false"))
	  MISC_LOG = false;
	else
	  System.err.println("Illigal Parameter : Generic.Parameter fail to parse MISC_LOG");
      }
      else if(s.equals("ACTION_LOG_PREFIX")){
	s = stz.nextToken();
	ACTION_LOG_PREFIX = s;
      }
      else if(s.equals("HEAR_LOG_PREFIX")){
	s = stz.nextToken();
	HEAR_LOG_PREFIX = s;
      }
      else if(s.equals("SELF_LOG_PREFIX")){
	s = stz.nextToken();
	SELF_LOG_PREFIX = s;
      }
      else if(s.equals("MISC_LOG_PREFIX")){
	s = stz.nextToken();
	MISC_LOG_PREFIX = s;
      }
      else{
	System.err.println("Conf_File Err: " + str);
	return;
      }
    }
  }

  /********************************************************************/
  // ưȿˤƥ󥿡Ȥ
  // å򥻥åȤ᥽å

  public static void setMessageNum(int ag_num){

    MAX_CENTER_SNDMSG_NUM = ag_num*2;
    MAX_CENTER_RCVMSG_NUM = ag_num*2;
  }

  /********************************************************************/
}
