package rescueAgent.Generic;

public class StringWrapper{
  StringWrapper[] list;
  String str;
  int length;

  /********************************************************************/

  public StringWrapper(String s){
    String[] elem = SFTokenizer.tokenizeT(s);
    list = new StringWrapper[elem.length];
    str = s;
    if(elem.length == 1){
      list = null;
    }
    else if(elem.length > 1){
      for(int i=0;i<elem.length;i++){
	list[i] = new StringWrapper(elem[i]);
      };
    }
    else{
      System.err.println("StringWrapper.elem.length == 0");
    };
  }

  /********************************************************************/

  public String getString(){
    if(list == null && str.charAt(0)=='(' && 
       str.charAt(str.length()-1)==')'){ 
      //(single)Τ褦ʤΤξ̤֤
      return str.substring(1,str.length()-1);
    }
    else{
      return str;
    }
  }

  /********************************************************************/

  public StringWrapper getElement(int i){
    if(list == null){//(single)Τ褦ʤΤξ
      return this;
    }
    else{
      return list[i];
    }
  }

  /********************************************************************/

  public int length(){
    if(list==null || list.length == 1)
      return 1;
    else
      return list.length;
  }

  /********************************************************************/

  public boolean isAtomic(){
    if(list != null)
      return false;
    else
      return true;
  }

  /********************************************************************/

  public void print(){
    if(list == null){
      System.out.println(str);
    }
    else{
      System.out.println(str);
      for(int i=0;i<list.length;i++){
	list[i].print();
      };
    };
  }

  /********************************************************************/
}

/**********************************************************************/
/*******************************************/
/*  SFTokenizer  S-бStringTokenizer */
/*******************************************/
class SFTokenizer{
  int nest = 0;
  int endCount;
  int totalCount;
  String[] stbox = new String[256];
  char[] charArray;

  /********************************************************************/
  // 󥹥ȥ饯

  public SFTokenizer(String inputString){
    tokenize(inputString);
  }

  /********************************************************************/

  public SFTokenizer(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  public void tokenize(String str){
    stbox = tokenizeT(str);
  }

  /********************************************************************/

  public static String[] tokenizeT(String str){
    if(str.length()==0){
      if(str.charAt(0) == '(' || str.charAt(str.length()-1) == ')'){
	String[] s = {str.substring(1,str.length()-1)};
	return s;
      };
      String[] s = {str};
      return s;
    };

    int lastParent = str.lastIndexOf(')');
    if(lastParent < 0){ // ̤ΤʤΤƤ
      String[] s = {str};
      return s;
    };
    String pstr = str.substring(0,str.lastIndexOf(')')+1);
    char[] charArrayT = pstr.toCharArray();

    if((charArrayT[0] != '(') || (charArrayT[charArrayT.length - 1] != ')')){
      System.out.println("String Type is Illigal(SFTokenizer.tokenize)");
      System.out.println(pstr + "<-");      
      return null;
    };

    int i=1;
    int start=1;

    int endCountT=0;
    int nestT = 0;
    String[] stboxT = new String[64];

    while(i<charArrayT.length){
      // ̤褿ͥȤٲ,Ĥ̤褿ͥȤ夲
      if(charArrayT[i] == '('){
	nestT++;
      }
      else if(charArrayT[i] == ')'){
	nestT--;
      };

      // ڡǶڤ
      if(Character.isWhitespace(charArrayT[i]) && nestT == 0){
	if(i != 0 && Character.isWhitespace(charArrayT[i-1])
	   && Character.isWhitespace(charArrayT[i])){
	  start = i+1;
	}
	else{
	  stboxT[endCountT] = new String(charArrayT,start,i-start);
	  start = i+1;
	  endCountT++;
	  if(stboxT[endCountT-1].equals(" ") 
	     || stboxT[endCountT-1].equals("")){
	    endCountT--;
	  };
	};
      };
      i++;
    };

    // Ǹˤ⤦ɬ
    stboxT[endCountT] = new String(charArrayT,start,i-start-1);
    endCountT++;

    String[] ret = new String[endCountT];
    System.arraycopy(stboxT,0,ret,0,endCountT);

    return ret;
  }

  /********************************************************************/

  public boolean hasMoreSFTokens(){
    if(totalCount < endCount){
      return true;
    }
    else{
      return false;
    }
  }

  /********************************************************************/

  public String nextSFToken(){
    return stbox[totalCount++];
  }

  /********************************************************************/

  public void printSFTokens(){
    int i=0;

    while(i < endCount){
      System.out.println(">" + stbox[i]);
      i++;
    };
  }

  /********************************************************************/
}
