/*
  # IO.java
  # $Id: IO.java,v 1.19 2002/06/08 06:18:22 yoshikia Exp $
  */

package rescueAgent.IO;

import java.net.*;
import java.io.*;
import java.util.*;
import rescueAgent.Generic.*;
import rescueAgent.ObjectSet.*;
import rescueAgent.RescueLib.*;

/**
 * ȤRescue Kernelȥޥɤ򤪤ʤΥ᥽åɤ,
 * ȤγƼ᥽åɤ󶡤롣
 **/
public class IO implements CommandTable, KKCommand, AACommand{

  DatagramSocket socket;       // Socketν
  DatagramPacket sendPacket;
  DatagramPacket recvPacket;
  InetAddress address;         // kernelɥ쥹
  int port;                    // ݡֹ
  byte[] sendBuffer;           // Хåե
  byte[] recvBuffer = new byte[4096]; // ХåեʥŬ
  ByteArrayOutputStream baos;  // ǡByte
  DataOutputStream dos;        // Byte˽񤭹

  Vector rcvVec = new Vector(); // ѥåȤʣ褿Ƥ
  int totalSize = 0;                // ѥåȤ

  int headSize = 16; // åΥإåʬΥХȿ

  int id;

  FileWriter afw; // output log for agent's action 
  BufferedWriter abw;
  FileWriter hfw; // output log for agent's communication
  BufferedWriter hbw;
  FileWriter sfw; // output log for agent's self information 
  BufferedWriter sbw;  
  FileWriter mfw; // output log for misc(for Debug)
  BufferedWriter mbw;

  int time; // Time of Simulation
  String prefix;

  /********************************************************************/
  // 󥹥ȥ饯
  /**
   * ǥեȤǤlocalhost6000֥ݡȤ³򤪤ʤ
   **/
  public IO(){
    // ݡ
    try{
      socket = new DatagramSocket();
      address = InetAddress.getLocalHost();
      port = 6000;

      baos = new ByteArrayOutputStream();
      dos = new DataOutputStream(baos);
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }

  /********************************************************************/
  /**
   * @param address  ³ۥ(̾ or IPɥ쥹)
   * @param port     ³ݡֹ
   **/
  public IO(String address,int port){
    try{
      socket = new DatagramSocket();
      this.address = InetAddress.getByName(address);
      this.port = port;

      baos = new ByteArrayOutputStream();
      dos = new DataOutputStream(baos);
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }

  // 󥹥ȥ饯 ޤ 
  /********************************************************************/
  // AK_CONNECTˤkernelȤ³
  /**
   * AK_CONNECTˤ,kernelȤ³򤪤ʤ
   *<BR><BR>
   * <TABLE BORDER>
   * <TR><TD>typeNumο</TD><TD>ȥ</TD></TR>
   * <TR><TD>1</TD><TD>Civilian</TD></TR>
   * <TR><TD>2</TD><TD>FireBrigade</TD></TR>
   * <TR><TD>4</TD><TD>FireStation</TD></TR>
   * <TR><TD>8</TD><TD>AmbulanceTeam</TD></TR>
   * <TR><TD>16</TD><TD>AmbulanceCenter</TD></TR>
   * <TR><TD>32</TD><TD>PoliceForce</TD></TR>
   * <TR><TD>64</TD><TD>PoliceOffice</TD></TR>
   * </TABLE>
   * @param typeNum ³륨ȥ
   * @param version Ķν֤(1)ʤ(0)
   **/
  public void connect(int typeNum,boolean initMapData){
    String type = Integer.toString(typeNum,16);
    int agentType = Integer.valueOf(type,16).intValue();
    try{
      appendDecl(dos); // (0)-(7)
      // ѥåղ

      dos.writeInt(CommandTable.AK_CONNECT); // (8)-(11)
      // AK_CONNECT = 0x10

      dos.write(0x0);  // (12) Length of Body 
      dos.write(0x0);  // (13) ѥåΤĹ
      dos.write(0x0);  // (14) (length = tmp.ID + agentType + version)
      dos.write(0xC);  // (15) Ǥ12Х

      dos.write(0x7F); // (16) temporaryID
      dos.write(0xFF); // (17)
      dos.write(0xFF); // (18)
      dos.write(0xFE); // (19)

      dos.write(0x0);  // (20) version
      dos.write(0x0);  // (21) 0 : Ķν֤
      dos.write(0x0);  // (22) 1 : Ķν֤ʤ
      if(initMapData){
	dos.write(0x0);  // (23)
      }
      else{
	dos.write(0x1);  // (23)
      }

      dos.writeInt(agentType); //(24)-(27) agentType
      /*
      1:Civilian1ӥåܡ         (0x01)
      2:FireBrigade2ӥåܡ      (0x02)
      4:FireStation3ӥåܡ      (0x04)
      8:AmbulanceTeam4ӥåܡ    (0x08)
      16:AmburanceCenter5ӥåܡ (0x10)
      32:PoliceForce6ӥåܡ     (0x20)
      64:PoliceOffice7ӥåܡ    (0x40)
      */

      dos.writeInt(CommandTable.HEADER_NULL); // (28)-(31) HEADER_NULL = 0x00

      dos.close();

      // ľ
      sendBuffer = baos.toByteArray();

      sendPacket = new DatagramPacket(sendBuffer,sendBuffer.length,
				      address,port);
      socket.send(sendPacket);

      baos.reset();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }

  /********************************************************************/

  public void connect(String type,boolean initMapData){
    int typeNum = 1;
    if(type.equals("FireBrigade")){
      typeNum = 2;
    }
    else if(type.equals("AmbulanceTeam")){
      typeNum = 8;
    }
    else if(type.equals("PoliceForce")){
      typeNum = 32;
    }
    else if(type.equals("FireStation")){
      typeNum = 4;
    }
    else if(type.equals("AmbulanceCenter")){
      typeNum = 16;
    }
    else if(type.equals("PoliceOffice")){
      typeNum = 64;
    }
    else if(type.equals("Civilian")){
      typeNum = 1;
    }
    else{
      System.exit(0);
    }

    connect(typeNum,initMapData);
  }

  /********************************************************************/
  /**
   * AK_ACKKNOWLEDGEˤ,kernelack
   **/
  public void sendAck(){
    try{
      appendDecl(dos); // (0)-(7)
      // ѥåղ

      dos.writeInt(AK_ACKNOWLEDGE); // (8)-(11)
      // AK_ACKNOWLEDGE = 0x011 ˤ4byteäڤ˽񤭹

      dos.write(0x0);  // (12) Version ?
      dos.write(0x0);  // (13)
      dos.write(0x0);  // (14)
      dos.write(0x4);  // (15)

      dos.writeInt(id); // (16)-(19) ID

      /*
      dos.write(0x0);  // (20) agentType
      dos.write(0x0);  // (21)
      dos.write(0x0);  // (22)
      dos.write(0x1);  // (23)

      dos.write(0xFF); // (24) 
      dos.write(0xFF); // (25)
      dos.write(0xFF); // (26)
      dos.write(0xFE); // (27)
      */

      dos.writeInt(HEADER_NULL); 
      // (28)-(31) HEADER_NULL = 0x00

      dos.close();

      // ľ
      sendBuffer = baos.toByteArray();

      sendPacket = new DatagramPacket(sendBuffer,sendBuffer.length,
				      address,port);
      socket.send(sendPacket);

      baos.reset();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }

  /********************************************************************/
  /** ѥåղáʤʤʤǽ硩 **/
  void appendDecl(DataOutputStream d) throws IOException{
    // ѥåȤ 
    d.write(0x0);  // (0) Manual P.26
    d.write(0x8);  // (1) 0x0008
    
    d.write(0x0);  // (2) ID Ŭɤ2ѥåȤ1Ĥξ
    d.write(0x0);  // (3)    ФϤ򤽤
    
    d.write(0x0);  // (4) ѥåȥʥС
    d.write(0x0);  // (5)

    d.write(0x0);  // (6) Total Packet Number
    d.write(0x1);  // (7) 1Ǥ餷
    // ѥåȤ ޤ
  }

  /********************************************************************/
  /**
   *  kernelΥåȤȤKAޥȥǡʬ롣
   * <BR> θ塢KAޥint[]ѴƤ顢ǡϥå
   * SENSEʤint[]ѴƤ顢åHEARʤbyte[]
   * ޤޡ줾Vector˳Ǽ֤<BR>
   * KA_SENSE = 82(0x52)λKA16Хʬ(ޤ)KAޥ
   * ʹ(֥Ⱦ󤫤)ǡ˳Ǽ뤳Ȥˤ롣<BR>
   * KA_HEAR* = 83,84,85(0x53,0x54,0x55)λKA16Хʬ(ID
   * ޤ)KAޥʹ(ʹߤΥǡ[ñ:Byte])
   * ǡ˳Ǽ뤳Ȥˤ롣
   *<BR><BR>
   * @return Vector˳Ǽ줿kernelΥå
   **/
  public Vector receive(){

    // ֤ͤľܴطΤѿ(msg_dataϸ)
    Vector message = new Vector(); // åΤѿ
    int[] msg_header; // åإåѿ
    int[] msg_data_int; // intΥåǡѿ
    byte[] msg_data_byte; // byteΥåǡѿ

    // ºݤϤѥåȤ˴ؤѿ
    int[] packetHeader = new int[4]; // ѥåȥإåѿ(Debug_use)
    int packetLength = 0; // ȤäѥåȤĹ

    try{
      recvPacket = 
	new DatagramPacket(recvBuffer,recvBuffer.length,address,port);      

      socket.receive(recvPacket);
      packetLength = recvPacket.getLength();
      //System.out.println("PacketLength : " + packetLength); // *****
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }

    // ѥåȥإå (Debug_use)
    // 0 : magicnumber=8
    // 2 : packetID
    // 4 : packet number(0-total)
    // 6 : total
    for(int i=0,counter=0 ; i < 8 ; i+=2,counter++){
      packetHeader[counter] =
	(((int)recvBuffer[i] & 0xFF) << 8) | ((int)recvBuffer[i+1] & 0xFF);
      //System.out.println("PHeader" + i + " : " + packetHeader[counter]);
    }

    byte[] msg = packetParser(recvBuffer,packetLength);
    int rcvCount = 1; // äѥåȿ
    boolean first = true;
    rcvVec.clear(); // VectorǤν
    totalSize = 0; // totalSizeν

    while(rcvCount < packetHeader[3]){ // ѥåȤʬ䤵Ƥ
      //System.out.print("LongUDP!! " + packetHeader[2] + "/ ");

      if(first){ // ǽΥårcvVec˳Ǽ
	rcvVec.add(msg);
	totalSize = msg.length; // totalSizeΥå
	first = false;
      }

      // ⤦٥å
      try{
	recvPacket = 
	  new DatagramPacket(recvBuffer,recvBuffer.length,address,port); 

	socket.receive(recvPacket);
	packetLength = recvPacket.getLength();
	//System.out.println("PacketLength : " + packetLength); // ******
      }
      catch(Exception e){
	e.printStackTrace();
	System.exit(1);
      }

      for(int i=0,counter=0 ; i < 8 ; i+=2,counter++){
	packetHeader[counter] =(((int)recvBuffer[i] & 0xFF) << 8) | 
	  ((int)recvBuffer[i+1] & 0xFF);
	//System.out.println("PHeader" + i + " : " + packetHeader[counter]);
      }

      byte[] tmpmsg = packetParser(recvBuffer,packetLength);

      rcvVec.add(tmpmsg); // årcvVecɲ
      totalSize += tmpmsg.length; // totalSizeɲ
      rcvCount++;
    }

    // ƤΤ
    if(!rcvVec.isEmpty()){
      int fill = 0;
      msg = new byte[totalSize];
      for(int i=0;i<rcvVec.size();i++){
	byte[] pkt = (byte[])rcvVec.elementAt(i);	
	System.arraycopy(pkt,0,msg,fill,pkt.length);
	fill += pkt.length;
      }
    }

    // ºݤ֤ͤȤʤåʬ(trycatchǡδƻ)
    try{
      msg_header = getMsgHeader(msg); // åإåʬ
      message.add(msg_header); // åإåVector˳Ǽ
      switch(msg_header[0]){ // åǡʬϰʲΤ褦˾ʬ
      case KA_SENSE: // senseϾξ
      case KA_CONNECT_OK:
	msg_data_int = getIntMsgData(msg); // int[]ǡ
	message.add(msg_data_int); // åǡȤVector˳Ǽ
	break;
      case KA_HEAR: // hearϾξ
      case KA_HEAR_SAY:
      case KA_HEAR_TELL:
	msg_data_byte = getByteMsgData(msg); // byte[]ǡ
	message.add(msg_data_byte); // åǡȤVector˳Ǽ
	msg_data_int = new int[1]; // ߡȤƤ
	break;
      // ¾(ʥåإåĥѥåȤϤ)
      default:
	//System.err.print("Illegal Mesage Data!!(KA_command:"+msg_header[0]);
	//System.err.println("[0x"+(msg_header[0]/16)+(msg_header[0]%16)+"])");
	msg_data_int = getIntMsgData(msg); // int[]ǡ
	message.add(msg_data_int); // åǡȤVector˳Ǽ
      }// end switch(msg_header[0])
    }
    catch(Exception e){
      e.printStackTrace();
      //System.err.println("Illegal Mesage Data!!");
      message.clear(); // ǼʤȤ
      msg_header = new int[1];
      msg_header[0] = -1; // 򼨤إå
      msg_data_byte = msg; // ǡϤå򤽤Τޤ޳Ǽ
      message.add(msg_header);
      message.add(msg_data_byte);
      msg_data_int = new int[1]; // ߡȤƤ
    }

    // KAޥɤˤʬ
    if(msg_header[0]==KA_SENSE){ // SENSE
      // 0:KA_SENSE, 1:ľ夫ΥѥåĹ(Byte), 2:ID, 3:
      time = msg_header[3]; // Set time
      // եνФ
      if(Parameter.ACTION_LOG && time%4 == 0){
	try{
	  abw.flush();
	}
	catch(Exception e){
	  e.printStackTrace();
	}
      }
      if(Parameter.HEAR_LOG && time%4 == 1){
	try{
	  hbw.flush();
	}
	catch(Exception e){
	  e.printStackTrace();
	}
      }
      if(Parameter.SELF_LOG && time%4 == 2){
	try{
	  sbw.flush();
	}
	catch(Exception e){
	  e.printStackTrace();
	}
      }
      if(Parameter.MISC_LOG && time%4 == 3){
	try{
	  mbw.flush();
	}
	catch(Exception e){
	  e.printStackTrace();
	}
      }
    }
    else if(msg_header[0]==KA_HEAR || msg_header[0]==KA_HEAR_SAY
	    || msg_header[0]==KA_HEAR_TELL){ // HEAR(HEAR_SAY,HEAR_TELLޤ)
      // 0:KA_HEAR*, 1:ľ夫ΥѥåĹ(Byte), 2:ID, 3:ID
    }
    else if(msg_header[0]==KA_CONNECT_OK){ // CONNECT_OK
      // 0:KA_CONNECT_OK, 1:ľ夫ΥѥåĹ(Byte), 2:(t=-1), 3: My ID
      // Ǥλ(t=-1)intǡ2147483646פɽƤ
      id = msg_header[3]; // ʬID򥻥å
      int agentType = msg_data_int[0];
      String job = ServerSetting.getAgentType(agentType,true); // 2ʸString
      try{
	if(Parameter.ACTION_LOG){
	  String afile = Parameter.ACTION_LOG_PREFIX + job + id + ".log";
	  afw = new FileWriter(afile);
	  abw = new BufferedWriter(afw);
	  
	}
	if(Parameter.HEAR_LOG){
	  String hfile = Parameter.HEAR_LOG_PREFIX + job + id + ".log";
	  hfw = new FileWriter(hfile);
	  hbw = new BufferedWriter(hfw);
	}
	if(Parameter.SELF_LOG){
	  String sfile = Parameter.SELF_LOG_PREFIX + job + id + ".log";
	  sfw = new FileWriter(sfile);
	  sbw = new BufferedWriter(sfw);
	}
	if(Parameter.MISC_LOG){
	  String mfile = Parameter.MISC_LOG_PREFIX + job + id + ".log";
	  mfw = new FileWriter(mfile);
	  mbw = new BufferedWriter(mfw);
	}
      }
      catch(Exception e){
	e.printStackTrace();
      }
      String jobName = ServerSetting.getAgentType(agentType,false); // Fullʸ
      writeMyJobToLog(jobName);
    }
    else{
      //System.out.println("Illegal msg_header[0]= " + msg_header[0]);
    }
    return message;
  }

  /********************************************************************/
  /**
   * kernelѥåȤåʬФ롣
   *<BR><BR>
   * @param recvbyte ѥå
   * @param length ѥåĹ
   * @return byteå
   **/
  private byte[] packetParser(byte[] recvbyte,int length){

    byte[] msg = new byte[length-8];
    // ѥåȥإå(8byte[07]ޤ),ʹ(9byte[8])򥳥ԡ
    System.arraycopy(recvbyte,8,msg,0,length-8);
    return msg;
  }

  /********************************************************************/
  /**
   * byteΥåإåʬintˤФ롣
   *<BR><BR>
   * @param msg å
   * @return intåإå
   **/
  private int[] getMsgHeader(byte[] msg){

    int[] header = new int[headSize/4]; // headSize=16,so int[4]
    for(int i=0,counter=0 ; i<headSize ; i+=4,counter++){ // Header
      header[counter] = (((int)msg[i] & 0xFF) << 24) | 
	  (((int)msg[i+1] & 0xFF) << 16) | 
	  (((int)msg[i+2] & 0xFF) << 8) | 
	  ((int)msg[i+3] & 0xFF);
    }
    // System.out.println("header: "+header[0]+" "+header[1]+" "+header[2]+" "+header[3]);
    return header;
  }

  /********************************************************************/
  /**
   * byteΥåǡʬintˤФ롣
   *<BR><BR>
   * @param msg å
   * @return intåǡ
   **/
  private int[] getIntMsgData(byte[] msg){

    // dataĹϡ{(msgĹ)(header[16byte])}ࣴ 
    int[] data = new int[(msg.length-headSize)/4]; // headSize=16

    for(int i=headSize,counter=0; i<msg.length; i+=4,counter++){
      data[counter] = (((int)msg[i] & 0xFF) << 24) | 
	  (((int)msg[i+1] & 0xFF) << 16) | 
	  (((int)msg[i+2] & 0xFF) << 8) | 
	  ((int)msg[i+3] & 0xFF);
    }
    // System.out.println("Idata: "+data[0]+" "+data[1]+" "+data[2]+" "+data[3]);
    return data;
  }

  /********************************************************************/
  /**
   * byteΥåǡʬbyteΤޤФ롣
   *<BR><BR>
   * @param msg å
   * @return byteåǡ
   **/
  private byte[] getByteMsgData(byte[] msg){

    // dataĹϡ(msgĹ)(header[16byte])
    byte[] data = new byte[msg.length-headSize]; // headSize=16
    // åإå(16byteܤޤ)ʹ(17byteܤ)򥳥ԡ
    System.arraycopy(msg,headSize,data,0,msg.length-headSize);
    // System.out.println("Bdata: "+data[0]+" "+data[1]+" "+data[2]+" "+data[3]);
    return data;
  }

  /********************************************************************/
  /**
   * moveޥɤkernel롣ư롼Ȥϼʬΰ֤Ϥޤ,
   * ŪϤޤǤΥ֥IDɽƤɬפ롣â,
   * ʬΰ֤ʪλ,ʪνиǤΡɤ񤭻Ϥɬפ롣
   *<BR><BR>
   * @param dest ư롼Ȥ򥪥֥IDɽ
   * @param nowPos ʬΰ(ObjectID)ActionLog񤯰٤¸ߤ
   **/
  public void move(int[] dest, int nowPos){
    int destCount;
    // ¤1/10ΥХк
    if(dest.length < 25)
      destCount = dest.length;
    else
      destCount = 25;      

    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_MOVE); // (8)-(11)
      // AK_MOVE = 0x081 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(8 + destCount * 4); // (size + id) = 8 byte

      // ID
      dos.writeInt(id);

      // 롼Ȥ
      for(int i=0;i<destCount;i++){
	dos.writeInt(dest[i]); 
      };

      dos.writeInt(HEADER_NULL); 
      dos.writeInt(HEADER_NULL); 
      // ɤ2ɬפ餷 ...
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    };

    writeActionLog("Move",prefix,nowPos,dest[dest.length-1]);
  }

  /********************************************************************/
  /**
   * sayޥɤkernel롣
   * sayˤ̿Ǥ,̿ãΥ30m(äȻפ)
   *<BR><BR>
   * @param destID ΥȤID(֥ɥ㥹ȤΤ̣ʤ)
   * @param str ʸ
   **/
  public void say(int destID,String str){
    // RoboCup2002 ΥƥȤΤ
    return;
    
    /*
    byte[] msg = str.getBytes();

    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_SAY); // (8)-(11)
      // AK_SAY = 0x084 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(12 + msg.length); // (size + id + msg_size) = 12 byte

      // ID
      dos.writeInt(id); 

      // å
      dos.writeInt(msg.length); // å
      dos.write(msg,0,msg.length);

      // ID
      dos.writeInt(destID); 


      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    };
    */
  }

  /********************************************************************/
  /**
   * tellޥɤkernel롣
   * tell̿ˤ̿,̿ãΥ̵
   * (kernelˤꤵƤ)
   *<BR><BR>
   * @param destID ΥȤID(֥ɥ㥹ȤΤ̣ʤ)
   * @param str ʸ
   **/
  public void tell(int destID,String str){
    // RoboCup2002 ΥƥȤΤ
    return;

    /*
    byte[] msg = str.getBytes();

    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_TELL); // (8)-(11)
      // AK_SAY = 0x084 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(12 + msg.length); // (size + id + msgLength) = 12 byte


      // ID
      dos.writeInt(id); 

      // å
      dos.writeInt(msg.length); // å
      dos.write(msg,0,msg.length);

      // ID
      dos.writeInt(destID); 

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    };
    */
  }

  /********************************************************************/
  /**
   * sayޥɤkernel롣RoboCup2002 ǡ
   * sayˤ̿Ǥ,̿ãΥ30m(äȻפ)
   *<BR><BR>
   * @param command ޥɡkk:[0-9|0-9]
   * @param objID  ID iiiiiiiiii:[0-9]+10
   **/
  public void say(int command,int[] objID){
    int[] buffer = new int[10];
    int index = buffer.length-1;
    
    try{
      appendDeclM(dos); // ѥåղ
      
      dos.writeInt(AK_SAY); // (8)-(11)
      // AK_SAY = 0x084 ˤ4byteäڤ˽񤭹
      
      // ѥåȥ
      dos.writeInt(20); // (id + size + msgLength) = 4 + 4 + 12 byte 
      
      // ID
      dos.writeInt(id);
      
      // 12kkID Format
      dos.writeInt(12);
      
      // commandư̤ʬ񤭹
      dos.write(command/10+0x30); // ASCII code Ѵ
      dos.write(command%10+0x30); // ASCII code Ѵ
      
      // 
      // TODO : ID η 10 ʾξ꤬
      //  Υ쥹塼㤢ꤨʤ...
      //   äƤ iiiiiiiiii եɤ꤭ʤ
      for (int i=0;i<objID.length;i++){
	// оݤȤʤ ID
	int tmp = objID[i];
	// ¸
	int digit = 0;
	do{
	  if(index < 0){
	    // 10 ӥåȤۤ,ҤʬХåե
	    // Ƥ
	    for (int j=0;j<digit;j++){
	      buffer[j] = 0;
	    }
	    // index , ID ɤߤˤ
	    index = digit-1;
	    digit = 0;
	    break;
	  }
	  buffer[index--] = tmp%10;
	  tmp /= 10;
	  digit++;
	}
	while(tmp != 0);
	if (index == -1){
	  // ξ֤Ƿ񤭹ȼԤΤ,Ҥʬ
	  for (int j=0;j<digit;j++){
	    buffer[j] = 0;
	  }
	  // index , ID ɤߤˤ
	  index = digit-1;
	  digit = 0;	    
	}
	if (digit != 0){
	  // ϥХåե˽񤭹
	  buffer[index--] = digit;
	}
      }
      
      // IDºݤ˽񤭹
      for (int i=0;i<buffer.length;i++){
	dos.write(buffer[i]+0x30); // ASCII code Ѵ 
      }
      
      dos.writeInt(HEADER_NULL);       
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }
  
  /********************************************************************/
  /**
   * tellޥɤkernel롣RoboCup2002 ǡ
   * tell̿ˤ̿,̿ãΥ̵
   * (kernelˤꤵƤ)
   *<BR><BR>
   * @param command ޥɡkk:[0-9|0-9]
   * @param objID  ID iiiiiiiiii:[0-9]+10
   **/
  public void tell(int command,int[] objID){
    int[] buffer = new int[10];
    int index = buffer.length-1;
    
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_TELL); // (8)-(11)
      // AK_TELL = 0x085 4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(20); // (id + size + msgLength) = 4 + 4 + 12 byte 

      // ID
      dos.writeInt(id);

      // 12kkID Format
      dos.writeInt(12);

      // commandư̤ʬ񤭹
      dos.write(command/10+0x30); // ASCII code Ѵ
      dos.write(command%10+0x30); // ASCII code Ѵ
      
      // 
      // TODO : ID η 10 ʾξ꤬
      //  Υ쥹塼㤢ꤨʤ...
      //   äƤ iiiiiiiiii եɤ꤭ʤ
      for (int i=0;i<objID.length;i++){
	// оݤȤʤ ID
	int tmp = objID[i];
	// ¸
	int digit = 0;
	do{
	  if(index < 0){
	    // 10 ӥåȤۤ,ҤʬХåե
	    // Ƥ
	    for (int j=0;j<digit;j++){
	      buffer[j] = 0;
	    }
	    // index , ID ɤߤˤ
	    index = digit-1;
	    digit = 0;
	    break;
	  }
	  buffer[index--] = tmp%10;
	  tmp /= 10;
	  digit++;
	}
	while(tmp != 0);
	if (index == -1){
	  // ξ֤Ƿ񤭹ȼԤΤ,Ҥʬ
	  for (int j=0;j<digit;j++){
	    buffer[j] = 0;
	  }
	  // index , ID ɤߤˤ
	  index = digit-1;
	  digit = 0;	    
	}
	if (digit != 0){
	  // ϥХåե˽񤭹
	  buffer[index--] = digit;
	}
      }
      
      // IDºݤ˽񤭹
      for (int i=0;i<buffer.length;i++){
	dos.write(buffer[i]+0x30); // ASCII code Ѵ 
      }
      
      dos.writeInt(HEADER_NULL);       
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    };
  }

  /********************************************************************/
  /**
   * sayޥɤkernel롣RoboCup2002 ǡ
   * sayˤ̿Ǥ,̿ãΥ30m(äȻפ)
   *<BR><BR>
   * @param msgRC2002 MessageRoboCup2002å
   **/
  public void say(MessageRoboCup2002 msgRC2002){    
    try{
      appendDeclM(dos); // ѥåղ
      
      dos.writeInt(AK_SAY); // (8)-(11)
      // AK_SAY = 0x084 ˤ4byteäڤ˽񤭹
      
      // ѥåȥ
      dos.writeInt(20); // (id + size + msgLength) = 4 + 4 + 12 byte 
      // dos.writeInt(58); // (id + size + msgLength) = 4 + 4 + 50 byte 
      
      // ID
      dos.writeInt(id);
      
      // 12kkID Format
      dos.writeInt(12);
      // 50kkID Format
      //  dos.writeInt(50); // 50λϤȤ

      // ǡ(Ǥ ASCII code ѴѤߤΤ)
      int[] buffer = msgRC2002.getMsgIntArray(time);

      // 񤭹
      for (int i=0;i<buffer.length;i++){
	dos.write(buffer[i]);
      }
      
      dos.writeInt(HEADER_NULL);       
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }

  /********************************************************************/
  /**
   * tellޥɤkernel롣RoboCup2002 ǡ
   * tell̿ˤ̿,̿ãΥ̵
   * (kernelˤꤵƤ)
   *<BR><BR>
   * @param msgRC2002 MessageRoboCup2002å
   **/
  public void tell(MessageRoboCup2002 msgRC2002){    
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_TELL); // (8)-(11)
      // AK_TELL = 0x085 4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(20); // (id + size + msgLength) = 4 + 4 + 12 byte 
      //dos.writeInt(58); // (id + size + msgLength) = 4 + 4 + 50 byte 
            //    åѤϤѹ
      // ID
      dos.writeInt(id);

      // 12kkID Format
      dos.writeInt(12);
      // 50kkID Format
      //      dos.writeInt(50); // 50λϤȤ

      // ǡ(Ǥ ASCII code ѴѤߤΤ)
      int[] buffer = msgRC2002.getMsgIntArray(time);

      // 񤭹
      for (int i=0;i<buffer.length;i++){
	dos.write(buffer[i]);
      }
      
      dos.writeInt(HEADER_NULL);       
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
      System.exit(1);
    }
  }

  /********************************************************************/
  /** sayޥɤkernel롣̿ǡ<BR>
   * sayˤ̿Ǥ,̿ãΥ30mǤ롣<BR><BR>
   * @param data byteåǡ
   * @param maxSize Хȿ
   **/
  public void say(byte[] data,int maxSize){
    try{
      appendDeclM(dos); // ѥåղ
      dos.writeInt(AK_SAY); // AK_SAY = 0x084 ˤ4byteäڤ˽񤭹

      int sendData = data.length;
      if(sendData > maxSize){
	sendData = maxSize;
      }
      // ѥåȥ
      dos.writeInt(4+4+sendData); // id(4)+sendData(4)+data(sendData)
      // ID
      dos.writeInt(id);
      // ǡ
      dos.writeInt(sendData);
      // ǡ򤤤äڤ˽񤭹
      dos.write(data,0,sendData);
      // λɤ
      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
  }

  /********************************************************************/
  /** tellޥɤkernel롣̿ǡ<BR>
   * tell̿ˤ̿,̿ãΥ̵
   * (kernelˤꤵƤ)<BR><BR>
   * @param data byteåǡ
   * @param maxSize Хȿ
   **/
  public void tell(byte[] data,int maxSize){
    try{
      appendDeclM(dos); // ѥåղ
      dos.writeInt(AK_TELL); // AK_TELL = 0x085 ˤ4byteäڤ˽񤭹

      int sendData = data.length;
      if(sendData > maxSize){
	sendData = maxSize;
      }
      // ѥåȥ
      dos.writeInt(4+4+sendData); // id(4)+sendData(4)+data(sendData)
      // ID
      dos.writeInt(id);
      // ǡ
      dos.writeInt(sendData);
      // ǡ򤤤äڤ˽񤭹
      dos.write(data,0,sendData);
      // λɤ
      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
  }

  /********************************************************************/
  /**
   * ƻϩΤߤѤǤ륳ޥɤ,ĺɤƻϩ̤롣
   *<BR><BR>
   * @param objID ̤RoadΥ֥ID
   **/
  public void clear(int objID){
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_CLEAR); // (8)-(11)
      // AK_CLEAR = 0x089 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(8); // (size + id) = 8 byte

      // ʬID
      dos.writeInt(id);

      // clearRoadID
      dos.writeInt(objID);

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Clear",prefix,objID,-1);
  }

  /********************************************************************/
  /**
   * ΤߤѤǤ륳ޥɤ,ǳƤʪòФ뤿
   * 򤪤ʤ̤ϼưŪ˲ǽʺ̤˥åȤ롣
   *<BR><BR>
   * @param target òгưԤʤʪΥ֥ID
   * @param x      򤹤xɸ
   *(ͤ,Ȥΰ֤1mǤʤƤ)
   * @param y      򤹤yɸ
   **/
  public void extinguish(int target,double x,double y){
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_EXTINGUISH); // (8)-(11)
      // AK_EXTINGUISH = 0x086 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(28); // (id + target + dir + x + y + quant + end)

      // ʬID
      dos.writeInt(id); 

      // åȤID
      dos.writeInt(target); 

      // ʡˤ
      dos.writeInt(0); 

      // X
      dos.writeInt((int)x);

      // Y
      dos.writeInt((int)y); 

      // Ф̤
      dos.writeInt(Parameter.MAX_WATER_QUANT);

      // λʡˤ
      dos.writeInt(0);

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Extinguish",prefix,target,-1);
  }

  /********************************************************************/
  /**
   * ΤߤѤǤ륳ޥɤ,ǳƤʪòФ뤿
   * 򤪤ʤʥޥ:ˡ
   *<BR><BR>
   * @param target òгưԤʤʪΥ֥ID
   * @param x      򤹤xɸ
   *(ͤ,Ȥΰ֤1mǤʤƤ)
   * @param y      򤹤yɸ
   * @param water_quant 򤹤(ñ̡ȥ)
   **/
  public void extinguish(int[] target,int direction,double x,double y,
			 int water_quant){
    if(target == null)
      return;

    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_EXTINGUISH); // (8)-(11)
      // AK_EXTINGUISH = 0x086 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(8+target.length*20); // (id + target*)

      // ʬID
      dos.writeInt(id); 

      for(int i=0;i<target.length;i++){
	dos.writeInt(target[i]); // åȤID
	dos.writeInt(direction); // ʡˤ
	dos.writeInt((int)x); // X
	dos.writeInt((int)y); // Y
	// Ф̤
	dos.writeInt(water_quant);
      }

      // λʡˤ
      dos.writeInt(0);

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    };
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Extinguish",prefix,target[0],-1);
  }

  /********************************************************************/
  /**
   * ΤߤѤǤ륳ޥɤ,ǳƤʪòФ뤿
   * 򤪤ʤ
   *<BR><BR>
   * @param target òгưԤʤʪΥ֥ID
   * @param direction ʪФƾòФ򤪤ʤ
   * @param x      򤹤xɸ
   *(ͤ,Ȥΰ֤1mǤʤƤ)
   * @param y      򤹤yɸ
   * @param water_quant 򤹤(ñ̡ȥ)
   **/
  public void extinguish(int target,int direction,
			 double x,double y,int water_quant){
    
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_EXTINGUISH); // (8)-(11)
      // AK_EXTINGUISH = 0x086 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(28); // (id + target + dir + x + y + quant + end)

      // ʬID
      dos.writeInt(id); 

      // åȤID
      dos.writeInt(target); 

      // 
      dos.writeInt(direction); 

      // X
      dos.writeInt((int)x);

      // Y
      dos.writeInt((int)y); 

      // Ф̤
      dos.writeInt(water_quant);

      // λʡˤ
      dos.writeInt(0);

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Extinguish",prefix,target,-1);
  }

  /********************************************************************/
  /**
   * ߵΤߤѤǤ륳ޥɤޤäƤ륨Ȥٵ
   *<BR><BR>
   * @param targetID ٵȤID
   * @param dest ޤäƤ
   **/
  public void rescue(int targetID, int dest){
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_RESCUE); // (8)-(11)
      // AK_RESCUE = 0x088 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(8); // (size + id) = 8 byte

      // ʬID
      dos.writeInt(id); 

      // rescuetargetID
      dos.writeInt(targetID); // ?????

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Rescue",prefix,targetID,dest);
  }

  /********************************************************************/
  /**
   * ߵΤߤѤǤ륳ޥɤ,
   * Ȥ򱿤֤,ߵ޼֤˺ܤ롣
   *<BR><BR>
   * @param targetID ߵ޼(?)˺ܤ륨ȤID
   * @param dest ޤäƤ
   **/
  public void load(int targetID, int dest){
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_LOAD); // (8)-(11)
      // AK_LOAD = 0x082 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(8); // (size + id) = 8 byte

      // ʬID
      dos.writeInt(id); 

      // loadtargetID
      dos.writeInt(targetID); // ?????

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Load",prefix,targetID,dest);
  }

  /********************************************************************/
  /**
   * ߵΤߤѤǤ륳ޥɤ,
   * ߵ޼֤˺ܤƤ륨Ȥ򲼤<BR><BR>
   * @param targetID ߵ޼(?)鲼ȤID
   * @param dest (̾ΤϤ)
   **/
  public void unload(int targetID, int dest){
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_UNLOAD); // (8)-(11)
      // AK_UNLOAD = 0x083 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(4); // 䤷ä?????

      // ʬID
      dos.writeInt(id); 

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Unload",prefix,targetID,dest);
  }

  /********************************************************************/
  /**
   * ξˤȤɤޤ롣(⤷ʤ)
   * @param dest ȤɤޤäƤ
   **/
  public void rest(int dest){
    try{
      appendDeclM(dos); // ѥåղ

      dos.writeInt(AK_REST); // (8)-(11)
      // AK_UNLOAD = 0x080 ˤ4byteäڤ˽񤭹

      // ѥåȥ
      dos.writeInt(4); // 䤷ä?????

      // ʬID
      dos.writeInt(id); 

      dos.writeInt(HEADER_NULL); 
      dos.close();
      sendPacket();
    }
    catch(Exception e){
      e.printStackTrace();
    }
    // ˽񤭹( -1 ϥǡפʬɽ)
    writeActionLog("Rest",prefix,-1,dest);
  }

  /********************************************************************/

  void sendPacket() throws IOException{
    // ľ
    sendBuffer = baos.toByteArray();
    sendPacket = new DatagramPacket(sendBuffer,sendBuffer.length,
				    address,port);
    socket.send(sendPacket);      
    baos.reset(); // Append
  }

  /********************************************************************/

  void appendDeclM(DataOutputStream d) throws IOException{
    // ѥåȤ 
    d.write(0x0);  // (0) Manual P.26
    d.write(0x8);  // (1) 0x0008
    
    d.write(0x0);  // (2)
    d.write(0x0);  // (3) ID餷...?
    
    d.write(0x0);  // (4)
    d.write(0x0);  // (5)

    d.write(0x0);  // (6) Total Packet Number
    d.write(0x1);  // (7) 1Ǥ餷
    // ѥåȤ ޤ
  }

  /********************************************************************/
  /**
   * ƬܥȤΥ֤Ϥ롣 <BR><BR>
   * @param job ʬΥ̾
   **/
  private void writeMyJobToLog(String job){
    if (Parameter.ACTION_LOG){
      try{
	abw.write("My job is " + job + "\n");
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
    if (Parameter.HEAR_LOG){
      try{
	hbw.write("My job is " + job + "\n");
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
    if (Parameter.SELF_LOG){
      try{
	sbw.write("My job is " + job + "\n");
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
    if (Parameter.MISC_LOG){
      try{
	mbw.write("My job is " + job + "\n");
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
  }

  /********************************************************************/
  /**
   * ХåեίäƤƤΥǡŪ˥ե˽񤭹ࡣ
   * <BR><BR>
   **/
  public void flushAllLog(){
    if (Parameter.ACTION_LOG){
      try{
	abw.flush();
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
    if (Parameter.HEAR_LOG){
      try{
	hbw.flush();
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
    if (Parameter.SELF_LOG){
      try{
	sbw.flush();
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
    if (Parameter.MISC_LOG){
      try{
	mbw.flush();
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
  }

  /********************************************************************/
  /**
   * Ȥιư񤭹᥽åɡ<BR><BR>
   * @param com ̾
   * @param pre ü쥢̾
   * @param src ȯ,å,òХå,߽ͤΤ줫
   * @param dest Ū,Τ줫
   **/
  protected void writeActionLog(String com,String pre,int src,int dest){

    if(Parameter.ACTION_LOG){
      try{
	// ư
	if(com.equals("Move")){
	  // src = ȯ, dest = Ū
	  if(pre==null){
	    abw.write("(" + time + "):" + id + " " + 
		      com + " " + src + " -> " + dest + "\n");
	  }
	  else{
	    abw.write("(" + time + "):" + id + " " + 
		      pre + com + " " + src + " -> " + dest + "\n");
	  }
	}
	// 
	else if(com.equals("Clear")){
	  // src = å
	  if(pre==null){
	    abw.write("(" + time + "):" + id + " " + 
		      com + " " + src + "\n");
	  }
	  else{
	    abw.write("(" + time + "):" + id + " " +  pre +
		      com + " " + src + "\n");
	  }
	}
	// ߽
	else if(com.equals("Rescue")){
	  // src = ߽ , dest = 
	  if(pre==null){
	    abw.write("(" + time + "):" + id + " " + 
		      com + " " + src + " in " + dest + "\n");
	  }
	  else{
	    abw.write("(" + time + "):" + id + " " + pre +
		      com + " " + src + " in " + dest + "\n");
	  }
	}
	// ò
	else if(com.equals("Extinguish")){
	  // src = òХå
	  if(pre==null){
	    abw.write("(" + time + "):" + id + " " + 
		    com + " " + src + "\n");
	  }
	  else{
	    abw.write("(" + time + "):" + id + " " +  pre +
		      com + " " + src + "\n");
	  }
	}
	// ô
	else if(com.equals("Load")){
	  // src = ߽ , dest = 
	  if(pre==null){
	    abw.write("(" + time + "):" + id + " " + 
		      com + " " + src + " in " + dest + "\n");
	  }
	  else{
	    abw.write("(" + time + "):" + id + " " + pre +
		      com + " " + src + " in " + dest + "\n");
	  }
	}
	// 
	else if(com.equals("Unload")){
	  // src = ߽ , dest = 
	  if(pre==null){
	    abw.write("(" + time + "):" + id + " " + 
		      com + " " + src + " in " + dest + "\n");
	  }
	  else{
	    abw.write("(" + time + "):" + id + " " + pre +
		      com + " " + src + " in " + dest + "\n");
	  }
	}
	// ⤷ʤ
	else if(com.equals("Rest")){
	  // dest = 
	  if(pre==null){
	    abw.write("(" + time + "):" + id + " " + 
		      com + " at " + dest + "\n");
	  }
	  else{
	    abw.write("(" + time + "):" + id + " " + pre + 
		      com + " at " + dest + "\n");
	  }
	}
	// ʳ
	else{
	  //System.err.println("actionLog Err: " + com);
	}
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
    prefix = null;
  }

  /********************************************************************/
  /**
   * ȤİХ񤭹᥽åɡ<BR><BR>
   * @fdeprecated ѻߡ public void writeHearLog(int hearType,
   *             java.util.Vector msgSet) ͽꡣ
   * @fparam com AACommand.java줿ޥɤ
   * @fparam sender 
   * @fparam dest ObjectID(˥åȤȤʤꡩ)
   **/
    /*
  public void writeHearLog(int com,int sender,int[] dest){
    
    if(Parameter.HEAR_LOG){
      try{
	if((KK_BURY <= com && com <= KK_BURRY_SHALLOW_BURIED_HARD_INJURED)
	   || (KK_BURY_RO <= com
	       && com <= KK_BURRY_SHALLOW_BURIED_HARD_INJURED_RO)){
	  // state=äݤ  dest=?
	  hbw.write("#(" + time + "):" + id + " Bury Mode -> " + com + "(0x"
		    + (com/16)+(com%16) + ") senderID -> " + sender + " in ");
	  for(int i=0;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_HEAR_BURIED_CIVILIAN){
	  // state=äݤ  dest=?
	  hbw.write("#(" + time + "):" + id
		    + " Civilian 'Help ME!'(command:0x"+(com/16)+(com%16)
		    + ") senderID -> " + sender + " at ");
	  for(int i=0;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_FIN_HELP){
	  // state=äݤ  dest=?
	  hbw.write("#(" + time + "): KK_FIN_HELP Message from " + 
		    sender + " in ");
	  for(int i=0;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_HALT || com == KK_MAYBE_HALT){
	  // state=äݤ  dest=?
	  hbw.write("#(" + time + "): Halt Message from " + 
		    sender + " in ");
	  for(int i=0;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_EXTINGUISH){
	  // state=äݤ  dest=?
	  hbw.write("#(" + time + "):" + id + " Extinguish " + 
		    sender + " ");
	  for(int i=0;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_CLEAR || com == KK_CLEAR_FIN){
	  // state=äݤ  dest=?
	  hbw.write("#(" + time + "):" + id + " Clear " + 
		    sender + " in ");
	  for(int i=0;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_RCV){
	  // ǡ褿ȤϿ
	  hbw.write("Recieve (" + time + ") : From " + sender + "(ListVersion)\n");
	}
	else if(com == KK_TELL_EXT || com == KK_TELL_CLR ||
		com == KK_TELL_BRY || com == KK_TELL_HLT ||
		com == KK_TELL_BURNING){
	  // 򤪤ʤäȤϿ
	  hbw.write("@(" + time + "):" + id + " " + com + "(0x"
		    + (com/16)+(com%16) + ") ");
	  for(int i=0;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if (com == KK_WOULD_GROUP){
	  hbw.write("Recieve (" + time + ") : From " + sender + "  : 롼ײ׵ (ɸʪ id = " + dest[0] +")\n");
	  hbw.write("¾ξ : ");
	  for(int i=1;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if (com == KK_GROUP_REJCT){
	  hbw.write("Recieve (" + time + ") : From " + sender + "  : 롼ײ׵ (롼ײ׵ id = "+ dest[0] + ", ɸʪ id = " + dest[1] +")\n");
	  hbw.write("¾ξ : ");
	  for(int i=2;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_GROUP_RECIP) {
	  hbw.write("Recieve (" + time + ") : From " + sender + "  : 롼׻ (롼ײ׵ id = "+ dest[0] + ", ɸʪ id = " + dest[1] +")\n");
	  hbw.write("¾ξ : ");
	  for(int i=2;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_GROUP_MAKED) {
	  hbw.write("Recieve (" + time + ") : From " + sender + "  : 롼׷ (꡼ id = "+ dest[0] + ", ɸʪ id = " + dest[1] +")\n");
	  hbw.write("¾ξ : ");
	  for(int i=2;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else if(com == KK_GROUP_BROKE) {
	  hbw.write("Recieve (" + time + ") : From " + sender + "  : 롼ײ (꡼ id = "+ dest[0] + ", ɸʪ id = " + dest[1] +")\n");
	  hbw.write("¾ξ : ");
	  for(int i=2;i<dest.length;i++){
	    hbw.write(dest[i] + " ");
	  }
	  hbw.write("(ListVersion)\n");
	}
	else{
	  System.err.println("(ListVersion)HearLog Err: " + com
			     + "(0x" + (com/16)+(com%16) + ")");
	}
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
  }
    */
  /********************************************************************/
  /**
   * ȤİХ񤭹᥽åɡ<BR><BR>
   * @param hearType KA_HEAR_SAY  KA_HEAR_TELL Τɤ餫
   * @param senderID ľܤ
   * @param msgSet Message֥ȤVectorå
   **/
  public void writeHearLog(int hearType, int senderID, Vector msgSet){

    if(Parameter.HEAR_LOG){
      int hearTime = time;
      String hearTypeStr;
      if(hearType == KA_HEAR_SAY){
	hearTypeStr = "HearSayMessage";
      }
      else if(hearType == KA_HEAR_TELL){
	hearTypeStr = "HearTellMessage";
      }
      else{
	//System.err.println("̤ΤHearפǤ[writeHearLog()]");
	return;
      }
      int dataTime;
      int length;
      int command;
      int[] msgData;
      try{
	if(msgSet != null){
	  if(msgSet.size() != 0){
	    hbw.write(hearTypeStr + "(rcvTime= " +time+
		      "): sender... " +senderID+ ", receiver... " +id+ "\n");
	    Iterator it = msgSet.iterator();
	    while(it.hasNext()){
	      Message mes = (Message)it.next();
	      dataTime = mes.getDataTime();
	      length = mes.getMsgLength();
	      command = mes.getCommand();
	      msgData = mes.getMessage();
	      hbw.write("   dataTime: " +dataTime+ ", length: " +length+
			", command: " +command+ ", data: ");
	      for(int i=0; i<msgData.length; i++){
		hbw.write(msgData[i]+ " ");
	      }
	      hbw.write("\n");
	    }
	  }
	}
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
  }

  /********************************************************************/
  /**
   * Ȥθϥ񤭹᥽åɡ<BR><BR>
   * @param pos ObjectID
   * @param posext ObjectRoadλλεΥ
   **/
  public void writeSelfLog(int pos,double posext){
    
    if(Parameter.SELF_LOG){
      try{
	sbw.write("(time=" + time + "):id=" + id + " pos=" + pos + " pos_ext=" + posext + "\n");
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
  }

  /********************************************************************/
  /**
   * ȤΤ¾񤭹᥽åɡ<BR>
   * @param log ˽񤭹ߤʸ
  **/
  public void writeMiscLog(String log){

    if(Parameter.MISC_LOG){
      try{
	mbw.write("(" + time + "): " + log + "\n");
      }
      catch(Exception e){
	e.printStackTrace();
      }
    }
  }

  /********************************************************************/
  /**
   *  actionLogξܺ(üAction)Ȥʤprefix򵭽Ҥ,
   *  ʸ򥻥åȤ᥽åɡ<BR><BR>
   * @param str actionLog˾ܺ٤˽񤭹ߤʸ
   **/
  public void setPrefixActLog(String str){
    prefix = str;
  }

 /********************************************************************/  
  /**
   *  åȤΥॢȤꡣ<BR><BR>
   * @deprecated Υ᥽åɤɤƤФƤʤäƤ⤤⡩
   * @param t_length ॢȻ֡
   * @param dest ߾äƤObjectID [ rest()¹Ԥ뤿 ]
   **/
  public void setTimeout(int t_length,int dest){
    try{
      socket.setSoTimeout(t_length);
    }
    catch(Exception e){
      e.printStackTrace();
      rest(dest);
    }
  }

  /********************************************************************/  
}




