/*
  # HearInfoParser.java
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  # $Id: HearInfoParser.java,v 1.4.1 2004/06/02 22:27:52 honji Exp $
*/
package rescueAgent.ObjectSet;

import java.util.*;
import rescueAgent.IO.CommandTable;
import rescueAgent.Generic.Parameter;
import rescueAgent.RescueLib.ServerSetting;
import rescueAgent.RescueObject.*;

/**
 * ̿Ϥ뤿Υ饹
 **/
public class HearInfoParser implements AACommand,CommandTable,ObjectProperty{
  /********************************************************************/
  /** ֥ȾǼǡ١饹 <BR>
   *  (Database of all object information) <BR><BR>
   **/
  ObjectDatabase objectDB;
  /** SenseInfoParserΥ᥽åɤȤ񤬤뤿ѿǼ **/
  SenseInfoParser sip;
  /** KA_HEAR_SAYǼåϥåơ֥ **/
  private Hashtable rcvHearSayMsgTable;
  /** KA_HEAR_TELLǼåϥåơ֥ **/
  private Hashtable rcvHearTellMsgTable;
  /** ľǼåŪ˵Ƥåå **/
  private Vector newMsgSet;
  /** åѴ **/
  MessageConverter msgConverter = new MessageConverter();
  /** 줿֥ȤIDΥå **/
  private Vector renewObjectIDset = new Vector();

  /********************************************************************/
  // 󥹥ȥ饯

  public HearInfoParser(ObjectDatabase objectDatabase,
			SenseInfoParser senseInfoParser){
     objectDB = objectDatabase;
     sip = senseInfoParser;
     int storeNum = (int)(Parameter.MAX_SIMULATION_TIME*1.5)+7;
     rcvHearSayMsgTable = new Hashtable(storeNum);
     rcvHearTellMsgTable = new Hashtable(storeNum);
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /** KA_HEAR_* åϤ᥽å()<BR>
   * Ԥ̱ɤȽꤹ롣̱äϲ⤻˽λ롣
   * <BR> 쥹塼(߽+)äǥɤ򳫻Ϥ롣<BR>
   * Υ᥽åǤ,٥åɤǹȤ򤹤롣
   * ObjectID ,饹Vectorѿ˳Ǽ, ֤ͤȤƹObject
   * Sense֤褦ˤʤäƤ롣<BR>,å Hashtable
   * ˤݴɤƤΤ,  key ˤƼФȤǤ롣
   * <BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   * @param time å(msg_dataΥǡǤϤʤ!!)
   * @return Υ᥽åǹ֥ȤΥץѥƥ,
   *         Senseˤʤä(ۤ AgentViewer ѤǤΤ߻Ȥ)
   *         åʤä䥨顼ˤ null ֤롣
   **/
  public int[] parseHearInfo(int[] msg_header, byte[] msg_data, int time){
    Integer rcvTime = new Integer(time); // Υå
    Hashtable rcvMsgTable;
    if(msg_header[0] == KA_HEAR_SAY){
      rcvMsgTable = rcvHearSayMsgTable; // HEAR_SAY Ѥ Hashtable 򥻥å
    }
    else if(msg_header[0] == KA_HEAR_TELL){
      rcvMsgTable = rcvHearTellMsgTable; // HEAR_TELL Ѥ Hashtable 򥻥å
    }
    else{
      //System.err.print("ͽʤإåǤ[parseHearInfo()]:");
      //System.err.println(" header="+msg_header[0]);
      return null; // 顼Ȥnull֤
    }
    int senderID = msg_header[3]; // Ծ򥻥å
    if(objectDB.hasCivilianObject(senderID)
       && !objectDB.hasFireBrigadeObject(senderID)
       && !objectDB.hasAmbulanceTeamObject(senderID)
       && !objectDB.hasPoliceForceObject(senderID)){ // פϻ̱ä
      return null; // Ȥꤢ,Ǥϲ⤷ʤƤȻפΤ֡
    }

    // ԤRescueAgentäǥɳϡ
    // θ Hashtableǡ١˥åǼ(ʳΣ)
    byte[] mainData = new byte[(msg_data.length)-4]; // ʬǼѿ
    // ǡƬΥåĹξ
    System.arraycopy(msg_data,4,mainData,0,(msg_data.length)-4);
    newMsgSet = msgConverter.decodeMessage(mainData); // ϥᥤ
    if(newMsgSet == null){
      return null; // åäΤǲ⤷ʤǽλ
    }
    else if(newMsgSet.size() == 0){
      return null; // åäΤǲ⤷ʤǽλ
    }	
    // ƱǴϤƤåФ
    Vector msgSet = (Vector)rcvMsgTable.get(rcvTime);
    if(msgSet == null){ // ϤƤåʤϿput
      rcvMsgTable.put(rcvTime, newMsgSet);
    }
    else{ // ϤƤåϥޡ
      Iterator it = newMsgSet.iterator();
      while(it.hasNext()){
	msgSet.add(it.next());
      }
      rcvMsgTable.put(rcvTime, msgSet);
    }

    // ϥå򣱤ģĸ, Ȥ򤹤(ʳΣ)
    Iterator it = newMsgSet.iterator();

    // ޤswitchʸʲѤѿ
    // {KA_HEAR_*,-1,-1,datatime}˽äƵ¤إå
    int[] header = {msg_header[0],-1,-1,-1}; // datatimeϸ夫
    int[] mesData; // åǡѿ
    int typeA; // AgentTYPE
    int typeO; // ObjectTYPE
    int humanID; // ư()֥ID
    int objectID; // ʪID(ǤϷʪƻϩ)
    int position; // ݥ(ȤΤ륪֥ID)
    int buildingFieryness; // ׷ʪFieryness
    int hp; // ׼HP
    int buriedness; // ׼Ԥ
    int damage; // ׼ԤDamage
    int block; // ƻϩĺ[mm]
    int waterQuantity; // Ŀ[åȥ]

    // ֤򤹤
    int[] updatedata; // ֤
    int[] tempdata = new int[Parameter.TELL_MAX_BYTE*2]; // (ǿŬ)
    // ǿ, TELL_MAX_BYTE2ܤϼäȤʤ­!!
    // ToDo:ޤǿηˡͤ뤳!!
    int tempindex = 0; // Ǽǡνλ(Ǽ뤿ӤѲ)

    while(it.hasNext()){
      Message mes = (Message)it.next();
      header[3] = mes.getDataTime(); // ¤إådatatime򥻥å
      switch(mes.getCommand()){
      case AA_SENSE_FB:
      case AA_SENSE_FS:
      case AA_SENSE_AT:
      case AA_SENSE_AC:
      case AA_SENSE_PF:
      case AA_SENSE_PO:
	mesData = mes.getMessage();
	sip.parseSenseInfo(header,mesData,getRenewObjectsID()); // ݤʤ
	System.arraycopy(mesData,0,tempdata,
			 tempindex,(mesData.length)-1); // 01;ʬʤΤ
	//tempindex += (mesData.length)-1; // ֤dataγǼȽü֤ι
	break;
      case AA_MOVE_FB:
      case AA_MOVE_AT:
      case AA_MOVE_PF:
	// ToDo: ̤äƤǤⲿ⤷ʤ
	break;
      case AA_BURIED_MYSELF_FB:
      case AA_BURIED_MYSELF_AT:
      case AA_BURIED_MYSELF_PF:
      case AA_BURIED_CIVILIAN_FB:
      case AA_BURIED_CIVILIAN_AT:
      case AA_BURIED_CIVILIAN_PF:
	mesData = mes.getMessage();
	if(mesData.length != 6){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(6)..."+mesData.length);
	  break; // switchʸȴ
	}
	typeA = getType(mes.getCommand()); // TYPE
	typeO = ServerSetting.TYPE_BUILDING; // ʪTYPE
	humanID = mesData[0]; // ׼ID
	objectID = mesData[1]; // ׷ʪID
        position = objectID; // ݥ
	buildingFieryness = mesData[2]; // ׷ʪFieryness
	hp = mesData[3]; // ׼HP
	buriedness = mesData[4]; // ׼Ԥ
	damage = mesData[5]; // ׼ԤDamage
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata1 = {typeA,humanID,PROPERTY_POSITION,position,
			     PROPERTY_POSITION_EXTRA,0,PROPERTY_HP,hp,
			     PROPERTY_BURIEDNESS,buriedness,PROPERTY_DAMAGE,
			     damage,0,
			     typeO,objectID,PROPERTY_FIERYNESS,
			     buildingFieryness,0,0};
	sip.parseSenseInfo(header,updatedata1,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata1,0,tempdata,
			 tempindex,(updatedata1.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata1.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_HALT_FB:
      case AA_HALT_AT:
      case AA_HALT_PF:
	mesData = mes.getMessage();
	if(mesData.length != 2){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(2)..."+mesData.length);
	  break; // switchʸȴ
	} // Ǥ break  case AA_CONGESTED_* ˿ʤ
      case AA_CONGESTED_FB:
      case AA_CONGESTED_AT:
      case AA_CONGESTED_PF:
	mesData = mes.getMessage();
	if(mes.getCommand() == AA_CONGESTED_FB ||
	   mes.getCommand() == AA_CONGESTED_AT ||
	   mes.getCommand() == AA_CONGESTED_PF){ // 夫³褿ѥ
	  if(mesData.length != 3){
	    //System.err.print("äHearǡ: command..."+mes.getCommand());
	    //System.err.println(", datasize(3)..."+mesData.length);
	    break; // switchʸȴ
	  }
	} // 夫³褿Ϥϥѥ ޤ
	typeA = getType(mes.getCommand()); // TYPE
	humanID = mesData[0]; // MyID
        position = mesData[1]; // ݥ
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata2 = {typeA,humanID,PROPERTY_POSITION,position,
			     PROPERTY_POSITION_EXTRA,0,0,0};
	sip.parseSenseInfo(header,updatedata2,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata2,0,tempdata,
			 tempindex,(updatedata2.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata2.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_BLOCKADE_FB:
      case AA_BLOCKADE_AT:
      case AA_BLOCKADE_PF:
	mesData = mes.getMessage();
	if(mesData.length != 2){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(2)..."+mesData.length);
	  break; // switchʸȴ
	}
	typeO = getType(mes.getCommand()); // ƻϩTYPE
	objectID = mesData[0]; // ƻϩID
	Road r = objectDB.getRoadObject(objectID);
	if(r == null){
	  //System.err.println("äƻϩID: id..."+objectID);
	  break; // switchʸȴ
	}
	block = (int)(r.getWidth()*mesData[1]/100); // ĺ
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata3 = {typeO,objectID,PROPERTY_BLOCK,block,
			     PROPERTY_REPAIR_COST,1,0,0};
	sip.parseSenseInfo(header,updatedata3,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata3,0,tempdata,
			 tempindex,(updatedata3.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata3.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_JUST_FIRE_FB:
      case AA_JUST_FIRE_FS:
      case AA_JUST_FIRE_AT:
      case AA_JUST_FIRE_AC:
      case AA_JUST_FIRE_PF:
      case AA_JUST_FIRE_PO:
	mesData = mes.getMessage();
	if(mesData.length != 1){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(1)..."+mesData.length);
	  break; // switchʸȴ
	}
	typeO = getType(mes.getCommand()); // ʪTYPE
	objectID = mesData[0]; // ʪID
	Building b = objectDB.getBuildingObject(objectID);
	if(b == null){
	  //System.err.println("äʪID: id..."+objectID);
	  break; // switchʸȴ
	}
	else if(b.getFieryness() == 0){ // ޤвФƤʤ
	  // SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	  int[] updatedata4 = {typeO,objectID,PROPERTY_FIERYNESS,1,0,0};
	  sip.parseSenseInfo(header,updatedata4,getRenewObjectsID()); // ݤʤ
	  System.arraycopy(updatedata4,0,tempdata,tempindex,
			   (updatedata4.length)-1); // 01;ʬʤΤ
	  tempindex += (updatedata4.length)-1; // ֤dataǼȽüֹ
	}
	else if(mes.getDataTime()
		< b.getIgnitionTime()){ // ¤ϤäǳƤ
	  b.setIgnitionTime(mes.getDataTime()); // влͤ˥å
	  setRenewObjectID(new Integer(objectID)); // Ͽ
	}
	else{ // ǡ˽вФȤΤäƤ
	} // äƲ⤻˽λ
	break;
      case AA_EXTINGUISH_FIN:
	mesData = mes.getMessage();
	if(mesData.length != 2){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(2)..."+mesData.length);
	  break; // switchʸȴ
	}
	typeO = getType(mes.getCommand()); // ʪTYPE
	objectID = mesData[1]; // ʪID
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata5 = {typeO,objectID,PROPERTY_FIERYNESS,6,0,0};
	sip.parseSenseInfo(header,updatedata5,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata5,0,tempdata,tempindex,
			 (updatedata5.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata5.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_REFILL:
      case AA_REFILL_FIN:
	mesData = mes.getMessage();
	if(mes.getCommand() == AA_REFILL){ // äȤʤ
	  if(mesData.length != 2){
	    //System.err.print("äHearǡ: command..."+mes.getCommand());
	    //System.err.println(", datasize(2)..."+mesData.length);
	    break; // switchʸȴ
	  }
	  waterQuantity = mesData[1]*1000;
	}
	else if(mes.getCommand() == AA_REFILL_FIN){ // äȤʤ
	  if(mesData.length != 1){
	    //System.err.print("äHearǡ: command..."+mes.getCommand());
	    //System.err.println(", datasize(1)..."+mesData.length);
	    break; // switchʸȴ
	  }
	  waterQuantity = Parameter.MAX_TANK_QUANT;
	}
	else{
	  //System.err.print("ˤϤʤϤ: command..."+mes.getCommand());
	  break;
	}
	typeA = getType(mes.getCommand()); // TYPE
	humanID = mesData[0]; // ID
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata6 = {typeA,humanID,PROPERTY_WATER_QUANTITY,
			     waterQuantity,0,0};
	sip.parseSenseInfo(header,updatedata6,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata6,0,tempdata,tempindex,
			 (updatedata6.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata6.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_RESCUE_FIN:
	mesData = mes.getMessage();
	if(mesData.length != 2){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(2)..."+mesData.length);
	  break; // switchʸȴ
	}
	typeA = getType(mes.getCommand()); // TYPE
	humanID = mesData[1]; // ׼ID
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata7 = {typeA,humanID,PROPERTY_BURIEDNESS,0,0,0};
	sip.parseSenseInfo(header,updatedata7,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata7,0,tempdata,tempindex,
			 (updatedata7.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata7.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_LOADING:
	mesData = mes.getMessage();
	if(mesData.length != 2){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(2)..."+mesData.length);
	  break; // switchʸȴ
	}
	typeA = getType(mes.getCommand()); // TYPE
	humanID = mesData[1]; // (оݼ)ID
        position = mesData[0]; // ݥ(ߵξ˾äƤΤ)
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata8 = {typeA,humanID,PROPERTY_POSITION,position,
			     PROPERTY_POSITION_EXTRA,0,0,0};
	sip.parseSenseInfo(header,updatedata8,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata8,0,tempdata,tempindex,
			 (updatedata8.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata8.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_CLEAR_FIN:
	mesData = mes.getMessage();
	if(mesData.length != 2){
	  //System.err.print("äHearǡ: command..."+mes.getCommand());
	  //System.err.println(", datasize(2)..."+mesData.length);
	  break; // switchʸȴ
	}
	typeO = getType(mes.getCommand()); // ƻϩTYPE
	objectID = mesData[1]; // ƻϩID
	// SenseInfoParser.parseSenseInfo()˴ꤲ뤿Υǡ
	int[] updatedata9 = {typeO,objectID,PROPERTY_BLOCK,0,
			     PROPERTY_REPAIR_COST,0,0,0};
	sip.parseSenseInfo(header,updatedata9,getRenewObjectsID()); // ݤʤ
	System.arraycopy(updatedata9,0,tempdata,
			 tempindex,(updatedata9.length)-1); // 01;ʬʤΤ
	tempindex += (updatedata9.length)-1; // ֤dataǼȽüֹ
	break;
      case AA_REST_FB:
      case AA_REST_AT:
      case AA_REST_PF:
      case AA_HEAR_BURIED_CIVILIAN_FB:
      case AA_HEAR_BURIED_CIVILIAN_FS:
      case AA_HEAR_BURIED_CIVILIAN_AT:
      case AA_HEAR_BURIED_CIVILIAN_AC:
      case AA_HEAR_BURIED_CIVILIAN_PF:
      case AA_HEAR_BURIED_CIVILIAN_PO:
      case AA_MOVE_ASIDE_FB:
      case AA_MOVE_ASIDE_AT:
      case AA_MOVE_ASIDE_PF:
      case AA_WOULD_GROUP:
      case AA_GROUP_RECIP:
      case AA_GROUP_REJCT:
      case AA_GROUP_MAKED:
      case AA_GROUP_BROKE:
      case AA_GROUP_RELEASE:
      case AA_EXTINGUISH:
      case AA_RESCUE:
      case AA_LOAD:
      case AA_UNLOAD:
      case AA_CLEAR:
	break; // 饳ޥɤλϹϹԤʤʤ
      default:
	//System.err.print("̤ޥɤǤ[parseHearInfo()] : ");
	//System.err.println(mes.getCommand());
      }//end switch(mes.getCommand())
    }//end while(it.hasNext())
    tempdata[tempindex++] = 0; // λɤ

    // Ǹ֤Ѥƽλ(ʳΣ)
    updatedata = new int[tempindex];
    System.arraycopy(tempdata,0,updatedata,0,tempindex);
    return updatedata; // ֥ȥץѥƥ֤(AgentViewer)
  }

  /********************************************************************/
  /** Ϥ줿 AACommand ,ɬפʥ֥ȤΥפ֤<BR>
   * â,ޥ AA_BURIED_* ˴ؤƤ,
   * ɬפʥ֥ȥפ¸ߤΤ,
   * Ū˶̤ɬפʰưΥ֥ȤΥפ֤Ȥˤ롣
   * <BR><BR>
   * @param hearCommand AACommand 줿
   * @return ServerSetting.java 줿 ObjectTYPE ͡
   *         ֤ͤɬפΤʤ, ڤӳ AACommand
   *         ʤ, ֤ -1
   **/
  private int getType(int hearCommand){
    int type;
    switch(hearCommand){
    case AA_BURIED_MYSELF_FB:
    case AA_MOVE_FB:
    case AA_HALT_FB:
    case AA_CONGESTED_FB:
      type = ServerSetting.TYPE_FIREBRIGADE;
      break;
    case AA_BURIED_MYSELF_AT:
    case AA_MOVE_AT:
    case AA_HALT_AT:
    case AA_CONGESTED_AT:
      type = ServerSetting.TYPE_AMBULANCETEAM;
      break;
    case AA_BURIED_MYSELF_PF:
    case AA_MOVE_PF:
    case AA_HALT_PF:
    case AA_CONGESTED_PF:
      type = ServerSetting.TYPE_POLICEFORCE;
      break;
    case AA_BURIED_CIVILIAN_FB:
    case AA_BURIED_CIVILIAN_AT:
    case AA_BURIED_CIVILIAN_PF:
    case AA_RESCUE_FIN:
    case AA_LOADING:
      type = ServerSetting.TYPE_CIVILIAN;
      break;
    case AA_BLOCKADE_FB:
    case AA_BLOCKADE_AT:
    case AA_BLOCKADE_PF:
    case AA_CLEAR_FIN:
      type = ServerSetting.TYPE_ROAD;
      break;
    case AA_JUST_FIRE_FB:
    case AA_JUST_FIRE_FS:
    case AA_JUST_FIRE_AT:
    case AA_JUST_FIRE_AC:
    case AA_JUST_FIRE_PF:
    case AA_JUST_FIRE_PO:
    case AA_EXTINGUISH_FIN:
      type = ServerSetting.TYPE_BUILDING;
      break;
    default:
      type = -1;
    }// end switch(hearCommand)
    return type;
  }

  /********************************************************************/
  /** ϥåơ֥뤫,ǻꤷ HearSay å
   * Vector åȤ֤<BR><BR>
   * @param time ߤ HearSay åμ
   * @return Vector åȤˤʤäƤ HearSay å
   *         ꤷ˥åʤä null ֤롣
   **/
  public Vector getHearSayMessageSet(int time){
    return (Vector)rcvHearSayMsgTable.get(new Integer(time));
  }

  /********************************************************************/
  /** ϥåơ֥뤫,ǻꤷ HearTell å
   * Vector åȤ֤<BR><BR>
   * @param time ߤ HearTell åμ
   * @return Vector åȤˤʤäƤ HearTell å
   *         ꤷ˥åʤä null ֤롣
   **/
  public Vector getHearTellMessageSet(int time){
    return (Vector)rcvHearTellMsgTable.get(new Integer(time));
  }

  /********************************************************************/
  /** ľ parseHearInfo() ˤФ줿MessageΥåȤ֤<BR>
   * , parseHearInfo() ˳ǼƤåȤϼФʤ<BR>
   * Τ褦ʥåȤФˤ getHear*MessageSet() Ѥ롣<BR><BR>
   * @return ľ parseHearInfo() ˤФ줿MessageVectoråȡ
   *         åʤä null ֤롣
   **/
  public Vector getJustNowMessageSet(){
    return newMsgSet;
  }

  /********************************************************************/
  /**
   * Τä֥ȤIDꥹȤ֤<BR> Τˤ, 
   * clearRenewObjectsID() Ǿ򥯥ꥢ鸽ߤޤǤ KA_HEAR_*
   * ˤäƾ󤬹줿֥ȤIDΥꥹȤ֤<BR><BR>
   * @return ObjectIDΥꥹ
   **/
  public Vector getRenewObjectsID(){
    return renewObjectIDset;
  }

  /********************************************************************/
  /**
   * Τä֥ȤIDꥹȤ˥åȤ롣<BR>
   * ΤȤʤ顢Υ饹ʳϤΥ᥽åɤϸƤ٤ʤ<BR><BR>
   * @param id ΤäObjectID
   **/
  private void setRenewObjectID(Integer id){
    renewObjectIDset.add(id);
  }

  /********************************************************************/
  /**
   * ޤǤΥ֥ȤIDꥹȤ򥯥ꥢ롣<BR>
   * Υ饹ǤϥꥢϹԤʤʤä,
   * ̥饹ǤŪ˹Ԥʤʤ,
   * ꥹȤä³뤳Ȥˤʤ롣<BR><BR>
   **/
  public void clearRenewObjectsID(){
    renewObjectIDset.clear();
  }

  /********************************************************************/
}
