/*
  # MessageConverter.java
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  # $Id: MessageConverter.java,v 1.4.1 2002/06/02 22:42:04 honji Exp $
*/
package rescueAgent.ObjectSet;

import rescueAgent.RescueObject.ObjectProperty;
import java.util.*;

/**
 * å̿Ѥ沽ꡢѤ沽ꤹ뤿Υ饹
 **/
public class MessageConverter implements AACommand, ObjectProperty{
  /********************************************************************/
  /** åΥˡ(Ȥʤ) **/
  public static final int NO_SORT = 0;
  /** åΥˡ(ֽ˥) **/
  public static final int SORT_BY_TIME = 1;
  /** åΥˡ(ٽ˥) **/
  public static final int SORT_BY_IMPORTANCE = 2;
  /** åΥˡ(å礭˥) **/
  public static final int SORT_BY_MESSAGE_SIZE_LARGER = 3;
  /** åΥˡ(åξ˥) **/
  public static final int SORT_BY_MESSAGE_SIZE_SMALLER = 4;
  /** åΥˡ(ֽ[+ٽ]˥) **/
  public static final int SORT_BY_TIME_AND_IMPORTANCE = 5;
  /** åΥˡ(ֽ[+å礭]˥) **/
  public static final int SORT_BY_TIME_AND_SIZE_LARGER = 6;
  /** åΥˡ(ֽ[+ٽ[+Message礭]]˥) **/
  public static final int SORT_BY_TIME_AND_IMPORTANCE_AND_SIZE_LARGER = 7;
  /** åΥˡ(ٽ[+ֽ]˥) **/
  public static final int SORT_BY_IMPORTANCE_AND_TIME = 8;
  /** åΥˡ(ٽ[+ֽ[+Message礭]]˥) **/
  public static final int SORT_BY_IMPORTANCE_AND_TIME_AND_SIZE_LARGER = 9;
  /** åΥˡ(å礭[+ֽ]˥) **/
  public static final int SORT_BY_MESSAGE_SIZE_LARGER_AND_TIME = 10;
  /** åΥˡ(åξ[+ֽ]˥) **/
  public static final int SORT_BY_MESSAGE_SIZE_SMALLER_AND_TIME = 11;

  /********************************************************************/
  // 󥹥ȥ饯

  public MessageConverter(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /** Vector˳Ǽ줿MessageΥåȤ̿Ѥbyte沽롣<BR>
   * 沽κݤˡ⤷å¥Ķϡ
   * ϰ˼ޤäå沽ޤʤäʬ
   * 沽ե饰falseˤ򽪤롣<BR><BR>
   * @param msgSet Vector˳Ǽ줿MessageΥå
   * @param sortType Message沽ݤγǼ
   * @param maxByte ХȤޤǥå뤫
   * @return ̿Ѥbyte沽줿åǡ
   **/
  public byte[] encodeMessage(Vector msgSet, int sortType, int maxByte){

    byte[] tmpMsg = new byte[maxByte]; // 
    byte[] encodeMsg; // ºݤΥå

    if(msgSet == null){
      return null; // å̵Τnull֤
    }
    else if(msgSet.size() == 0){
      return null; // å̵Τnull֤
    }
    // SortTypeʣܤΥȤϴܥȤʣԤʤȤǼ¸
    // â饽Ȥϥåν¤˼褦ʥȤλ
    // ʤΤǡ׻֤硪[ꡢ2*O(n^2) n:Messages Ȥʤ롪]
    // än礭(n>500)ϰʲΥƥ󥰤ϻȤ٤Ǥʤ
    switch(sortType){
    case NO_SORT:
      // Ȥʤ
      break;
    case SORT_BY_TIME:
    case SORT_BY_IMPORTANCE:
    case SORT_BY_MESSAGE_SIZE_LARGER:
    case SORT_BY_MESSAGE_SIZE_SMALLER:
      // ñ order ˤ륽
      sortMessage(msgSet,sortType);
      break;
    case SORT_BY_TIME_AND_IMPORTANCE:
      // ֽ[+ٽ]˥
      sortMessage(msgSet,SORT_BY_IMPORTANCE);
      sortMessage(msgSet,SORT_BY_TIME);
      break;
    case SORT_BY_TIME_AND_SIZE_LARGER:
      // ֽ[+å礭]˥
      sortMessage(msgSet,SORT_BY_MESSAGE_SIZE_LARGER);
      sortMessage(msgSet,SORT_BY_TIME);
      break;
    case SORT_BY_TIME_AND_IMPORTANCE_AND_SIZE_LARGER:
      // ֽ[+ٽ[+å礭]]˥
      // ׻ַ¬Ѥ(PenIV 2.8GHz,msgSet.size()=20 ΤȤ time=0.7msec)
      sortMessage(msgSet,SORT_BY_MESSAGE_SIZE_LARGER);
      sortMessage(msgSet,SORT_BY_IMPORTANCE);
      sortMessage(msgSet,SORT_BY_TIME);
      break;
    case SORT_BY_IMPORTANCE_AND_TIME:
      // ٽ[+ֽ]˥
      sortMessage(msgSet,SORT_BY_TIME);
      sortMessage(msgSet,SORT_BY_IMPORTANCE);
      break;
    case SORT_BY_IMPORTANCE_AND_TIME_AND_SIZE_LARGER:
      // ٽ[+ֽ[+å礭]]˥
      sortMessage(msgSet,SORT_BY_MESSAGE_SIZE_LARGER);
      sortMessage(msgSet,SORT_BY_TIME);
      sortMessage(msgSet,SORT_BY_IMPORTANCE);
      break;
    case SORT_BY_MESSAGE_SIZE_LARGER_AND_TIME:
      // å礭[+ֽ]˥
      sortMessage(msgSet,SORT_BY_TIME);
      sortMessage(msgSet,SORT_BY_MESSAGE_SIZE_LARGER);
      break;
    case SORT_BY_MESSAGE_SIZE_SMALLER_AND_TIME:
      // åξ[+ֽ]˥
      sortMessage(msgSet,SORT_BY_TIME);
      sortMessage(msgSet,SORT_BY_MESSAGE_SIZE_SMALLER);
      break;
    default:
      // ¸ߤʤȥפʤΤǲ⤷ʤ֤ͤnull
      //System.err.println("¸ߤʤȥפǤ("+sortType+")");
      return null;
    }// end switch(sortType)

    // ºݤ沽Ԥʤʬ
    int index = 0; // tmpMsgbyte˽񤭹
    Message prevMsg = null; // 1Υå
    Iterator it = msgSet.iterator();
    while(it.hasNext()){ // å̵ʤޤǷ֤
      Message msg = (Message)it.next();
      if(prevMsg == null){ // 󡢤⤷ľ顼äϤ̤
	// ǽbyteĶƤ뤫ɤγǧ
	if(index +2+2 >= tmpMsg.length){ // 2...data, 2...endCode
	  //System.err.print("ǽByteε̤Ķ衪");
	  //System.err.print("[encodeMessage()] ľΥå");
	  //System.err.println("ǼǤޤǤ");
	  msg.setEncodeOK(false); // Υå沽(falseǼ)
	  break; // while(it.hasNext())ȴơ沽λ
	}
	// ־byte˳Ǽ  : 2Bytes
	tmpMsg[index++] = (byte)((msg.getDataTime() & 0x0000FF00) >> 8);
	tmpMsg[index++] = (byte)(msg.getDataTime() & 0x000000FF);
      }
      else if(msg.getDataTime() != prevMsg.getDataTime()){ // 郎Ѥä
	// ǽbyteĶƤ뤫ɤγǧ
	if(index +3+2 >= tmpMsg.length){ // 3...data, 2...endCode
	  //System.err.print("ǽByteε̤Ķ衪");
	  //System.err.print("[encodeMessage()] ľΥå");
	  //System.err.println("ǼǤޤǤ");
	  msg.setEncodeOK(false); // Υå沽(falseǼ)
	  break; // while(it.hasNext())ȴơ沽λ
	}	    
	tmpMsg[index++] = 0; // ޤǤλǤΥǡνλ
	// ־byte˳Ǽ  : 2Bytes
	tmpMsg[index++] = (byte)((msg.getDataTime() & 0x0000FF00) >> 8);
	tmpMsg[index++] = (byte)(msg.getDataTime() & 0x000000FF);
      }

      // åƤbyte˳Ǽ()֤ͤϳǼbyte
      int next = encodeCommandData(index, msg, tmpMsg);

      if(next != -1){ // åmsg沽Ǥ
	prevMsg = msg;
	index += next;
	if(!prevMsg.getEncodeOK()){ // ǼByte󤬵̤򥪡С
	  break; // while(it.hasNext())ȴơ沽λ
	}
      }
      else{ // åmsg沽Ǥʤä
	//System.err.println("å沽˼ԡ[encodeMessage()]");
	msg.setEncodeOK(false); // Υå沽(falseǼ)
	if(prevMsg == null){ // 󡢤⤷ľ顼ä
	  index -= 2; // Υåmsg̵뤷ƼΥåǼ
	}
	else if(msg.getDataTime() != prevMsg.getDataTime()){ // 郎Ѳ
	  index -= 2; // Υåmsg̵뤷ƼΥåǼ
	  prevMsg = null; // ľΥå򥯥ꥢ
	}
      }
    }
    if(index != 0){ // ̤ʤ(index=0λ)ϥǡλס
      tmpMsg[index++] = 0; // ޤǤλǤΥǡνλ
    }
    tmpMsg[index++] = 0; // åνλ
    tmpMsg[index++] = 0; // ƱϽλɤȤ2BytesɬפʤΤ

    encodeMsg = new byte[index]; // ֤Ѥ
    System.arraycopy(tmpMsg,0,encodeMsg,0,index); // ԡ
    return encodeMsg;
  }

  /********************************************************************/
  /** ĤΥå沽byte롣
   * @param start byte񤭹߳ϰ
   * @param msg Messageå
   * @param encodeMsg 񤭹ߤԤʤbyte
   * @return 񤭹byte
   **/
  private int encodeCommandData(int start, Message msg, byte[] encodeMsg){

    int offset = 0; // Υ᥽åǽ񤭹byte
    int command = msg.getCommand();
    // ǽbyteĶƤ뤫ɤγǧ
    if((start+offset)+1+3 >= encodeMsg.length){ // 1...data, 3...endCode
      //System.err.print("ǽByteε̤Ķ衪");
      //System.err.print("[encodeCommandData()] ľΥå");
      //System.err.println("ޤǤǼƤʤΤǳǼ԰Ǥ");
      msg.setEncodeOK(false); // Υå沽(falseǼ)
      return offset; // 񤭹᤿ޤǤbyte֤
    }
    // ޥɾbyte˳Ǽ  : 1Byte
    encodeMsg[start+(offset++)] = (byte)(command & 0x000000FF);

    // ޥ̤沽ؿƤӽФ
    switch(command){
    case AA_SENSE_FB:
    case AA_SENSE_FS:
    case AA_SENSE_AT:
    case AA_SENSE_AC:
    case AA_SENSE_PF:
    case AA_SENSE_PO:
      offset += encodeSenseData(start+offset, msg, encodeMsg);
      break;
    case AA_MOVE_FB:
    case AA_MOVE_AT:
    case AA_MOVE_PF:
      offset += encodeMoveData(start+offset, msg, encodeMsg);
      break;
    case AA_BURIED_MYSELF_FB:
    case AA_BURIED_MYSELF_AT:
    case AA_BURIED_MYSELF_PF:
    case AA_BURIED_CIVILIAN_FB:
    case AA_BURIED_CIVILIAN_AT:
    case AA_BURIED_CIVILIAN_PF:
      offset += encodeBuriedData(start+offset, msg, encodeMsg);
      break;
    case AA_BLOCKADE_FB:
    case AA_BLOCKADE_AT:
    case AA_BLOCKADE_PF:
    case AA_REFILL:
      offset += encodeBlockadeOrRefillData(start+offset, msg, encodeMsg);
      break;
    case AA_EXTINGUISH:
      offset += encodeExtinguishData(start+offset, msg, encodeMsg);
      break;
    case AA_REST_FB:
    case AA_REST_AT:
    case AA_REST_PF:
    case AA_HEAR_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FS:
    case AA_HEAR_BURIED_CIVILIAN_AT:
    case AA_HEAR_BURIED_CIVILIAN_AC:
    case AA_HEAR_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_PO:
    case AA_HALT_FB:
    case AA_HALT_AT:
    case AA_HALT_PF:
    case AA_CONGESTED_FB:
    case AA_CONGESTED_AT:
    case AA_CONGESTED_PF:
    case AA_JUST_FIRE_FB:
    case AA_JUST_FIRE_FS:
    case AA_JUST_FIRE_AT:
    case AA_JUST_FIRE_AC:
    case AA_JUST_FIRE_PF:
    case AA_JUST_FIRE_PO:
    case AA_MOVE_ASIDE_FB:
    case AA_MOVE_ASIDE_AT:
    case AA_MOVE_ASIDE_PF:
    case AA_WOULD_GROUP:
    case AA_GROUP_RECIP:
    case AA_GROUP_REJCT:
    case AA_GROUP_MAKED:
    case AA_GROUP_BROKE:
    case AA_GROUP_RELEASE:
    case AA_EXTINGUISH_FIN:
    case AA_REFILL_FIN:
    case AA_RESCUE:
    case AA_RESCUE_FIN:
    case AA_LOAD:
    case AA_LOADING:
    case AA_UNLOAD:
    case AA_CLEAR:
    case AA_CLEAR_FIN:
      offset += encodeStandardData(start+offset, msg, encodeMsg);
      break;
    default:
      //System.err.print("̤ޥɤǤ[encodeCommandData()] : ");
      //System.err.println(command);
    }//end switch(command)
    if(offset == 0){ // 沽˼Ԥ(command[1]+沽[-1]=[0])
      offset--; // offset[-1]˥å
    }
    return offset;
  }

  /********************************************************************/
  /** Ĥsenseå沽byte롣<BR>
   * ToDo: Υ󥹥ץѥƥ(Value=128,129,130,131,207,235,242)б
   * @param start byte񤭹߳ϰ
   * @param msg Messageå
   * @param encodeMsg 񤭹ߤԤʤbyte
   * @return 񤭹byte
   **/
  private int encodeSenseData(int start, Message msg, byte[] encodeMsg){

    int offset = 0; // Υ᥽åǽ񤭹byte
    int[] data = msg.getMessage(); // ºݤΥå
    int index = 0; // dataɤߤȤ֤ν
    if(data == null){ // data
      //System.err.println("󥹥ǡʤ衪[encodeSenseData()]");
      return -1; // [-1]֤
    }
    else if(data.length == 0){ // data
      //System.err.println("󥹥ǡʤ衪[encodeSenseData()]");
      return -1; // [-1]֤
    }
    while(data[index] != 0){
      if(index+2 >= data.length){ // 󥹥ǡλ
	//System.err.println("ä󥹥ǡ衪[encodeSenseData()]");
	return -1; // [-1]֤
      }
      // ǽbyteĶƤ뤫ɤγǧ
      if((start+offset)+5+4 >= encodeMsg.length){ // 5...data, 4...endCode
	//System.err.print("ǽByteε̤Ķ衪");
	//System.err.print("[encodeSenseData()] ľΥå");
	//System.err.println("ޤǤǼƤʤΤǳǼ԰Ǥ");
	encodeMsg[start+(offset++)] = -128; // commandλɤΥå
	msg.setEncodeOK(false); // Υå沽(falseǼ)
	return offset; // 񤭹᤿ޤǤbyte֤
      }	    
      // ֥TYPE  : 1Byte
      encodeMsg[start+(offset++)] = (byte)((data[index++]-128) & 0x000000FF);
      // ֥ID    : 4Bytes
      encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
      encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
      encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
      encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF);
      while(data[index] != 0){
	if(index+3 >= data.length){ // 󥹥ǡλ
	  //System.err.println("ä󥹥ǡ衪[encodeSenseData()]");
	  return -1; // [-1]֤
	}	    
	// ǽbyteĶƤ뤫ɤγǧ
	if((start+offset)+5+4 >= encodeMsg.length){ // 5...data, 4...endCode
	  //System.err.print("ǽByteε̤Ķ衪");
	  //System.err.print("[encodeSenseData()] ľΥå");
	  //System.err.println("ޤǤǼƤʤΤǳǼ԰Ǥ");
	  encodeMsg[start+(offset++)] = -128; // ObjTYPEλɤΥå
	  encodeMsg[start+(offset++)] = -128; // commandλɤΥå
	  msg.setEncodeOK(false); // Υå沽(falseǼ)
	  return offset; // 񤭹᤿ޤǤbyte֤
	}	    
        // ֥PROPERTY TYPE   : 1Byte
	encodeMsg[start+(offset++)] = (byte)((data[index++]-128) & 0x000000FF);

	// ͷӡ
	if(data[index-1] == 207){
	  while(data[index] != 0){
	    index++;
	  }
	}
	// ͷӡޤ

        // ֥PROPERTY VALUE  : 4Bytes
	encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
	encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
	encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
	encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF);
      }
      encodeMsg[start+(offset++)] = -128; // ObjTYPEλɤΥå
      index++;
    }
    encodeMsg[start+(offset++)] = -128; // commandλɤΥå
    index++;
    if(data.length != index){ // 󥹥ǡλ
      //System.err.println("ä󥹥ǡ衪[encodeSenseData()]");
      return -1; // [-1]֤
    }
    msg.setEncodeOK(true); // ̵Ǹޤ̲ᤷΤtrue
    return offset;
  }

  /********************************************************************/
  /** Ĥmoveå沽byte롣<BR>
   * ToDo: Υ᥽åɡޤ̤
   * @deprecated Υ᥽åɡޤ̤
   * @param start byte񤭹߳ϰ
   * @param msg Messageå
   * @param encodeMsg 񤭹ߤԤʤbyte
   * @return 񤭹byte
   **/
  private int encodeMoveData(int start, Message msg, byte[] encodeMsg){

    return -1; // Ȥꤢ顼ˤƤ
  }

  /********************************************************************/
  /** Ĥburiedå沽byte롣<BR>
   * @param start byte񤭹߳ϰ
   * @param msg Messageå
   * @param encodeMsg 񤭹ߤԤʤbyte
   * @return 񤭹byte(...16, ...-1 ꤨʤϤ)
   **/
  private int encodeBuriedData(int start, Message msg, byte[] encodeMsg){

    int offset = 0; // Υ᥽åǽ񤭹byte
    int[] data = msg.getMessage(); // ºݤΥå
    int index = 0; // dataɤߤȤ֤ν
    if(data == null){ // data
      //System.err.println("Buriedǡʤ衪[encodeBuriedData()]");
      return -1; // [-1]֤
    }
    else if(data.length == 0){ // data
      //System.err.println("Buriedǡʤ衪[encodeBuriedData()]");
      return -1; // [-1]֤
    }
    else if(data.length != 6){ // Buried data
      //System.err.println("äBuriedǡ衪[encodeBuriedData()]");
      return -1; // [-1]֤
    }
    // ǽbyteĶƤ뤫ɤγǧ
    if(start +15+2 >= encodeMsg.length){ // 15...data, 2...endCode
      //System.err.print("ǽByteε̤Ķ衪");
      //System.err.print("[encodeBuriedData()] ľΥå");
      //System.err.println("ǼǤޤǤ");
      return -1; // [-1]֤
    }

    // MyID(AA_BURIED_MYSELF_*),⤷ϻ̱ID(AA_BURIED_CIVILIAN_*)
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    // ׷ʪID
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    // ׷ʪFieryness
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 1Byte
    // MyHP(AA_BURIED_MYSELF_*),⤷ϻ̱HP(AA_BURIED_CIVILIAN_*)
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 2Bytes
    // My(AA_BURIED_MYSELF_*),⤷ϻ̱(AA_BURIED_CIVILIAN_*)
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 2Bytes
    // MyDamage(AA_BURIED_MYSELF_*),⤷ϻ̱Damage(AA_BURIED_CIVILIAN_*)
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 2Bytes

    msg.setEncodeOK(true); // ̵Ǹޤ̲ᤷΤtrue
    return offset;
  }

  /********************************************************************/
  /** Ĥextinguishå沽byte롣<BR>
   * @param start byte񤭹߳ϰ
   * @param msg Messageå
   * @param encodeMsg 񤭹ߤԤʤbyte
   * @return 񤭹byte
   **/
  private int encodeExtinguishData(int start, Message msg, byte[] encodeMsg){

    int offset = 0; // Υ᥽åǽ񤭹byte
    int[] data = msg.getMessage(); // ºݤΥå
    int index = 0; // dataɤߤȤ֤ν
    if(data == null){ // data
      //System.err.println("Extinguishǡʤ衪[encodeExtinguishData()]");
      return -1; // [-1]֤
    }
    else if(data.length == 0){ // data
      //System.err.println("Extinguishǡʤ衪[encodeExtinguishData()]");
      return -1; // [-1]֤
    }
    else if(data.length != 6){ // Extinguish data
      //System.err.println("äExtinguishǡ[encodeExtinguishData()]");
      return -1; // [-1]֤
    }
    // ǽbyteĶƤ뤫ɤγǧ
    if(start +22+2 >= encodeMsg.length){ // 22...data, 2...endCode
      //System.err.print("ǽByteε̤Ķ衪");
      //System.err.print("[encodeExtinguishData()] ľΥå");
      //System.err.println("ǼǤޤǤ");
      return -1; // [-1]֤
    }

    // MyID
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    // òзʪID
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    // ò
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    //  X ɸ
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    //  Y ɸ
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    // 
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 2Bytes

    msg.setEncodeOK(true); // ̵Ǹޤ̲ᤷΤtrue
    return offset;
  }

  /********************************************************************/
  /** Ĥrefillå沽byte롣<BR>
   * @param start byte񤭹߳ϰ
   * @param msg Messageå
   * @param encodeMsg 񤭹ߤԤʤbyte
   * @return 񤭹byte
   **/
  private int encodeBlockadeOrRefillData(int start,
					 Message msg,
					 byte[] encodeMsg){

    int offset = 0; // Υ᥽åǽ񤭹byte
    int[] data = msg.getMessage(); // ºݤΥå
    int index = 0; // dataɤߤȤ֤ν
    if(data == null){ // data
      //System.err.print("BlockadeOrRefillǡʤ衪");
      //System.err.println("[encodeBlockadeOrRefillData()]");
      return -1; // [-1]֤
    }
    else if(data.length == 0){ // data
      //System.err.print("BlockadeOrRefillǡʤ衪");
      //System.err.println("[encodeBlockadeOrRefillData()]");
      return -1; // [-1]֤
    }
    else if(data.length != 2){ // BlockadeOrRefill data
      //System.err.print("äBlockadeOrRefillǡ衪");
      //System.err.println("[encodeBlockadeOrRefillData()]");
      return -1; // [-1]֤
    }
    // ǽbyteĶƤ뤫ɤγǧ
    if(start +5+2 >= encodeMsg.length){ // 5...data, 2...endCode
      //System.err.print("ǽByteε̤Ķ衪");
      //System.err.print("[encodeBlockadeOrRefillData()] ľΥå");
      //System.err.println("ǼǤޤǤ");
      return -1; // [-1]֤
    }

    // MyID
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0xFF000000) >> 24);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x00FF0000) >> 16);
    encodeMsg[start+(offset++)] = (byte)((data[index] & 0x0000FF00) >>  8);
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 4Bytes
    // ĺ[:], ⤷ Ŀ[ton:]
    encodeMsg[start+(offset++)] = (byte)(data[index++] & 0x000000FF); // 1Byte

    msg.setEncodeOK(true); // ̵Ǹޤ̲ᤷΤtrue
    return offset;
  }

  /********************************************************************/
  /** Ĥstandard(ɸ)å沽byte롣<BR>
   * @param start byte񤭹߳ϰ
   * @param msg Messageå
   * @param encodeMsg 񤭹ߤԤʤbyte
   * @return 񤭹byte
   **/
  private int encodeStandardData(int start, Message msg, byte[] encodeMsg){

    int offset = 0; // Υ᥽åǽ񤭹byte
    int[] data = msg.getMessage(); // ºݤΥå
    int index = 0; // dataɤߤȤ֤ν
    int dataLength; // ޥ̤dataĹ

    switch(msg.getCommand()){
    case AA_HEAR_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FS:
    case AA_HEAR_BURIED_CIVILIAN_AT:
    case AA_HEAR_BURIED_CIVILIAN_AC:
    case AA_HEAR_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_PO:
    case AA_CONGESTED_FB:
    case AA_CONGESTED_AT:
    case AA_CONGESTED_PF:
      dataLength = 3;
      break;
    case AA_HALT_FB:
    case AA_HALT_AT:
    case AA_HALT_PF:
    case AA_MOVE_ASIDE_FB:
    case AA_MOVE_ASIDE_AT:
    case AA_MOVE_ASIDE_PF:
    case AA_EXTINGUISH_FIN:
    case AA_RESCUE:
    case AA_RESCUE_FIN:
    case AA_LOAD:
    case AA_LOADING:
    case AA_UNLOAD:
    case AA_CLEAR:
    case AA_CLEAR_FIN:
      dataLength = 2;
      break;
    case AA_REST_FB:
    case AA_REST_AT:
    case AA_REST_PF:
    case AA_JUST_FIRE_FB:
    case AA_JUST_FIRE_FS:
    case AA_JUST_FIRE_AT:
    case AA_JUST_FIRE_AC:
    case AA_JUST_FIRE_PF:
    case AA_JUST_FIRE_PO:
    case AA_WOULD_GROUP:
    case AA_GROUP_RECIP:
    case AA_GROUP_REJCT:
    case AA_GROUP_MAKED:
    case AA_GROUP_BROKE:
    case AA_GROUP_RELEASE:
    case AA_REFILL_FIN:
      dataLength = 1;
      break;
    default:
      //System.err.print("ˤʤϤ[encodeStandardData()] : ");
      //System.err.println(msg.getCommand());
      return -1; // [-1]֤
    }//end switch(command)

    if(data == null){ // data
      //System.err.println("Standardǡʤ衪[encodeStandardData()]");
      return -1; // [-1]֤
    }
    else if(data.length == 0){ // data
      //System.err.println("Standardǡʤ衪[encodeStandardData()]");
      return -1; // [-1]֤
    }
    else if(data.length != dataLength){ // Standard data
      //System.err.println("äStandardǡ衪[encodeStandardData()]");
      return -1; // [-1]֤
    }
    // ǽbyteĶƤ뤫ɤγǧ   (dataLength*4)...data
    if(start +(dataLength*4)+2 >= encodeMsg.length){ //           2 ...endCode
      //System.err.print("ǽByteε̤Ķ衪");
      //System.err.print("[encodeStandardData()] ľΥå");
      //System.err.println("ǼǤޤǤ");
      return -1; // [-1]֤
    }

    for(int i=0; i<dataLength; i++){ // ƼǡγǼ
      encodeMsg[start+(offset++)] = (byte)((data[i] & 0xFF000000) >> 24);
      encodeMsg[start+(offset++)] = (byte)((data[i] & 0x00FF0000) >> 16);
      encodeMsg[start+(offset++)] = (byte)((data[i] & 0x0000FF00) >>  8);
      encodeMsg[start+(offset++)] = (byte)(data[i] & 0x000000FF); // 4Bytes
    }

    msg.setEncodeOK(true); // ̵Ǹޤ̲ᤷΤtrue
    return offset;
  }

  /********************************************************************/
  /** åorder˥ȡ<BR>
   * ȤϥåȤǤؤˡְij򴹡פ
   * ΤǤϤʤְjǤiǤפ롣(i &lt j) <BR><BR>
   * @param msgSet åå
   * @param order νǥȤ򤹤뤫
   **/
  public void sortMessage(Vector msgSet, int order){

    Message msg1;
    Message msg2;
    for(int i=0; i<msgSet.size()-1; i++){
      if(i != 0){
	msg1 = (Message)msgSet.get(i-1);
	msg2 = (Message)msgSet.get(i);
	if(isEqual(msg1,msg2,order)){ // orderӤͤäƱ
	  continue; // 촹Ƚɬפ̵ΤǰʲΥ롼פФ
	}
      }
      for(int j=i+1; j<msgSet.size(); j++){
	msg1 = (Message)msgSet.get(i);
	msg2 = (Message)msgSet.get(j);
	if(shouldExchange(msg1,msg2,order)){ // orderǤӤˤ򴹤ɬ
	  msgSet.remove(j); // 촹ΤǤϤʤ
	  msgSet.add(i,msg2); // ȤΤ⡢νݻ뤿
	}
      }//end for(int j=1; i<msgSet.size(); j++)
    }//end for(int i=0; i<msgSet.size()-1; i++)
  }

  /********************************************************************/
  /** Ϥ줿ĤΥåorderǻꤵ줿ѿɤ
   * <BR><BR>
   * @param msg1 Ӹå
   * @param msg2 Ӹå
   * @param order оѿ
   * @return ɤ
   **/
  private boolean isEqual(Message msg1, Message msg2, int order){
    int param1;
    int param2;
    switch(order){
    case SORT_BY_TIME:
      param1 = msg1.getDataTime();
      param2 = msg2.getDataTime();
      break;
    case SORT_BY_IMPORTANCE:
      param1 = msg1.getImportance();
      param2 = msg2.getImportance();
      break;
    case SORT_BY_MESSAGE_SIZE_LARGER:
    case SORT_BY_MESSAGE_SIZE_SMALLER:
      param1 = msg1.getMsgLength();
      param2 = msg2.getMsgLength();
      break;
    default:
      //System.err.println("ʤ order Ǥ[isEqual()]: Value = "+order);
      return false;
    }//end switch(order)
    return (param1 == param2);
  }

  /********************************************************************/
  /** Ϥ줿ĤΥåorderǻꤵ줿ѿ msg1.order,
   * msg2.order   msg1.order < msg2.order ɤ(㳰)
   * <BR><BR>
   * @param msg1 Ӹå
   * @param msg2 Ӹå
   * @param order оѿ
   * @return msg1.order < msg2.order ɤ(㳰)
   **/
  private boolean shouldExchange(Message msg1, Message msg2, int order){
    int param1;
    int param2;
    switch(order){
    case SORT_BY_TIME:
      param1 = msg1.getDataTime();
      param2 = msg2.getDataTime();
      break;
    case SORT_BY_IMPORTANCE:
      param1 = msg1.getImportance();
      param2 = msg2.getImportance();
      break;
    case SORT_BY_MESSAGE_SIZE_LARGER:
      param1 = msg1.getMsgLength();
      param2 = msg2.getMsgLength();
      break;
    case SORT_BY_MESSAGE_SIZE_SMALLER:
      param1 = msg2.getMsgLength(); // սΤ촹
      param2 = msg1.getMsgLength(); // СʲƱͤ˰
      break;
    default:
      //System.err.println("ʤ order Ǥ[shouldExchange()]: Value = "+order);
      return false;
    }//end switch(order)
    return (param1 < param2);
  }

  /********************************************************************/
  /** ̿ˤ沽줿byte椷Vector˳Ǽ롣<BR>
   * 沽κݤˡ⤷¤Ӥ򤷤ƤåĤäϡ
   * Υåޥɤ(̵)ΥåǼ
   * ƳƤ椯<BR><BR>
   * @param msgData ͥ뤫byte沽åǡâ,
   *                ǡΥåĹξϼƤɬפ롣
   * @return Message饹ΥåȤǼ줿Vector
   **/
  public Vector decodeMessage(byte[] msgData){

    if(msgData == null){
      //System.err.println("åǡޤ1[decodeMessage()]");
      return null; // åǡ̵Τnull֤
    }
    else if(msgData.length == 0){
      //System.err.println("åǡޤ2[decodeMessage()]");
      return null; // åǡ̵Τnull֤
    }

    int byteSize = msgData.length; // byteåǡĹ
    Vector msgSet = new Vector(); // 沽ΥåVectorå
    int index = 0; // msgDatabyte󤫤ɤ߹߰
    int msgTime = 0; // åλ֤Ǽѿ

    if(byteSize < 2){ // 沽åmsgData
      //System.err.print("沽åmsgData[decodeMessage()]");
      //System.err.println(": decodeλޤ");
      return null; // åǡʤΤnull֤
    }
    // åǡκǸޤɤ
    while(index+1 < byteSize){
      msgTime = (((int)msgData[index++] & 0xFF) << 8) |
	         ((int)msgData[index++] & 0xFF); // 2Bytes
      //System.out.println("time="+msgTime);
      if(msgTime == 0){ // åνλ
	//System.out.println("åνλ["+msgTime+"]:ｪλ");
	return msgSet; // ޤǳǼMessageåȤ֤
      }
      else{ // åޤ
	if(index >= byteSize){ // ǡä
	  //System.err.print("沽åcommandData1");
	  //System.err.println("[decodeMessage()]: decodeλޤ");
	  return msgSet;
	}    
	// ޤǤλǤΥǡνλ[0]ޤcommandȤɤ
	int command = ((int)msgData[index] & 0xFF);
	//System.out.println("command="+command);
	while((command=((int)msgData[index] & 0xFF)) != 0){
	  Message msg = new Message(msgTime); // å
	  // 沽å沽msg˳Ǽ()֤ͤɼäbyte
	  index += decodeCommandData(index,msgData,msg);
	  if(msg.getMsgLength() > 2){ // 沽ǤȤ(2...̿λ)
	    msg.setDataTime(msgTime); // 򥻥å
	    msgSet.add(msg); // ååȤ˥åɲ
	  }
	  else{ // 沽Ǥʤä
	    //System.err.print("沽åcommandData");
	    //System.err.println("[decodeMessage()]:Υޥɤߤޤ");
	  }
	  if(index >= byteSize){ // ǡä
	    //System.err.print("沽åcommandData2");
	    //System.err.println("[decodeMessage()]: decodeλޤ");
	    return msgSet;
	  }    
	}
	//System.out.print("ޤǤλǤΥǡνλ[");
	//System.out.println(command+"]");
	index++;
      }
      if(index+1 >= byteSize){ // ǡä
	//System.err.print("沽åcommandData3");
	//System.err.println("[decodeMessage()]: decodeλޤ");
	return msgSet;
      }
    }
    return msgSet;
  }

  /********************************************************************/
  /** ̿ˤ沽줿byte椷Message˳Ǽ롣<BR>
   * 沽κݤˡ⤷¤Ӥ򤷤ƤåĤäϡ
   * ֤ͤȤ[-1]֤Message˼ԤȤ롣<BR>
   * κݡMessageǡ(null)ˤƤ<BR><BR>
   * @param start byteɤ߹߳ϰ
   * @param data ͥ뤫byte沽åǡ
   * @param msg dataǼMessageå
   * @return ɤ߹byte
   **/
  private int decodeCommandData(int start, byte[] data, Message msg){

    int offset = 0; // Υ᥽åǽ񤭹byte
    int command = ((int)data[start+(offset++)] & 0xFF); // ޥɤ 1Byte
    msg.setCommand(command); // å˥ޥɾ򥻥å
    //System.out.println("command="+msg.getCommand());

    // ޥ̤沽ؿƤӽФ
    switch(command){
    case AA_SENSE_FB:
    case AA_SENSE_FS:
    case AA_SENSE_AT:
    case AA_SENSE_AC:
    case AA_SENSE_PF:
    case AA_SENSE_PO:
      offset += decodeSenseData(start+offset, data, msg);
      break;
    case AA_MOVE_FB:
    case AA_MOVE_AT:
    case AA_MOVE_PF:
      offset += decodeMoveData(start+offset, data, msg);
      break;
    case AA_BURIED_MYSELF_FB:
    case AA_BURIED_MYSELF_AT:
    case AA_BURIED_MYSELF_PF:
    case AA_BURIED_CIVILIAN_FB:
    case AA_BURIED_CIVILIAN_AT:
    case AA_BURIED_CIVILIAN_PF:
      offset += decodeBuriedData(start+offset, data, msg);
      break;
    case AA_BLOCKADE_FB:
    case AA_BLOCKADE_AT:
    case AA_BLOCKADE_PF:
    case AA_REFILL:
      offset += decodeBlockadeOrRefillData(start+offset, data, msg);
      break;
    case AA_EXTINGUISH:
      offset += decodeExtinguishData(start+offset, data, msg);
      break;
    case AA_REST_FB:
    case AA_REST_AT:
    case AA_REST_PF:
    case AA_HEAR_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FS:
    case AA_HEAR_BURIED_CIVILIAN_AT:
    case AA_HEAR_BURIED_CIVILIAN_AC:
    case AA_HEAR_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_PO:
    case AA_HALT_FB:
    case AA_HALT_AT:
    case AA_HALT_PF:
    case AA_CONGESTED_FB:
    case AA_CONGESTED_AT:
    case AA_CONGESTED_PF:
    case AA_JUST_FIRE_FB:
    case AA_JUST_FIRE_FS:
    case AA_JUST_FIRE_AT:
    case AA_JUST_FIRE_AC:
    case AA_JUST_FIRE_PF:
    case AA_JUST_FIRE_PO:
    case AA_MOVE_ASIDE_FB:
    case AA_MOVE_ASIDE_AT:
    case AA_MOVE_ASIDE_PF:
    case AA_WOULD_GROUP:
    case AA_GROUP_RECIP:
    case AA_GROUP_REJCT:
    case AA_GROUP_MAKED:
    case AA_GROUP_BROKE:
    case AA_GROUP_RELEASE:
    case AA_EXTINGUISH_FIN:
    case AA_REFILL_FIN:
    case AA_RESCUE:
    case AA_RESCUE_FIN:
    case AA_LOAD:
    case AA_LOADING:
    case AA_UNLOAD:
    case AA_CLEAR:
    case AA_CLEAR_FIN:
      offset += decodeStandardData(start+offset, data, msg);
      break;
    default:
      //System.err.print("̤ޥɤǤ[decodeCommandData()] : ");
      //System.err.println(command);
      msg.setMsgLength(-1); // åǤ뤳Ȥ
    }//end switch(command)
    return offset;
  }

  /********************************************************************/
  /** byte沽Ĥsenseå롣<BR>
   * ToDo: Υ󥹥ץѥƥ(Value=128,129,130,131,207,235,242)б
   * @param start byteɤ߹߳ϰ
   * @param encodeMsg ͥ뤫byte沽åǡ
   * @param msg encodeMsgǼMessageå
   * @return ɤ߹byte
   **/
  private int decodeSenseData(int start, byte[] encodeMsg, Message msg){

    int offset = 0; // Υ᥽åɤ߹byte
    int[] realdata; // Message饹˳ǼintΥǡ
    int[] data = new int[encodeMsg.length]; // Ū˳Ǽint
    int index = 0; // dataν񤭹֤߰ν

    if(start+offset >= encodeMsg.length){ // 󥹥ǡλ
      //System.err.println("ä󥹥ǡ衪1[decodeSenseData()]");
      msg.setMsgLength(-1); // åǤ뤳Ȥ
      return offset; // ɤȤޤǤ֤
    }
    while((data[index]=(((int)encodeMsg[start+offset]+128) & 0xFF)) != 0){
      if((start+offset)+5 >= encodeMsg.length){ // 󥹥ǡλ
	//System.err.println("ä󥹥ǡ衪2[decodeSenseData()]");
	msg.setMsgLength(-1); // åǤ뤳Ȥ
	return offset; // ɤȤޤǤ֤
      }
      // ֥TYPE
      data[index++] = (((int)encodeMsg[start+(offset++)]+128) & 0xFF); // 1Byte
      //System.out.print("ObjectTYPE="+data[index-1]);
      // ֥ID
      data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	              (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	              (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	               ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
      //System.out.println(", ID="+data[index-1]);
      if(start+offset >= encodeMsg.length){ // 󥹥ǡλ
	//System.err.println("ä󥹥ǡ衪3[decodeSenseData()]");
	msg.setMsgLength(-1); // åǤ뤳Ȥ
	return offset; // ɤȤޤǤ֤
      }
      while((data[index]=(((int)encodeMsg[start+offset]+128) & 0xFF)) != 0){
	if((start+offset)+5 >= encodeMsg.length){ // 󥹥ǡλ
	  //System.err.println("ä󥹥ǡ衪4[decodeSenseData()]");
	  msg.setMsgLength(-1); // åǤ뤳Ȥ
	  return offset; // ɤȤޤǤ֤
	}	    
        // ֥PROPERTY TYPE   : 1Byte
	data[index++] = (((int)encodeMsg[start+(offset++)]+128) & 0xFF);
	//System.out.print("ObjectProperty : Type="+data[index-1]);
        // ֥PROPERTY VALUE
	data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	                (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	                (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	                 ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
	//System.out.println(", Value="+data[index-1]);
      }
      if(start+offset+1 >= encodeMsg.length){ // 󥹥ǡλ
	//System.err.println("ä󥹥ǡ衪5[decodeSenseData()]");
	msg.setMsgLength(-1); // åǤ뤳Ȥ
	return offset; // ɤȤޤǤ֤
      }
      // ObjTYPEλɤɤߤȤ
      data[index++] = (((int)encodeMsg[start+(offset++)]+128) & 0xFF); // 1Byte
      //System.out.println("ObjTYPEνλ["+data[index-1]+"]");
    }
    if(start+offset+1 >= encodeMsg.length){ // 󥹥ǡλ
      //System.err.println("ä󥹥ǡ衪6[decodeSenseData()]");
      msg.setMsgLength(-1); // åǤ뤳Ȥ
      return offset; // ɤȤޤǤ֤
    }
    // commandλɤɤߤȤ
    data[index++] = (((int)encodeMsg[start+(offset++)]+128) & 0xFF); // 1Byte
    //System.out.println("Commandνλ["+data[index-1]+"]");

    realdata = new int[index];
    System.arraycopy(data,0,realdata,0,index);
    msg.setMessage(realdata); // 沽ǡMessage˳Ǽ
    msg.setMsgLength(offset+1); // MessageDataĹ򥻥å
    return offset;
  }

  /********************************************************************/
  /** byte沽Ĥmoveå롣<BR>
   * ToDo: Υ᥽åɡޤ̤
   * @deprecated Υ᥽åɡޤ̤
   * @param start byteɤ߹߳ϰ
   * @param encodeMsg ͥ뤫byte沽åǡ
   * @param msg encodeMsgǼMessageå
   * @return ɤ߹byte
   **/
  private int decodeMoveData(int start, byte[] encodeMsg, Message msg){

    return 0; // Ȥꤢ顼(0)ˤƤ
  }

  /********************************************************************/
  /** byte沽Ĥburiedå롣<BR>
   * @param start byteɤ߹߳ϰ
   * @param encodeMsg ͥ뤫byte沽åǡ
   * @param msg encodeMsgǼMessageå
   * @return ɤ߹byte
   **/
  private int decodeBuriedData(int start, byte[] encodeMsg, Message msg){

    int offset = 0; // Υ᥽åɤ߹byte
    int[] realdata; // Message饹˳ǼintΥǡ
    int[] data = new int[encodeMsg.length]; // Ū˳Ǽint
    int index = 0; // dataν񤭹֤߰ν

    if(start +15 >= encodeMsg.length){ // Buriedǡλ
      //System.err.println("äBuriedǡ衪[decodeBuriedData()]");
      msg.setMsgLength(-1); // åǤ뤳Ȥ
      return offset; // ɤȤޤǤ֤
    }
    // MyID(AA_BURIED_MYSELF_*),⤷ϻ̱ID(AA_BURIED_CIVILIAN_*)
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    // ׷ʪID
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    // ׷ʪFieryness
    data[index++] =  ((int)encodeMsg[start+(offset++)] & 0xFF); // 1Byte
    // MyHP(AA_BURIED_MYSELF_*),⤷ϻ̱HP(AA_BURIED_CIVILIAN_*)
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 2Bytes
    // My(AA_BURIED_MYSELF_*),⤷ϻ̱(AA_BURIED_CIVILIAN_*)
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 2Bytes
    // MyDamage(AA_BURIED_MYSELF_*),⤷ϻ̱Damage(AA_BURIED_CIVILIAN_*)
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 2Bytes

    realdata = new int[index];
    System.arraycopy(data,0,realdata,0,index);
    msg.setMessage(realdata); // 沽ǡMessage˳Ǽ
    msg.setMsgLength(offset+1); // MessageDataĹ򥻥å
    return offset;
  }

  /********************************************************************/
  /** byte沽Ĥextinguishå롣<BR>
   * @param start byteɤ߹߳ϰ
   * @param encodeMsg ͥ뤫byte沽åǡ
   * @param msg encodeMsgǼMessageå
   * @return ɤ߹byte
   **/
  private int decodeExtinguishData(int start, byte[] encodeMsg, Message msg){

    int offset = 0; // Υ᥽åɤ߹byte
    int[] realdata; // Message饹˳ǼintΥǡ
    int[] data = new int[encodeMsg.length]; // Ū˳Ǽint
    int index = 0; // dataν񤭹֤߰ν

    if(start +22 >= encodeMsg.length){ // Extinguishǡλ
      //System.err.println("äExtinguishǡ[decodeExtinguishData()]");
      msg.setMsgLength(-1); // åǤ뤳Ȥ
      return offset; // ɤȤޤǤ֤
    }
    // MyID
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    // òзʪID
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    // ò
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    //  X ɸ
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    //  Y ɸ
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    // 
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 2Bytes

    realdata = new int[index];
    System.arraycopy(data,0,realdata,0,index);
    msg.setMessage(realdata); // 沽ǡMessage˳Ǽ
    msg.setMsgLength(offset+1); // MessageDataĹ򥻥å
    return offset;
  }

  /********************************************************************/
  /** byte沽Ĥrefillå롣<BR>
   * @param start byteɤ߹߳ϰ
   * @param encodeMsg ͥ뤫byte沽åǡ
   * @param msg encodeMsgǼMessageå
   * @return ɤ߹byte
   **/
  private int decodeBlockadeOrRefillData(int start,
					 byte[] encodeMsg,
					 Message msg){

    int offset = 0; // Υ᥽åɤ߹byte
    int[] realdata; // Message饹˳ǼintΥǡ
    int[] data = new int[encodeMsg.length]; // Ū˳Ǽint
    int index = 0; // dataν񤭹֤߰ν

    if(start +5 >= encodeMsg.length){ // BlockadeOrRefillǡλ
      //System.err.println("äBlockadeOrRefillǡ衪");
      //System.err.println("[decodeBlockadeOrRefillData()]");
      msg.setMsgLength(-1); // åǤ뤳Ȥ
      return offset; // ɤȤޤǤ֤
    }
    // MyID
    data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	            (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	             ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    // ĺ[:],⤷ϥĿ[ton:]
    data[index++] =  ((int)encodeMsg[start+(offset++)] & 0xFF); // 1Byte

    realdata = new int[index];
    System.arraycopy(data,0,realdata,0,index);
    msg.setMessage(realdata); // 沽ǡMessage˳Ǽ
    msg.setMsgLength(offset+1); // MessageDataĹ򥻥å
    return offset;
  }

  /********************************************************************/
  /** byte沽Ĥstandard(ɸ)å롣<BR>
   * @param start byteɤ߹߳ϰ
   * @param encodeMsg ͥ뤫byte沽åǡ
   * @param msg encodeMsgǼMessageå
   * @return ɤ߹byte
   **/
  private int decodeStandardData(int start, byte[] encodeMsg, Message msg){

    int offset = 0; // Υ᥽åɤ߹byte
    int[] realdata; // Message饹˳ǼintΥǡ
    int[] data = new int[encodeMsg.length]; // Ū˳Ǽint
    int index = 0; // dataν񤭹֤߰ν

    int dataLength; // (byteĹ)=(ޥ̤dataĹ)*4
    switch(msg.getCommand()){
    case AA_HEAR_BURIED_CIVILIAN_FB:
    case AA_HEAR_BURIED_CIVILIAN_FS:
    case AA_HEAR_BURIED_CIVILIAN_AT:
    case AA_HEAR_BURIED_CIVILIAN_AC:
    case AA_HEAR_BURIED_CIVILIAN_PF:
    case AA_HEAR_BURIED_CIVILIAN_PO:
    case AA_CONGESTED_FB:
    case AA_CONGESTED_AT:
    case AA_CONGESTED_PF:
      dataLength = 3*4;
      break;
    case AA_HALT_FB:
    case AA_HALT_AT:
    case AA_HALT_PF:
    case AA_MOVE_ASIDE_FB:
    case AA_MOVE_ASIDE_AT:
    case AA_MOVE_ASIDE_PF:
    case AA_EXTINGUISH_FIN:
    case AA_RESCUE:
    case AA_RESCUE_FIN:
    case AA_LOAD:
    case AA_LOADING:
    case AA_UNLOAD:
    case AA_CLEAR:
    case AA_CLEAR_FIN:
      dataLength = 2*4;
      break;
    case AA_REST_FB:
    case AA_REST_AT:
    case AA_REST_PF:
    case AA_JUST_FIRE_FB:
    case AA_JUST_FIRE_FS:
    case AA_JUST_FIRE_AT:
    case AA_JUST_FIRE_AC:
    case AA_JUST_FIRE_PF:
    case AA_JUST_FIRE_PO:
    case AA_WOULD_GROUP:
    case AA_GROUP_RECIP:
    case AA_GROUP_REJCT:
    case AA_GROUP_MAKED:
    case AA_GROUP_BROKE:
    case AA_GROUP_RELEASE:
    case AA_REFILL_FIN:
      dataLength = 1*4;
      break;
    default:
      //System.err.print("ˤʤϤ[decodeStandardData()] : ");
      //System.err.println(msg.getCommand());
      return -1; // [-1]֤
    }//end switch(command)
	
    if(start +dataLength >= encodeMsg.length){ // Standardǡλ
      //System.err.println("äStandardǡ衪[decodeStandardData()]");
      msg.setMsgLength(-1); // åǤ뤳Ȥ
      return offset; // ɤȤޤǤ֤
    }

    while(index < (dataLength/4)){ // ƼǡγǼ
      data[index++] = (((int)encodeMsg[start+(offset++)] & 0xFF) << 24) | 
	              (((int)encodeMsg[start+(offset++)] & 0xFF) << 16) | 
	              (((int)encodeMsg[start+(offset++)] & 0xFF) <<  8) | 
	               ((int)encodeMsg[start+(offset++)] & 0xFF); // 4Bytes
    }

    realdata = new int[index];
    System.arraycopy(data,0,realdata,0,index);
    msg.setMessage(realdata); // 沽ǡMessage˳Ǽ
    msg.setMsgLength(offset+1); // MessageDataĹ򥻥å
    return offset;
  }

  /********************************************************************/
}
