/*
  # MessageManager.java
  # Copyright (c) 2002-2004 Ken'ichi Honji(honji@phaser.elcom.nitech.ac.jp)
  # $Id: MessageManager.java,v 1.4.1 2004/06/10 00:30:11 honji Exp $
  */
package rescueAgent.ObjectSet;

import java.util.*;
import rescueAgent.Generic.Parameter;
import rescueAgent.IO.IO;
import rescueAgent.RescueObject.*;

/**
 * åδ򤹤륯饹å¤ä,
 * ǹԤʤ, å¤äϹԤʤʤ
 **/
public class MessageManager_NEW implements AACommand {
  /**
   * AK_SAYˤä줿(Ԥޤ)åϥåơ֥
   **/
  private Hashtable sendSayMsgTable;
  /** 
   * AK_TELLˤä줿(Ԥޤ)åϥåơ֥
   **/
  private Hashtable sendTellMsgTable;
  /** ̤ Say åå(ǿǽSayκ) **/
  private Vector[] sayMsgSet;
  /** ̤ Tell åå (ǿǽTellκ)**/
  private Vector[] tellMsgSet;
  /** Ѥߥå¸(default : 5step [-1¸]) **/
  private int storePeriod = 5; //  5step˺
  /** ߻ **/
  private int nowTime = -1;
  /** Υ饹ͭƤ륨ȤID **/
  private int userID = -1;
  /** ֥ȾǼǡ١饹 **/
  private ObjectDatabase objectDB;
  /** åѴ **/
  private MessageConverter msgConverter = new MessageConverter();
  /** RescueKernelȼºݤ򤪤ʤ饹 **/
  private IO io;

  /********************************************************************/
  // 󥹥ȥ饯
  /** ɸŪʥ󥹥ȥ饯(Ѥߥå¸֤ϥǥեȤ
   * 5step)<BR><BR>
   * @param sendSayMsgNum SayǤåκ
   * @param sendTellMsgNum TellǤåκ(ͤǤ)
   * @param id ͭID
   * @param objDB ֥ȥǡ١
   * @param io KernelȤΥåԤʤ饹
   **/
  public MessageManager_NEW(int sendSayMsgNum,int sendTellMsgNum,
			    int id, ObjectDatabase objDB, IO io){
    // å¸ꤷƥϥåơ֥
    int storeNum = (int)(storePeriod * 1.5)+4; // פ11(Default)
    sendSayMsgTable = new Hashtable(storeNum);
    sendTellMsgTable = new Hashtable(storeNum);
    // å
    sayMsgSet = new Vector[sendSayMsgNum];
    for(int i=0; i<sendSayMsgNum; i++){
      sayMsgSet[i] = new Vector();
    }
    tellMsgSet = new Vector[sendTellMsgNum]; // ºݤsendSayMsgNumȰ
    for(int i=0; i<sendTellMsgNum; i++){
      tellMsgSet[i] = new Vector();
    }
    userID = id; // ͭID
    objectDB = objDB; // ObjectDatabase
    this.io = io; // IO饹
  }
  /********************************************************************/
  /** Ѥߥå¸֤ꤹΥ󥹥ȥ饯<BR><BR>
   * @param sendSayMsgNum SayǤåκ
   * @param sendTellMsgNum TellǤåκ(ͤǤ)
   * @param storeTime ¸(-1λƤΥå¸)
   * @param id ͭID
   * @param objDB ֥ȥǡ١
   * @param io KernelȤΥåԤʤ饹
   **/
  public MessageManager_NEW(int sendSayMsgNum, int sendTellMsgNum,
			    int storeTime, int id,
			    ObjectDatabase objDB, IO io){
    // å¸ꤷƥϥåơ֥
    storePeriod = storeTime;
    // ߥ졼ְʾ, ⤷ 0 ʲλϥե¸Ȥߤʤ
    if(storePeriod > Parameter.MAX_SIMULATION_TIME || storePeriod < 1){
      storePeriod = Parameter.MAX_SIMULATION_TIME;
    }
    int storeNum = (int)(storePeriod * 1.5)+1;
    sendSayMsgTable = new Hashtable(storeNum);
    sendTellMsgTable = new Hashtable(storeNum);
    // å
    sayMsgSet = new Vector[sendSayMsgNum];
    for(int i=0; i<sendSayMsgNum; i++){
      sayMsgSet[i] = new Vector();
    }
    tellMsgSet = new Vector[sendTellMsgNum];
    for(int i=0; i<sendTellMsgNum; i++){
      tellMsgSet[i] = new Vector();
    }
    userID = id; // ͭID
    objectDB = objDB; // ObjectDatabase
    this.io = io; // IO饹
  }
  // 󥹥ȥ饯ޤ
  /********************************************************************/
  /** ߻򥻥åȡƱ¸֤β᤮ååȤ<BR>
   * ToDo: Υ᥽åɤSenseInfoParser.javaΤߤ¹Ԥ٤<BR><BR>
   * @param time ߻
   **/
  public void updateNowTime(int time){
    // 郎§̤˹ƤremoveȤϣOK
    if(time == nowTime + 1){
      sendSayMsgTable.remove(new Integer(time-storePeriod-1));
      sendTellMsgTable.remove(new Integer(time-storePeriod-1));
    }
    // §̤Ǥʤ, ɬʬƤˤremoveȤԤʤ
    else{
      for(int i=0; i<(time-storePeriod); i++){
	sendSayMsgTable.remove(new Integer(i));
	sendTellMsgTable.remove(new Integer(i));
      }
    }
    nowTime = time;
  }

  /********************************************************************/
  /** SayMessageʬꤷ֤ΥååȤݴ(ɲ)<BR><BR>
   * @param msg å
   * @param index ¸ååֹ(ͤ1sayMsgSet.length)
   **/
  public void storeSayMessage(Message msg, int index){
    if(index <= 0 || index > sayMsgSet.length){
      //System.err.print("ꤷindexˤ¸Ǥޤ[storeSayMessage()]");
      //System.err.println(": index="+index);
      return;
    }
    else if(msg == null){
      //System.err.println("åޤ[storeSayMessage()]");
      return;
    }
    sayMsgSet[index-1].add(msg);
  }

  /********************************************************************/
  /** TellMessageʬꤷ֤ΥååȤݴ(ɲ)<BR><BR>
   * @param msg å
   * @param index ¸ååֹ(ͤ1tellMsgSet.length)
   **/
  public void storeTellMessage(Message msg, int index){
    if(index <= 0 || index > tellMsgSet.length){
      //System.err.print("ꤷindexˤ¸Ǥޤ");
      //System.err.println("[storeTellMessage()]: index="+index);
      return;
    }
    else if(msg == null){
      //System.err.println("åޤ[storeTellMessage()]");
      return;
    }
    tellMsgSet[index-1].add(msg);
  }

  /********************************************************************/
  /** SayMessageSetꤷ֤ݴɡ<BR><BR>
   * @param msgSet åå
   * @param index ¸ååֹ(ͤ1sayMsgSet.length)
   * @return ޤǤΰ֤äƤååȡʤжVector
   **/
  public Vector storeSayMessageSet(Vector msgSet, int index){
    if(index <= 0 || index > sayMsgSet.length){
      //System.err.print("ꤷindexˤ¸Ǥޤ");
      //System.err.println("[storeSayMessageSet()]: index="+index);
      return null;
    }
    else if(msgSet == null){
      //System.err.print("ååȤޤ");
      //System.err.println("[storeSayMessageSet()]");
      return null;
    }
    Vector nowMsgSet = sayMsgSet[index-1];
    sayMsgSet[index-1] = msgSet;
    return nowMsgSet;
  }

  /********************************************************************/
  /** TellMessageSetꤷ֤ݴɡ<BR><BR>
   * @param msgSet åå
   * @param index ¸ååֹ(ͤ1tellMsgSet.length)
   * @return ޤǤΰ֤äƤååȡʤжVector
   **/
  public Vector storeTellMessageSet(Vector msgSet, int index){
    if(index <= 0 || index > tellMsgSet.length){
      //System.err.print("ꤷindexˤ¸Ǥޤ");
      //System.err.println("[storeTellMessageSet()]: index="+index);
      return null;
    }
    else if(msgSet == null){
      //System.err.print("ååȤޤ");
      //System.err.println("[storeTellMessageSet()]");
      return null;
    }
    Vector nowMsgSet = tellMsgSet[index-1];
    tellMsgSet[index-1] = msgSet;
    return nowMsgSet;
  }

  /********************************************************************/
  /** SayMessageSetꤷ֤ˤMessageSetȷ礷ݴɡ<BR><BR>
   * @param msgSet åå
   * @param index 硦¸ååֹ(ͤ1sayMsgSet.length)
   **/
  public void mergeSayMessageSet(Vector msgSet, int index){
    if(index <= 0 || index > sayMsgSet.length){
      //System.err.print("ꤷindexˤ¸Ǥޤ");
      //System.err.println("[mergeSayMessageSet()]: index="+index);
      return;
    }
    else if(msgSet == null){
      //System.err.print("ååȤޤ");
      //System.err.println("[mergeSayMessageSet()]");
      return;
    }
    sayMsgSet[index-1] = mergeVector(sayMsgSet[index-1],msgSet);
  }

  /********************************************************************/
  /** TellMessageSetꤷ֤ˤMessageSetȷ礷ݴɡ<BR><BR>
   * @param msgSet åå
   * @param index 硦¸ååֹ(ͤ1tellMsgSet.length)
   **/
  public void mergeTellMessageSet(Vector msgSet, int index){
    if(index <= 0 || index > tellMsgSet.length){
      //System.err.print("ꤷindexˤ¸Ǥޤ");
      //System.err.println("[mergeTellMessageSet()]: index="+index);
      return;
    }
    else if(msgSet == null){
      //System.err.print("ååȤޤ");
      //System.err.println("[mergeTellMessageSet()]");
      return;
    }
    tellMsgSet[index-1] = mergeVector(tellMsgSet[index-1],msgSet);
  }

  /********************************************************************/
  /** ĤVectorååȤ򣱤Ĥ˷礹롣<BR><BR>
   * @param srcVec 礵åå
   * @param mrgVec 礹åå
   * @return 礷ååȡsrcVecnullλΤߥ顼ͤȤnull
   *         ֤
   **/
  private Vector mergeVector(Vector srcVec, Vector mrgVec){
    if(srcVec == null){
      //System.err.println("縵ޤ[mergeVector()]");
      return null;
    }
    if(srcVec.size() == 0){
      if(mrgVec == null){
	return srcVec;
      }
      else{
	return mrgVec;
      }
    }
    else{
      if(mrgVec == null){
	return srcVec;
      }
      else if(mrgVec.size() == 0){
	return srcVec;
      }
      else{
	Iterator it = mrgVec.iterator();
	while(it.hasNext()){
	  Message mes = (Message)it.next();
	  srcVec.add(mes);
	}
	return srcVec;
      }
    }
  }

  /********************************************************************/
  /** ꤷindexˤååȤ롣<BR><BR>
   * @param index ååֹ(ͤ1sayMsgSet.length)
   * @return ֤ˤååȡʤжVector
   **/
  public Vector getSayMessageSet(int index){
    if(index <= 0 || index > sayMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[getSayMessageSet()]: index="+index);
      return null;
    }
    else if(sayMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[getSayMessageSet()]");
      return null;
    }
    return sayMsgSet[index-1];
  }

  /********************************************************************/
  /** ꤷindexˤååȤ롣<BR><BR>
   * @param index ååֹ(ͤ1tellMsgSet.length)
   * @return ֤ˤååȡʤжVector
   **/
  public Vector getTellMessageSet(int index){
    if(index <= 0 || index > tellMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[getTellMessageSet()]: index="+index);
      return null;
    }
    else if(tellMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[getTellMessageSet()]");
      return null;
    }
    return tellMsgSet[index-1];
  }

  /********************************************************************/
  /** ߤSayååȤμ<BR><BR>
   * @param time SayååȤ
   * @return ꤷSayååȡʤnull
   **/
  public Vector getPastSayMessageSet(int time){
    return (Vector)sendSayMsgTable.get(new Integer(time));
  }

  /********************************************************************/
  /** ߤTellååȤμ<BR><BR>
   * @param time TellååȤ
   * @return ꤷTellååȡʤnull
   **/
  public Vector getPastTellMessageSet(int time){
    return (Vector)sendTellMsgTable.get(new Integer(time));
  }

  /********************************************************************/
  /** ߥȥˤޤäƤSayåХȿ֤<BR><BR>
   * @param index Ĵ٤ååֹ(ͤ1sayMsgSet.length)
   * @return ååȤХȿλ 0ХȤ֤롣
   **/
  public int getSayMessageSetSize(int index){
    if(index <= 0 || index > sayMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[getSayMessageSetSize()]: index="+index);
      return -1;
    }
    else if(sayMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[getSayMessageSetSize()]");
      return -1;
    }
    int msgSize = 0;
    if(sayMsgSet[index-1].size() != 0){
      Iterator it = sayMsgSet[index-1].iterator();
      while(it.hasNext()){
	Message mes = (Message)it.next();
	msgSize += mes.getMsgLength();
      }
    }
    return msgSize;
  }

  /********************************************************************/
  /** ߥȥˤޤäƤTellåХȿ֤<BR><BR>
   * @param index Ĵ٤ååֹ(ͤ1tellMsgSet.length)
   * @return ååȤХȿλ 0ХȤ֤롣
   **/
  public int getTellMessageSetSize(int index){
    if(index <= 0 || index > tellMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[getTellMessageSetSize()]: index="+index);
      return -1;
    }
    else if(tellMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[getTellMessageSetSize()]");
      return -1;
    }
    int msgSize = 0;
    if(tellMsgSet[index-1].size() != 0){
      Iterator it = tellMsgSet[index-1].iterator();
      while(it.hasNext()){
	Message mes = (Message)it.next();
	msgSize += mes.getMsgLength();
      }
    }
    return msgSize;
  }

  /********************************************************************/
  /** ߥȥˤޤäƤindexܤSayååȤ,
   * åˤ[io.say()]롣<BR>
   * , åѤߥååȤ˰ܤ롣<BR><BR>
   * @param index ååֹ(ͤ1sayMsgSet.length)
   * @param sortMsgOrder å(MsgConverter饹)
   * @return ǤååȤο(0ޤ1)ä-1(̤)
   **/
  public int sendSayMessage(int index, int sortMsgOrder){
    if(index <= 0 || index > sayMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[sendSayMessage()]: index="+index);
      return -1;
    }
    else if(sayMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[sendSayMessage()]");
      return -1;
    }
    else if(sayMsgSet[index-1].size() == 0){
      return -1; // åä
    }
    byte[] sendMsg = msgConverter.encodeMessage(sayMsgSet[index-1],
						sortMsgOrder,
						Parameter.SAY_MAX_BYTE);
    if(sendMsg == null){
      return 0; // 󥳡ɤμ
    }
    // Sayåȯ
    io.say(sendMsg,Parameter.SAY_MAX_BYTE);
    // ѤߥååȤإåְư(ԡǤϤʤ)
    Vector pastSayMsg = (Vector)sendSayMsgTable.get(new Integer(nowTime));
    if(pastSayMsg == null){
      // !! clone() ʤ,塹 mergeVector() 뤳Ȥˤʤ!!
      pastSayMsg = (Vector)sayMsgSet[index-1].clone();
      sendSayMsgTable.put(new Integer(nowTime),pastSayMsg);
    }
    else{
      pastSayMsg = mergeVector(pastSayMsg,sayMsgSet[index-1]);
      sendSayMsgTable.put(new Integer(nowTime),pastSayMsg);
    }
    sayMsgSet[index-1].clear(); // ưʤΤǺǸ˰ư
    return 1;
  }

  /********************************************************************/
  /** ߥȥˤޤäƤindexܤTellååȤ,
   * åˤ[io.tell()]롣<BR>
   * , åѤߥååȤ˰ܤ롣<BR><BR>
   * @param index ååֹ(ͤ1tellMsgSet.length)
   * @param sortMsgOrder å(MsgConverter饹)
   * @return ǤååȤο(0ޤ1)ä-1(̤)
   **/
  public int sendTellMessage(int index, int sortMsgOrder){
    if(index <= 0 || index > tellMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[sendTellMessage()]: index="+index);
      return -1;
    }
    else if(tellMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[sendTellMessage()]");
      return -1;
    }
    else if(tellMsgSet[index-1].size() == 0){
      return -1; // åä
    }
    byte[] sendMsg = msgConverter.encodeMessage(tellMsgSet[index-1],
						sortMsgOrder,
						Parameter.TELL_MAX_BYTE);
    if(sendMsg == null){
      return 0; // 󥳡ɤμ
    }
    // Tellåȯ
    io.tell(sendMsg,Parameter.TELL_MAX_BYTE);
    // ѤߥååȤإåְư(ԡǤϤʤ)
    Vector pastTellMsg = (Vector)sendTellMsgTable.get(new Integer(nowTime));
    if(pastTellMsg == null){
      // !! clone() ʤ,塹 mergeVector() 뤳Ȥˤʤ!!
      pastTellMsg = (Vector)tellMsgSet[index-1].clone();
      sendTellMsgTable.put(new Integer(nowTime),pastTellMsg);
    }
    else{
      pastTellMsg = mergeVector(pastTellMsg,tellMsgSet[index-1]);
      sendTellMsgTable.put(new Integer(nowTime),pastTellMsg);
    }
    tellMsgSet[index-1].clear(); // ưʤΤǺǸ˰ư
    return 1;
  }

  /********************************************************************/
  /** ߥȥˤޤäƤƤSayååȤ,
   * åȤοʬΥåˤ[io.say()]롣<BR>
   * ,åѤߥååȤ˰ܤ롣<BR><BR>
   * @param sortMsgOrder å(MsgConverter饹)
   * @return ǤååȤο(0sayMsgSet.length)
   *         ʥåȤåä, 
   *         ޤǤλååȤο֤
   **/
  public int sendAllSayMessage(int sortMsgOrder){
    int sendMsgNum = 0;
    byte[] sendMsg;
    // ߻ΥåФƤ
    Vector pastSayMsg = (Vector)sendSayMsgTable.get(new Integer(nowTime));
    for(int i=0; i<sayMsgSet.length; i++){
      if(sayMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("ʥåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[sendAllSayMessage()]");
	continue;
      }
      else if(sayMsgSet[i].size() == 0){
	continue; // åä
      }
      else{
	sendMsg = msgConverter.encodeMessage(sayMsgSet[i],sortMsgOrder,
					     Parameter.SAY_MAX_BYTE);
	if(sendMsg == null){
	  continue; // 󥳡ɤμ
	}
	else{
	  // Sayåȯ
	  io.say(sendMsg,Parameter.SAY_MAX_BYTE);
	  // ѤߥååȤسǼ򤹤
	  if(pastSayMsg == null){
	    // !! clone() ʤ,塹 mergeVector() 뤳Ȥˤʤ!!
	    pastSayMsg = (Vector)sayMsgSet[i].clone();
	  }
	  else{
	    // åޤȤƤ
	    pastSayMsg = mergeVector(pastSayMsg,sayMsgSet[i]);
	  }
	  sayMsgSet[i].clear(); // ưʤΤǰưϺ
	  sendMsgNum++; // λåΥ
	}
      }
    }
    // Ǹ,ĤˤޤȤ᤿ååȤơ֥˳Ǽ
    if(pastSayMsg != null){
      sendSayMsgTable.put(new Integer(nowTime),pastSayMsg);
    }
    return sendMsgNum;
  }

  /********************************************************************/
  /** ߥȥˤޤäƤƤTellååȤ,
   * åȤοʬΥåˤ[io.tell()]롣<BR>
   * , åѤߥååȤ˰ܤ롣<BR><BR>
   * @param sortMsgOrder å(MsgConverter饹)
   * @return ǤååȤο(0tellMsgSet.length)
   *         ʥåȤåä, 
   *         ޤǤλååȤο֤
   **/
  public int sendAllTellMessage(int sortMsgOrder){
    int sendMsgNum = 0;
    byte[] sendMsg;
    // ߻ΥåФƤ
    Vector pastTellMsg = (Vector)sendTellMsgTable.get(new Integer(nowTime));
    for(int i=0; i<tellMsgSet.length; i++){
      if(tellMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("ʥåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[sendAllTellMessage()]");
	continue;
      }
      else if(tellMsgSet[i].size() == 0){
	continue; // åä
      }
      else{
	sendMsg = msgConverter.encodeMessage(tellMsgSet[i],sortMsgOrder,
					     Parameter.TELL_MAX_BYTE);
	if(sendMsg == null){
	  continue; // 󥳡ɤμ
	}
	else{
	  // Tellåȯ
	  io.tell(sendMsg,Parameter.TELL_MAX_BYTE);
	  // ѤߥååȤسǼ򤹤
	  if(pastTellMsg == null){
	    // !! clone() ʤ,塹 mergeVector() 뤳Ȥˤʤ!!
	    pastTellMsg = (Vector)tellMsgSet[i].clone();
	  }
	  else{
	    // åޤȤƤ
	    pastTellMsg = mergeVector(pastTellMsg,tellMsgSet[i]);
	  }
	  tellMsgSet[i].clear(); // ưʤΤǰưϺ
	  sendMsgNum++; // λåΥ
	}
      }
    }
    // Ǹ,ĤˤޤȤ᤿ååȤơ֥˳Ǽ
    if(pastTellMsg != null){
      sendTellMsgTable.put(new Integer(nowTime),pastTellMsg);
    }
    return sendMsgNum;
  }

  /********************************************************************/
  /** ߥȥˤޤäƤƤSay&TellååȤ,
   * åȤοʬΥåˤ[io.say() & io.tell()]롣<BR>
   * , åѤߥååȤ˰ܤ롣<BR><BR>
   * @param sortMsgOrder å(MsgConverter饹)
   * @return ǤååȤο(0sayMsgSet.length +
   *         tellMsgSet.length)ʥåȤåä, 
   *         ޤǤλååȤο֤
   **/
  public int sendAllMessage(int sortMsgOrder){
    int sendMsgNum = 0;
    byte[] sendMsg;
    // ߻ΥåФƤ
    Vector pastSayMsg = (Vector)sendSayMsgTable.get(new Integer(nowTime));
    Vector pastTellMsg = (Vector)sendTellMsgTable.get(new Integer(nowTime));
    // ޤSayå
    for(int i=0; i<sayMsgSet.length; i++){
      if(sayMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("Sayåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[sendAllMessage()]");
	continue;
      }
      else if(sayMsgSet[i].size() == 0){
	continue; // åä
      }
      else{
	sendMsg = msgConverter.encodeMessage(sayMsgSet[i],sortMsgOrder,
					     Parameter.SAY_MAX_BYTE);
	if(sendMsg == null){
	  continue; // 󥳡ɤμ
	}
	else{
	  // Sayåȯ
	  io.say(sendMsg,Parameter.SAY_MAX_BYTE);
	  // ѤߥååȤسǼ򤹤
	  if(pastSayMsg == null){
	    // !! clone() ʤ,塹 mergeVector() 뤳Ȥˤʤ!!
	    pastSayMsg = (Vector)sayMsgSet[i].clone();
	  }
	  else{
	    // åޤȤƤ
	    pastSayMsg = mergeVector(pastSayMsg,sayMsgSet[i]);
	  }
	  sayMsgSet[i].clear(); // ưʤΤǰưϺ
	  sendMsgNum++; // λåΥ
	}
      }
    }
    // Tellå
    for(int i=0; i<tellMsgSet.length; i++){
      if(tellMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("Tellåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[sendAllMessage()]");
	continue;
      }
      else if(tellMsgSet[i].size() == 0){
	continue; // åä
      }
      else{
	sendMsg = msgConverter.encodeMessage(tellMsgSet[i],sortMsgOrder,
					     Parameter.TELL_MAX_BYTE);
	if(sendMsg == null){
	  continue; // 󥳡ɤμ
	}
	else{
	  // Tellåȯ
	  io.tell(sendMsg,Parameter.TELL_MAX_BYTE);
	  // ѤߥååȤسǼ򤹤
	  if(pastTellMsg == null){
	    // !! clone() ʤ,塹 mergeVector() 뤳Ȥˤʤ!!
	    pastTellMsg = (Vector)tellMsgSet[i].clone();
	  }
	  else{
	    // åޤȤƤ
	    pastTellMsg = mergeVector(pastTellMsg,tellMsgSet[i]);
	  }
	  tellMsgSet[i].clear(); // ưʤΤǰưϺ
	  sendMsgNum++; // λåΥ
	}
      }
    }
    // Ǹ,ĤˤޤȤ᤿ååȤơ֥˳Ǽ
    if(pastSayMsg != null){
      sendSayMsgTable.put(new Integer(nowTime),pastSayMsg);
    }
    if(pastTellMsg != null){
      sendTellMsgTable.put(new Integer(nowTime),pastTellMsg);
    }
    return sendMsgNum;
  }

  /********************************************************************/
  /** ߥȥˤޤäƤindexܤSayååȤ롣<BR>
   * , send*Message()᥽åɤåϼưŪ clear
   * 뤬, ԤʤɤˤĤäƤޤä,
   * Ū˥å, Ѥ롣<BR><BR>
   * @param index  ååֹ(ͤ1sayMsgSet.length)
   **/
  public void clearSayMessageSet(int index){
    if(index <= 0 || index > sayMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[clearSayMessageSet()]: index="+index);
      return;
    }
    else if(sayMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[clearSayMessageSet()]");
      return;
    }
    else{
      sayMsgSet[index-1].clear();
    }
  }

  /********************************************************************/
  /** ߥȥˤޤäƤindexܤTellååȤ롣<BR>
   * , send*Message()᥽åɤåϼưŪ clear
   * 뤬, ԤʤɤˤĤäƤޤä,
   * Ū˥å, Ѥ롣<BR><BR>
   * @param index  ååֹ(ͤ1tellMsgSet.length)
   **/
  public void clearTellMessageSet(int index){
    if(index <= 0 || index > tellMsgSet.length){
      //System.err.print("ꤷindex̵Ǥ");
      //System.err.println("[clearTellMessageSet()]: index="+index);
      return;
    }
    else if(tellMsgSet[index-1] == null){ // 褳ˤϤʤϤ
      //System.err.print("ꤷindexΥååȤǤ");
      //System.err.println("[clearTellMessageSet()]");
      return;
    }
    else{
      tellMsgSet[index-1].clear();
    }
  }

  /********************************************************************/
  /** ߥȥˤޤäƤƤSayååȤ롣<BR>
   * , send*Message()᥽åɤåϼưŪ clear
   * 뤬, ԤʤɤˤĤäƤޤä,
   * Ū˥å, Ѥ롣<BR><BR>
   **/
  public void clearAllSayMessageSet(){
    for(int i=0; i<sayMsgSet.length; i++){
      if(sayMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("ʥåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[clearAllSayMessageSet()]");
	continue;
      }
      else{
	sayMsgSet[i].clear();
      }
    }
  }

  /********************************************************************/
  /** ߥȥˤޤäƤƤTellååȤ롣<BR>
   * , send*Message()᥽åɤåϼưŪ clear
   * 뤬, ԤʤɤˤĤäƤޤä,
   * Ū˥å, Ѥ롣<BR><BR>
   **/
  public void clearAllTellMessageSet(){
    for(int i=0; i<tellMsgSet.length; i++){
      if(tellMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("ʥåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[clearAllTellMessageSet()]");
	continue;
      }
      else{
	tellMsgSet[i].clear();
      }
    }
  }

  /********************************************************************/
  /** ߥȥˤޤäƤƤΥååȤ롣<BR>
   * , send*Message()᥽åɤåϼưŪ clear
   * 뤬, ԤʤɤˤĤäƤޤä,
   * Ū˥å, Ѥ롣<BR><BR>
   **/
  public void clearAllMessageSet(){
    // ޤ, sayMsgSet 򥪡륯ꥢ
    for(int i=0; i<sayMsgSet.length; i++){
      if(sayMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("ʥåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[clearAllMessageSet()]");
	continue;
      }
      else{
	sayMsgSet[i].clear();
      }
    }
    // , tellMsgSet 򥪡륯ꥢ
    for(int i=0; i<tellMsgSet.length; i++){
      if(tellMsgSet[i] == null){ // 褳ˤϤʤϤ
	//System.err.print("ʥåå(index:"+(i+1));
	//System.err.println(")¸ߤޤ[clearAllMessageSet()]");
	continue;
      }
      else{
	tellMsgSet[i].clear();
      }
    }
  }

  /********************************************************************/
  /** SenseMessage 롣<BR>
   * Υ᥽åɤϰmsgDataǡɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param msgData Senseǡ
   * @return AA_SENSE_* ޥ񤭹ޤ줿SenseMessage
   *         ˼Ԥnull
   **/
  public Message makeSenseMessage(int[] msgData){
    int imp = Message.IMPORTANCE_MIDDLE; // (ͥ)MIDDLE˥å
    int com; // ޥɤ
    if(msgData == null){
      //System.err.println("åǡޤ[makeSenseMessage()]");
      return null;
    }
    else if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_SENSE_FB;
    }
    else if(objectDB.hasFireStationObject(userID)){
      com = AA_SENSE_FS;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_SENSE_AT;
    }
    else if(objectDB.hasAmbulanceCenterObject(userID)){
      com = AA_SENSE_AC;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_SENSE_PF;
    }
    else if(objectDB.hasPoliceOfficeObject(userID)){
      com = AA_SENSE_PO;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeSenseMessage()]");
      return null;
    }

    // å
    Message senseMsg = new Message(nowTime,imp,-1,com,msgData);
    Vector tmpVec = new Vector();
    int sortType = MessageConverter.NO_SORT;
    tmpVec.add(senseMsg);
    byte[] tmp = msgConverter.encodeMessage(tmpVec,sortType,msgData.length*4);
    if(tmp == null){
      //System.err.println("åǡǤ1[makeSenseMessage()]");
      return null;
    }
    else if(tmp.length <= 5){ // ޥɾ󤷤ʤ
      //System.err.println("åǡǤ2[makeSenseMessage()]");
      return null;
    }
    senseMsg.setMsgLength((tmp.length)-5); // åĹΥå
    return senseMsg;
  }

  /********************************************************************/
  /** MoveMessage 롣<BR><BR>
   * @deprecated ̤
   * @param msgData Moveǡ
   * @return AA_MOVE_* ޥ񤭹ޤ줿MoveMessage
   *         ˼Ԥnull(̤Τḽߤ϶å֤)
   **/
  public Message makeMoveMessage(int[] msgData){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    return new Message(); // Ȥꤢå֤
  }

  /********************************************************************/
  /** RestMessage 롣<BR><BR>
   * @return AA_REST_* ޥ񤭹ޤ줿RestMessage
   *         ˼Ԥnull
   **/
  public Message makeRestMessage(){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 5; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_REST_FB;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_REST_AT;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_REST_PF;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeRestMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID};

    // å
    Message restMsg = new Message(nowTime,imp,length,com,data);
    return restMsg;
  }

  /********************************************************************/
  /** BuriedMyselfMessage 롣<BR>
   * Υ᥽åɤϰburiedBuildingIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param buriedBuildingID ȤޤäƤʪID
   * @return AA_BURIED_MYSELF_* ޥ񤭹ޤ줿BuriedMyselfMessage
   *         ˼Ԥnull
   **/
  public Message makeBuriedMyselfMessage(int buriedBuildingID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 16; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_BURIED_MYSELF_FB;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_BURIED_MYSELF_AT;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_BURIED_MYSELF_PF;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeBuriedMyselfMessage()]");
      return null;
    }
    // ʪIDå
    if(objectDB.hasBuildingObject(buriedBuildingID) == false){
      //System.err.print("¸ߤʤBuildingIDǤ");
      //System.err.println("[makeBuriedMyselfMessage()]");
      return null;
    }

    // ǡγͤκ
    Building b = objectDB.getBuildingObject(buriedBuildingID);
    int fieryness = b.getFieryness(); // ǳ
    Civilian myself = objectDB.getCivilianObject(userID);
    int myHP = myself.getHP(); // HP
    int myBuriedness = myself.getBuriedness(); // 
    int myDamage = myself.getDamage(); // ᡼

    // ǡκ
    int[] data = {userID,buriedBuildingID,fieryness,
		  myHP,myBuriedness,myDamage};

    // å
    Message buriedMyselfMsg = new Message(nowTime,imp,length,com,data);
    return buriedMyselfMsg;
  }

  /********************************************************************/
  /** BuriedCivilianMessage 롣<BR>
   * Υ᥽åɤϰcvID,buriedBuildingIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param cvID ޤäƤ̱ID
   * @param buriedBuildingID ̱ޤäƤʪID
   * @return AA_BURIED_CIVILIAN_* ޥ񤭹ޤ줿
   *         BuriedCivilianMessage˼Ԥnull
   **/
  public Message makeBuriedCivilianMessage(int cvID, int buriedBuildingID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 16; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_BURIED_CIVILIAN_FB;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_BURIED_CIVILIAN_AT;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_BURIED_CIVILIAN_PF;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeBuriedCivilianMessage()]");
      return null;
    }
    // ʪIDå
    if(objectDB.hasBuildingObject(buriedBuildingID) == false){
      //System.err.print("¸ߤʤBuildingIDǤ");
      //System.err.println("[makeBuriedCivilianMessage()]");
      return null;
    }
    // ̱IDå
    if(objectDB.hasCivilianObject(cvID) == false){
      //System.err.print("¸ߤʤCivilianIDǤ");
      //System.err.println("[makeBuriedCivilianMessage()]");
      return null;
    }

    // ǡγͤκ
    Building b = objectDB.getBuildingObject(buriedBuildingID);
    int fieryness = b.getFieryness(); // ǳ
    Civilian cv = objectDB.getCivilianObject(cvID);
    int cvHP = cv.getHP(); // HP
    int cvBuriedness = cv.getBuriedness(); // 
    int cvDamage = cv.getDamage(); // ᡼

    // ǡκ
    int[] data = {cvID,buriedBuildingID,fieryness,
		  cvHP,cvBuriedness,cvDamage};

    // å
    Message buriedCivilianMsg = new Message(nowTime,imp,length,com,data);
    return buriedCivilianMsg;
  }

  /********************************************************************/
  /** HearBuriedCivilianMessage 롣<BR>
   * Υ᥽åɤϰcvIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param cvID ޤäƤ餷̱ID
   * @return AA_HEAR_BURIED_CIVILIAN_* ޥ񤭹ޤ줿
   *         HearBuriedCivilianMessage˼Ԥnull
   **/
  public Message makeHearBuriedCivilianMessage(int cvID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 13; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_HEAR_BURIED_CIVILIAN_FB;
    }
    else if(objectDB.hasFireStationObject(userID)){
      com = AA_HEAR_BURIED_CIVILIAN_FS;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_HEAR_BURIED_CIVILIAN_AT;
    }
    else if(objectDB.hasAmbulanceCenterObject(userID)){
      com = AA_HEAR_BURIED_CIVILIAN_AC;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_HEAR_BURIED_CIVILIAN_PF;
    }
    else if(objectDB.hasPoliceOfficeObject(userID)){
      com = AA_HEAR_BURIED_CIVILIAN_PO;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeHearBuriedCivilianMessage()]");
      return null;
    }
    // ̱IDå
    if(objectDB.hasCivilianObject(cvID) == false){
      //System.err.print("¸ߤʤCivilianIDǤ");
      //System.err.println("[makeHearBuriedCivilianMessage()]");
      return null;
    }
    // ǡγͤκ
    Civilian myself = objectDB.getCivilianObject(userID);
    int myPosition = myself.getPosition(); // Position
    int myPositionEX = (int)(myself.getPositionExtra()*1000); // PosEX

    // ǡκ
    int[] data = {cvID,myPosition,myPositionEX};

    // å
    Message hearBuriedCivilianMsg = new Message(nowTime,imp,length,com,data);
    return hearBuriedCivilianMsg;
  }

  /********************************************************************/
  /** HaltMessage 롣<BR><BR>
   * @return AA_HALT_* ޥ񤭹ޤ줿
   *         HaltMessage˼Ԥnull
   **/
  public Message makeHaltMessage(){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_HALT_FB;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_HALT_AT;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_HALT_PF;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeHaltMessage()]");
      return null;
    }

    // ǡγͤκ
    Civilian myself = objectDB.getCivilianObject(userID);
    int myPosition = myself.getPosition(); // Position

    // ǡκ
    int[] data = {userID,myPosition};

    // å
    Message haltMsg = new Message(nowTime,imp,length,com,data);
    return haltMsg;
  }

  /********************************************************************/
  /** CongestedMessage 롣<BR>
   * Υ᥽åɤϰwantToGoRoadIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param wantToGoRoadID ưƻϩID
   * @return AA_CONGESTED_* ޥ񤭹ޤ줿
   *         CongestedMessage˼Ԥnull
   **/
  public Message makeCongestedMessage(int wantToGoRoadID){
    int imp = Message.IMPORTANCE_MIDDLE; // (ͥ)MIDDLE˥å
    int length = 13; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_CONGESTED_FB;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_CONGESTED_AT;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_CONGESTED_PF;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeCongestedMessage()]");
      return null;
    }
    // ƻϩIDå
    if(objectDB.hasRoadObject(wantToGoRoadID) == false){
      //System.err.print("¸ߤʤRoadIDǤ");
      //System.err.println("[makeCongestedMessage()]");
      return null;
    }

    // ǡγͤκ
    Civilian myself = objectDB.getCivilianObject(userID);
    int myPosition = myself.getPosition(); // Position

    // ǡκ
    int[] data = {userID,myPosition,wantToGoRoadID};

    // å
    Message congestedMsg = new Message(nowTime,imp,length,com,data);
    return congestedMsg;
  }

  /********************************************************************/
  /** BlockadeMessage 롣<BR>
   * Υ᥽åɤϰblockRoadIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param blockRoadID ưƻϩID
   * @return AA_BLOCKADE_* ޥ񤭹ޤ줿
   *         BlockadeMessage˼Ԥnull
   **/
  public Message makeBlockadeMessage(int blockRoadID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 6; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_BLOCKADE_FB;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_BLOCKADE_AT;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_BLOCKADE_PF;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeBlockadeMessage()]");
      return null;
    }
    // ƻϩIDå
    if(objectDB.hasRoadObject(blockRoadID) == false){
      //System.err.print("¸ߤʤRoadIDǤ");
      //System.err.println("[makeBlockadeMessage()]");
      return null;
    }

    // ǡγͤκ
    Road r = objectDB.getRoadObject(blockRoadID);
    // ĺ[]
    int blockRatio = (int)(((double)r.getBlock()/(double)r.getWidth())*100);

    // ǡκ
    int[] data = {blockRoadID,blockRatio};

    // å
    Message blockadeMsg = new Message(nowTime,imp,length,com,data);
    return blockadeMsg;
  }

  /********************************************************************/
  /** JustFireMessage 롣<BR>
   * Υ᥽åɤϰburningBuildingIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param burningBuildingID вФʪID
   * @return AA_JUST_FIRE_* ޥ񤭹ޤ줿
   *         JustFireMessage˼Ԥnull
   **/
  public Message makeJustFireMessage(int burningBuildingID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 5; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_JUST_FIRE_FB;
    }
    else if(objectDB.hasFireStationObject(userID)){
      com = AA_JUST_FIRE_FS;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_JUST_FIRE_AT;
    }
    else if(objectDB.hasAmbulanceCenterObject(userID)){
      com = AA_JUST_FIRE_AC;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_JUST_FIRE_PF;
    }
    else if(objectDB.hasPoliceOfficeObject(userID)){
      com = AA_JUST_FIRE_PO;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeJustFireMessage()]");
      return null;
    }
    // ʪIDå
    if(objectDB.hasBuildingObject(burningBuildingID) == false){
      //System.err.print("¸ߤʤBuildingIDǤ");
      //System.err.println("[makeJustFireMessage()]");
      return null;
    }
    Building b = objectDB.getBuildingObject(burningBuildingID);
    int fieryness = b.getFieryness(); // ǳ
    // оݤȤʪ˽вľ夫å()
    if(fieryness != 1){
      //System.err.print("ꤷʪϽвľǤϤޤ");
      //System.err.println("[makeJustFireMessage()]: fieryness="+fieryness);
      return null;
    }

    // ǡκ
    int[] data = {burningBuildingID};

    // å
    Message justFireMsg = new Message(nowTime,imp,length,com,data);
    return justFireMsg;
  }

  /********************************************************************/
  /** MoveAsideMessage 롣<BR>
   * Υ᥽åɤϰrescueManIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param rescueManID ɤߤ߽ID
   * @return AA_MOVE_ASIDE_* ޥ񤭹ޤ줿
   *         MoveAsideMessage˼Ԥnull
   **/
  public Message makeMoveAsideMessage(int rescueManID){
    int imp = Message.IMPORTANCE_MIDDLE; // (ͥ)MIDDLE˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_MOVE_ASIDE_FB;
    }
    else if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_MOVE_ASIDE_AT;
    }
    else if(objectDB.hasPoliceForceObject(userID)){
      com = AA_MOVE_ASIDE_PF;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeMoveAsideMessage()]");
      return null;
    }
    // ߽IDå
    if(objectDB.hasFireBrigadeObject(rescueManID) == false &&
       objectDB.hasAmbulanceTeamObject(rescueManID) == false &&
       objectDB.hasPoliceForceObject(rescueManID) == false){
      //System.err.print("¸ߤʤRescueManIDǤ");
      //System.err.println("[makeMoveAsideMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,rescueManID};

    // å
    Message moveAsideMsg = new Message(nowTime,imp,length,com,data);
    return moveAsideMsg;
  }

  /********************************************************************/
  /** ExtinguishMessage 롣<BR>
   * Υ᥽åɤϰextinguishBuildingIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param extinguishBuildingID òоݤηʪID
   * @param direction ò
   * @param hoseX 򤹤xɸ
   * @param hoseY 򤹤yɸ
   * @param waterQuant 
   * @return AA_EXTINGUISH ޥ񤭹ޤ줿
   *         ExtinguishMessage˼Ԥnull
   **/
  public Message makeExtinguishMessage(int extinguishBuildingID, int direction,
				       int hoseX, int hoseY, int waterQuant){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 23; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_EXTINGUISH;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeExtinguishMessage()]");
      return null;
    }
    // ʪIDå
    if(objectDB.hasBuildingObject(extinguishBuildingID) == false){
      //System.err.print("¸ߤʤBuildingIDǤ");
      //System.err.println("[makeExtinguishMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,extinguishBuildingID,direction,
		  hoseX,hoseY,waterQuant};

    // å
    Message extinguishMsg = new Message(nowTime,imp,length,com,data);
    return extinguishMsg;
  }

  /********************************************************************/
  /** ExtinguishFinMessage 롣<BR>
   * Υ᥽åɤϰextinguishBuildingIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param extinguishBuildingID òФʪID
   * @return AA_EXTINGUISH_FIN ޥ񤭹ޤ줿
   *         ExtinguishFinMessage˼Ԥnull
   **/
  public Message makeExtinguishFinMessage(int extinguishBuildingID){
    int imp = Message.IMPORTANCE_MIDDLE; // (ͥ)MIDDLE˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_EXTINGUISH_FIN;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeExtinguishFinMessage()]");
      return null;
    }
    // ʪIDå
    if(objectDB.hasBuildingObject(extinguishBuildingID) == false){
      //System.err.print("¸ߤʤBuildingIDǤ");
      //System.err.println("[makeExtinguishFinMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,extinguishBuildingID};

    // å
    Message extinguishFinMsg = new Message(nowTime,imp,length,com,data);
    return extinguishFinMsg;
  }

  /********************************************************************/
  /** RefillMessage 롣<BR><BR>
   * @return AA_REFILL ޥ񤭹ޤ줿
   *         RefillMessage˼Ԥnull
   **/
  public Message makeRefillMessage(){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 6; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_REFILL;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeRefillMessage()]");
      return null;
    }

    // ǡγͤκ
    FireBrigade fb = objectDB.getFireBrigadeObject(userID);
    // Ŀ[ton]
    int nowTankQuant = (int)((double)(fb.getWaterQuantity())/1000);

    // ǡκ
    int[] data = {userID,nowTankQuant};

    // å
    Message refillMsg = new Message(nowTime,imp,length,com,data);
    return refillMsg;
  }

  /********************************************************************/
  /** RefillFinMessage 롣<BR><BR>
   * @return AA_REFILL_FIN ޥ񤭹ޤ줿
   *         RefillFinMessage˼Ԥnull
   **/
  public Message makeRefillFinMessage(){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 5; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasFireBrigadeObject(userID)){
      com = AA_REFILL_FIN;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeRefillFinMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID};

    // å
    Message refillFinMsg = new Message(nowTime,imp,length,com,data);
    return refillFinMsg;
  }

  /********************************************************************/
  /** RescueMessage 롣<BR>
   * Υ᥽åɤϰrescuedIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param rescuedID ߽оݼID
   * @return AA_RESCUE ޥ񤭹ޤ줿
   *         RescueMessage˼Ԥnull
   **/
  public Message makeRescueMessage(int rescuedID){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_RESCUE;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeRescueMessage()]");
      return null;
    }
    // ߽оݼIDå
    if(objectDB.hasCivilianObject(rescuedID) == false){
      //System.err.print("¸ߤʤ߽оݼIDǤ");
      //System.err.println("[makeRescueMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,rescuedID};

    // å
    Message rescueMsg = new Message(nowTime,imp,length,com,data);
    return rescueMsg;
  }

  /********************************************************************/
  /** RescueFinMessage 롣<BR>
   * Υ᥽åɤϰrescuedIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param rescuedID ߽оݼID
   * @return AA_RESCUE_FIN ޥ񤭹ޤ줿
   *         RescueFinMessage˼Ԥnull
   **/
  public Message makeRescueFinMessage(int rescuedID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_RESCUE_FIN;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeRescueFinMessage()]");
      return null;
    }
    // ߽оݼIDå
    if(objectDB.hasCivilianObject(rescuedID) == false){
      //System.err.print("¸ߤʤ߽оݼIDǤ");
      //System.err.println("[makeRescueFinMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,rescuedID};

    // å
    Message rescueFinMsg = new Message(nowTime,imp,length,com,data);
    return rescueFinMsg;
  }

  /********************************************************************/
  /** LoadMessage 롣<BR>
   * Υ᥽åɤϰloadedIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param loadedID ô夲оݼID
   * @return AA_LOAD ޥ񤭹ޤ줿
   *         LoadMessage˼Ԥnull
   **/
  public Message makeLoadMessage(int loadedID){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_LOAD;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeLoadMessage()]");
      return null;
    }
    // ô夲оݼIDå
    if(objectDB.hasCivilianObject(loadedID) == false){
      //System.err.print("¸ߤʤô夲оݼIDǤ");
      //System.err.println("[makeLoadMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,loadedID};

    // å
    Message loadMsg = new Message(nowTime,imp,length,com,data);
    return loadMsg;
  }

  /********************************************************************/
  /** LoadingMessage 롣<BR>
   * Υ᥽åɤϰloadedIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param loadedID оݼID
   * @return AA_LOADING ޥ񤭹ޤ줿
   *         LoadingMessage˼Ԥnull
   **/
  public Message makeLoadingMessage(int loadedID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_LOADING;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeLoadingMessage()]");
      return null;
    }
    // оݼIDå
    if(objectDB.hasCivilianObject(loadedID) == false){
      //System.err.print("¸ߤʤоݼIDǤ");
      //System.err.println("[makeLoadingMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,loadedID};

    // å
    Message loadingMsg = new Message(nowTime,imp,length,com,data);
    return loadingMsg;
  }

  /********************************************************************/
  /** UnloadMessage 롣<BR>
   * Υ᥽åɤϰloadedIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param loadedID ôоݼID
   * @return AA_UNLOAD ޥ񤭹ޤ줿
   *         UnloadMessage˼Ԥnull
   **/
  public Message makeUnloadMessage(int loadedID){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasAmbulanceTeamObject(userID)){
      com = AA_UNLOAD;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeUnloadMessage()]");
      return null;
    }
    // ôоݼIDå
    if(objectDB.hasCivilianObject(loadedID) == false){
      //System.err.print("¸ߤʤôоݼIDǤ");
      //System.err.println("[makeUnloadMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,loadedID};

    // å
    Message unloadMsg = new Message(nowTime,imp,length,com,data);
    return unloadMsg;
  }

  /********************************************************************/
  /** ClearMessage 롣<BR>
   * Υ᥽åɤϰclearedRoadIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param clearedRoadID ƻϩID
   * @return AA_CLEAR ޥ񤭹ޤ줿
   *         ClearMessage˼Ԥnull
   **/
  public Message makeClearMessage(int clearedRoadID){
    int imp = Message.IMPORTANCE_LOW; // (ͥ)LOW˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasPoliceForceObject(userID)){
      com = AA_CLEAR;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeClearMessage()]");
      return null;
    }
    // ƻϩIDå
    if(objectDB.hasRoadObject(clearedRoadID) == false){
      //System.err.print("¸ߤʤRoadIDǤ");
      //System.err.println("[makeClearMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,clearedRoadID};

    // å
    Message clearMsg = new Message(nowTime,imp,length,com,data);
    return clearMsg;
  }

  /********************************************************************/
  /** ClearFinMessage 롣<BR>
   * Υ᥽åɤϰclearedRoadIDɤå,
   * ǡäΤߥåä֤<BR><BR>
   * @param clearedRoadID ƻϩID
   * @return AA_CLEAR_FIN ޥ񤭹ޤ줿
   *         ClearFinMessage˼Ԥnull
   **/
  public Message makeClearFinMessage(int clearedRoadID){
    int imp = Message.IMPORTANCE_HIGH; // (ͥ)HIGH˥å
    int length = 9; // åĹΥå
    int com; // ޥɤ
    if(objectDB.hasPoliceForceObject(userID)){
      com = AA_CLEAR_FIN;
    }
    else{
      //System.err.print("Υå븢ޤ");
      //System.err.println("[makeClearFinMessage()]");
      return null;
    }
    // ƻϩIDå
    if(objectDB.hasRoadObject(clearedRoadID) == false){
      //System.err.print("¸ߤʤRoadIDǤ");
      //System.err.println("[makeClearFinMessage()]");
      return null;
    }

    // ǡκ
    int[] data = {userID,clearedRoadID};

    // å
    Message clearFinMsg = new Message(nowTime,imp,length,com,data);
    return clearFinMsg;
  }

  /********************************************************************/
}
