/*
  # SenseInfoParser.java
  # $Id: SenseInfoParser.java,v 1.4 2002/06/08 08:36:34 yoshikia Exp $
  */

package rescueAgent.ObjectSet;

import java.util.*;
import rescueAgent.IO.*;
import rescueAgent.RescueObject.*;
import rescueAgent.RescueLib.ServerSetting;

/**
 * Ķ򰷤Υ饹
 **/
public class SenseInfoParser implements CommandTable{
  /** data of packet **/
  int[] dataArray;

  /** Table of RescueObject **/
  ObjectDatabase objectDB;
  /** ѿȤäƤʤ! **/
  Civilian self;
  /** MyID **/
  int selfID;
  /** MyJobType(ex. 233...FireBrigade) **/
  int selfType;

  /** length of dataArray **/
  int dataLength;
  /** ߻(ǿ) **/
  int time = 0;
  /** ǡ(Υǡ줿ǿǤϤʤȤ!!) **/
  private int datatime = 0;

  /** 줿֥ȤIDΥå **/
  private Vector renewObjectIDset = new Vector();

  boolean verbose = false;

  /********************************************************************/
  // 󥹥ȥ饯
  /**
   * @deprecated ȤƤʤषǽȺΤ,
   *             Ȥʤ褦ˤ뤳ȡäƤ⤤⡩
   **/
  public SenseInfoParser(int[] intArray){
    setBuffer(intArray);
  }

  /********************************************************************/

  public SenseInfoParser(ObjectDatabase objectDatabase){
     objectDB = objectDatabase;
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/
  /** Ϥåǡ򤳤Υ饹Υѿ˳Ǽ,
   * 饹ΤɤǤɤ褦ˤ뤿Υ᥽åɡ
   * @param intArray åǡ(åإåϴޤޤʤ)
   **/
  void setBuffer(int[] intArray){
    initAll();
    dataArray = intArray;
    dataLength = intArray.length;
    //System.out.println("DataLength : " + dataLength);
  }

  /********************************************************************/

  void initAll(){
  }

  /********************************************************************/
  /** check number within object code
   * @param no TYPE number
   * @return "no" is TYPE number... true, or false.
   **/
  boolean isTypeNumber(int no){
    if(no == ServerSetting.TYPE_BUILDING || 
       no == ServerSetting.TYPE_ROAD || 
       no == ServerSetting.TYPE_NODE ||
       no == ServerSetting.TYPE_CIVILIAN || 
       no == ServerSetting.TYPE_FIREBRIGADE ||
       no == ServerSetting.TYPE_AMBULANCETEAM || 
       no == ServerSetting.TYPE_POLICEFORCE ||
       no == ServerSetting.TYPE_REFUGE || 
       no == ServerSetting.TYPE_FIRESTATION ||
       no == ServerSetting.TYPE_AMBULANCECENTER || 
       no == ServerSetting.TYPE_POLICEOFFICE ||
       no == ServerSetting.TYPE_WORLD)
      return true;
    else
      return false;
  }

  /********************************************************************/
  /** ϥХåեΡKA_SENSE λϤäƤФ롣<BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   **/
  public void parseSenseInfo(int[] msg_header, int[] msg_data){
    parseSenseInfo(msg_header, msg_data, null); // ꤲ
  }

  /********************************************************************/
  /** ϥХåեΡ<BR>
   * ǰȤʤäƤ msg_header, msg_data ,
   * ɬio.receive()ǼåΤΤɽƤ櫓ǤϤʤ
   * <BR>ȤΤ⡢Υ᥽åɤϼξ˸ƤФ뤫Ǥ롣<BR><BR>
   * 1:åإå KA_SENSE λ <BR>
   *   ξ,  msg_geader, msg_data 
   *   ΰͿƥ᥽åɤƤФΤäϤʤ<BR><BR>
   * 2:åإå KA_HEAR* ,  HearInfoParser ƤФ <BR>
   *   ̾盧Υ᥽åɤ, KA_HEAR* ˤϸƤФʤ,ǡȤ
   *   SENSEǡ, ⤷Ϥʳ object 򹹿褦ʥޥ
   *   (AA_BURIED_* )λ, ǽŪ HearInfoParser Υ᥽åɤƤ֡
   *   <BR>
   *   ξ, msg_header ˤϲͶ(¤줿)إåǼ뤳Ȥˤʤ,
   *   msg_data ˤ KA_HEAR* , SENSE줿ǡ int[]
   *   ѴΤǼ뤳Ȥˤʤ롣<BR>
   *   , Ͷإåϰʲν񼰤˽ΤȤ롣<BR>
   *   msg_header[4]={KA_HEAR*,-1,-1,datatime} (datatime...data줿)
   *   <BR><BR>
   * 3:åإå KA_HEAR* ,  Controller ѥåƤФ
   *   <BR> Controller Ϲ٤ʥ֥ȹλľܸƤФ롣<BR>
   *   Υ᥽åɤϤإå, ¤λ⤢롣(ä˸KA_SENSEλ) <BR>
   *   ɤˤ, msg_data ˤ SENSE줿ǡ, msg_header
   *   ˤ, ʲν񼰤˽äͶإåǼƤ롣<BR>
   *   msg_header[4]={KA_HEAR*,-1,-1,datatime} (datatime...data줿)
   *   <BR><BR>
   * @param msg_header åإå
   * @param msg_data åǡ
   * @param renewIDset ȤƤΥ֥ȤIDꥹ
   **/
  public void parseSenseInfo(int[] msg_header, int[] msg_data, Vector set){
    int index = 0;  // INDEX of MessageData
    setBuffer(msg_data);

    switch(msg_header[0]){
    case KA_SENSE:
      selfID = msg_header[2]; // Set self ID
      datatime = msg_header[3]; // Set datatime
      time = datatime; // Set time
      objectDB.setTime(time); 
      selfType = msg_data[0]; // Set self Type
    case KA_CONNECT_OK:
      clearRenewObjectsID(); // ObjectåȤ򥯥ꥢ(Τ)
      break;
    case KA_HEAR:
    case KA_HEAR_SAY:
    case KA_HEAR_TELL:
      datatime = msg_header[3]; // Set datatime
      break;
    default:
      //System.err.print("̤ΤΥåإå(SenseInfoParser): ");
      //System.err.println(msg_header[0]);
      return;
    }

    while(index<dataLength){
      if(isTypeNumber(dataArray[index])){
	switch(dataArray[index]){ // ֥Ȥʤ̤˲
	case ServerSetting.TYPE_BUILDING:
	  index += parseObject(ServerSetting.TYPE_BUILDING,index,set);
	  break;
	case ServerSetting.TYPE_ROAD:
	  index += parseObject(ServerSetting.TYPE_ROAD,index,set);
	  break;
	case ServerSetting.TYPE_NODE:
	  index += parseObject(ServerSetting.TYPE_NODE,index,set);
	  break;
	case ServerSetting.TYPE_REFUGE:
	  index += parseObject(ServerSetting.TYPE_REFUGE,index,set);
	  break;
	case ServerSetting.TYPE_CIVILIAN:
	  index += parseObject(ServerSetting.TYPE_CIVILIAN,index,set);
	  break;
	case ServerSetting.TYPE_FIREBRIGADE:
	  index += parseObject(ServerSetting.TYPE_FIREBRIGADE,index,set);
	  break;
	case ServerSetting.TYPE_AMBULANCETEAM:
	  index += parseObject(ServerSetting.TYPE_AMBULANCETEAM,index,set);
	  break;
	case ServerSetting.TYPE_POLICEFORCE:
	  index += parseObject(ServerSetting.TYPE_POLICEFORCE,index,set);
	  break;
	case ServerSetting.TYPE_FIRESTATION:
	  index += parseObject(ServerSetting.TYPE_FIRESTATION,index,set);
	  break;
	case ServerSetting.TYPE_AMBULANCECENTER:
	  index += parseObject(ServerSetting.TYPE_AMBULANCECENTER,index,set);
	  break;
	case ServerSetting.TYPE_POLICEOFFICE:
	  index += parseObject(ServerSetting.TYPE_POLICEOFFICE,index,set);
	  break;
	case ServerSetting.TYPE_WORLD:
	  index += parseObject(ServerSetting.TYPE_WORLD,index,set);
	  break;
	default:
	  //System.out.print("(" + index + ")" + dataArray[index] + " ");
	}// end switch(dataArray[index]) 
	index++; // count sentinel
      }
      else if(dataArray[index] == 0){
      }
      else{
	//System.out.print("(" + index + ")" + dataArray[index] + " ");	
      }
      index++; // count for next
    }
  }

  /********************************************************************/
  /** ֥ȥǡTYPE̤˲Ϥǡ򹹿᥽åɡ<BR><BR>
   * @param TYPE ֥ȥǡ(ex. 233...FB)
   * @param index Ϥǡ(int[] dataArray)ɤߤȤ곫ϰ
   * @return ɤߤȤäǡ(ʬɤߤȤä)
   **/
  private int parseObject(int TYPE, int index, Vector renewIDset){
    RescueObject obj = objectDB.getObject(dataArray[index+1]);
    if(obj instanceof RealObject){ // ֤γǰ륪֥Ȥξ
	//System.out.print("parseObject() ... objType:"+TYPE+",objID:"
	//	       +((RealObject)obj).getID()+",nowObjDataTime:"
	//	       +((RealObject)obj).getTime()+",receiveObjDataTime:"
	//	       +datatime);
      if(datatime <= ((RealObject)obj).getTime()){ // ι֤
	//System.out.println(" -> Go dummy phase!!");
	// 󤬸ŤϹ򤷤ʤ(äꡣ)
	// 㤨СвлξϡǿΥǡäƤ
	//         ꡢŤǡäƤ礬롣
	//         âвлФƤϡޥ AA_JUST_FIRE_* 
	//         СǤΤǸλͤǤʤ
	//         (¾ˤͤʾˤʤץѥƥ̵Фä)
	return dummyParse(index,dataArray); // ߡιؿʤ
      }
      //System.out.println(" -> Go parse phase!!");
    }
    if(obj==null){
      switch(TYPE){
      case ServerSetting.TYPE_BUILDING:
	obj = new Building(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_ROAD:
	obj = new Road(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_NODE:
	obj = new Node(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_CIVILIAN:
	obj = new Civilian(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_FIREBRIGADE:
	obj = new FireBrigade(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_AMBULANCETEAM:
	obj = new AmbulanceTeam(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_POLICEFORCE:
	obj = new PoliceForce(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_REFUGE:
	obj = new Refuge(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_FIRESTATION:
	obj = new FireStation(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_AMBULANCECENTER:
	obj = new AmbulanceCenter(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_POLICEOFFICE:
	obj = new PoliceOffice(dataArray[index+1],datatime);
	break;
      case ServerSetting.TYPE_WORLD:
	obj = new World(dataArray[index+1]);
	break;
      default:
	//System.err.println("ObjectDatabase: No Type Matching : " + TYPE);
	return 0;
      }
      objectDB.addObject(dataArray[index+1],obj);
    }
    //int ret = obj.parseInfo(index,dataArray,datatime);
    //obj.printInfo();
    //return ret;

    // դ
    if(renewIDset == null){ // KA_SENSE ΤȤ
      setRenewObjectID(new Integer(dataArray[index+1]));
    }
    else{ //  KA_HEAR* ꤲ줿Ȥ
      setRenewObjectID(new Integer(dataArray[index+1]), renewIDset);
    }

    return obj.parseInfo(index,dataArray,datatime);
  }

  /********************************************************************/
  /** Υ֥ȥǡβϤ򤪤ʤ᥽åɡ<BR><BR>
   * @param start Ϥǡ(int[] data)ɤߤȤ곫ϰ
   * @param data ֥ȥǡ
   * @return ɤߤȤ(=ɤФ)ǡ(ʬɤߤȤä)
   **/
  private int dummyParse(int start,int[] data){
    int offset = 2; // ̵ͤͭˤ뺹ʬ׻
    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      // Building,Road,Node,FireBrigade ΥץѥƥƳѤ 
      case   3: // X
      case   4: // Y
      case   6: // Position
      case   7: // PositionExtra
      case   9: // Stamina
      case  10: // HP
      case  11: // Damage
      case  12: // Head
      case  13: // Tail
      case  14: // Floors
      case  15: // BuildingAttribute
      case  16: // Fieryness
      case  17: // Brokenness
      case  19: // RoadKind
      case  22: // Block
      case  23: // Buriedness
      case  24: // Length
      case  25: // WaterQuantity
      case  26: // StrechedLength
      case  27: // Direction
      case  34: // CarPassToHead
      case  35: // CarPassToTail
      case  36: // HumanPassToHead
      case  37: // HumanPassToTail
      case  38: // Width
      case  39: // RepairCost
      case  40: // MedianStrip
      case  41: // LinesToHead
      case  42: // LinesToTail
      case  43: // WidthForWalks
      case  44: // Signal
      case  48: // Ignition
      case  49: // BuildingShapeID
      case  50: // BuildingCode
      case  51: // BuildingAreaGround
      case  52: // BuildingAreaTotal
	offset += 2;
	break;
      case 128: // ShortCutToTurn
      case 129: // PocketToTurnAcross
      case 130: // SignalTiming
      case 131: // BuildingApexes
        if(data[start+offset+1]/4 == 0){
  	  //System.err.print("Parse Error [dummyParse()] :");
  	  //System.err.print("Proparty..."+data[start+offset]);
	  //System.err.println(", NextValue..."+data[start+offset+1]);
	  return offset-1; // ꤨʤǡʤΤɤ߹߽λ
	}
	offset += data[start+offset+1]/4 + 2;
	break;
      case 207: // PositionHistory
      case 235: // Entrances
      case 242: // Edge
	int counter = 0;
	while(data[start+counter+offset+1]!=0){
	  counter++;
	}
	offset += counter+2;
	break;
      default:
	// Illegal Data
	//System.err.print("Illegal Data!! ("+(start+offset)+")");
	//System.err.println(data[start+offset]); // Illegal Data ʬɽ
	//System.err.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  //System.err.print(data[start+i] + " "); // IllegalμDataɽ
	}
	//System.err.println();
	offset++;
      }// end switch(data[start+offset])
    }// end while(data[start+offset] != 0)
    return offset-1; // use array length in this object
  }

  /********************************************************************/
  /**
   * ߤμʬξ֤֤
   * <BR><BR>
   * @return ߤμʬξ
   **/
  public RescueObject getSelfInfo(){
    return objectDB.getObject(selfID,selfType);
  }

  /********************************************************************/
  /**
   * ߻(ǿ)δ֤˹줿֥ȤIDꥹȤ֤
   * @deprecated public java.util.Vector getLatestRenewAllObjectID()
   *             ˰ܹͽꡣ
   * @return ObjectIDΥꥹ
   **/
  public Vector getRcvObjectList(){
    return renewObjectIDset;
  }

  /********************************************************************/
  /**
   * Τä֥ȤIDꥹȤ֤<BR> Τˤ, 
   * clearRenewObjectsID() Ǿ򥯥ꥢ鸽ߤޤǤ KA_SENSE
   * ˤäƾ󤬹줿֥ȤIDΥꥹȤ֤<BR><BR>
   * @return ObjectIDΥꥹ
   **/
  public Vector getRenewObjectsID(){
    return renewObjectIDset;
  }

  /********************************************************************/
  /**
   * Τä֥ȤIDꥹȤ˥åȤ롣<BR>
   * ΤȤʤ顢Υ饹ʳϤΥ᥽åɤϸƤ٤ʤ<BR><BR>
   * @param id ΤäObjectID
   **/
  private void setRenewObjectID(Integer id){
    renewObjectIDset.add(id);
  }

  /********************************************************************/
  /**
   * Τä֥ȤIDꤷꥹȤ˥åȤ롣<BR>
   * Ūˤ HearInfoParser.java ꤲ줿󥹷ޥɤФ,
   * 򥻥åȤΤ˻Ȥ롣⳰ϸƤ٤ʤ͡<BR><BR>
   * @param id ΤäObjectID
   **/
  private void setRenewObjectID(Integer id, Vector renewIDset){
    renewIDset.add(id);
  }

  /********************************************************************/
  /**
   * ޤǤΥ֥ȤIDꥹȤ򥯥ꥢ롣<BR>
   * Υ饹ǤϥꥢϹԤʤʤä,
   * ̥饹ǤŪ˹Ԥʤʤ,
   * ꥹȤä³뤳Ȥˤʤ롣<BR><BR>
   **/
  public void clearRenewObjectsID(){
    renewObjectIDset.clear();
  }

  /********************************************************************/
}
