/*
  # Building.java
  # $Id: Building.java,v 1.3 2002/05/13 10:45:18 yoshikia Exp $
  */

package rescueAgent.RescueObject;
/**
 * Rescueߥ졼Ƿʪ֥Ȥɽ륯饹
 **/

public class Building extends PointObject{
  // ߥ졼ץѥƥ
  private int floors = -1;
  private int attribute = -1;
  private int ignition = -1;
  private int fieryness = -1;
  private int brokenness = -1;
  private int[] entrance;
  private int shapeID = -1;
  private int code = -1;
  private int areaGround = -1;
  private int areaTotal = -1;
  private int[] apexes;

  // ¾Υץѥƥ
  private int ignition_time = -1; // вл
  private double tp_alpha = -1; // ǳƻη

  /********************************************************************/
  // 󥹥ȥ饯
  /**
   * @param id   ֥ID
   * @param time 󹹿򤪤ʤä
   **/

  public Building(int id,int time){
    init(id,time);
  }

  /********************************************************************/

  public Building(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  void init(int id,int time){
    setID(id);
    setTime(time);
  }

  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_X)
      setX(value[0]);
    else if(propID == PROPERTY_Y)
      setY(value[0]);
    else if(propID == PROPERTY_FLOORS)
      setFloors(value[0]);
    else if(propID == PROPERTY_BUILDING_ATTRIBUTES)
      setAttribute(value[0]);
    else if(propID == PROPERTY_IGNITION)
      setIgnition(value[0]);
    else if(propID == PROPERTY_FIERYNESS)
      setFieryness(value[0]);
    else if(propID == PROPERTY_BROKENNESS)
      setBrokenness(value[0]);
    else if(propID == PROPERTY_ENTRANCES)
      setEntrance(value);
    else if(propID == PROPERTY_BUILDING_SHAPE_ID)
      setShapeID(value[0]);
    else if(propID == PROPERTY_BUILDING_CODE)
      setCode(value[0]);
    else if(propID == PROPERTY_BUILDING_AREA_GROUND)
      setAreaGround(value[0]);
    else if(propID == PROPERTY_BUILDING_AREA_TOTAL)
      setAreaTotal(value[0]);
    else if(propID == PROPERTY_BUILDING_APEXES)
      setApexes(value);
  }

  /********************************************************************/
  /**
   * ֥Ⱦι<BR>
   * Building(176) and SubClass(Refuge(184),FireStation(185),
   * AmbulanceCenter(186),PoliceOffice(187)) Parser: <BR>
   *   Type(ex.176),ID(ex.1521),X,Y,Floors,BuildingAttribute,Ignition,
   *   Fieryness,Brokenness,Entrance(list),BuildingShapeID,BuildingCode,
   *   BuildingAreaGround,BuildingAreaTotal,BuildingApexes(list) <BR><BR>
   *
   *  (NUM)[=Parameter Name]            Attribute      (Value) <BR>
   *  -------------------------------------------------------------------- <BR>
   *  (  3)[=PROPERTY_X]                X              (PositiveIntNumber) <BR>
   *  (  4)[=PROPERTY_Y]                Y              (PositiveIntNumber) <BR>
   *  ( 14)[=PROPERTY_FLOORS]           Floors         (PositiveIntNumber) <BR>
   *  ( 15)[=PROPERTY_BUILDING_ATTRIBUTES] BuildingAttribute
   *                                                   (PositiveIntNumber) <BR>
   *  ( 48)[=PROPERTY_IGNITION]         Ignition       (0 or 1) <BR>
   *  ( 16)[=PROPERTY_FIERYNESS]        Fieryness      (PositiveIntNumber) <BR>
   *  ( 17)[=PROPERTY_BROKENNESS]       Brokenness     (PositiveIntNumber) <BR>
   *  (235)[=PROPERTY_ENTRANCES]        Entrance       (NodeObjectIDs list)<BR>
   *  ( 49)[=PROPERTY_BUILDING_SHAPE_ID]BuildingShapeID(BuildingShapeID) <BR>
   *  ( 50)[=PROPERTY_BUILDING_CODE]    BuildingCode   (PositiveIntNumber) <BR>
   *  ( 51)[=PROPERTY_BUILDING_AREA_GROUND] BuildingAreaGround
   *                                                   (PositiveIntNumber) <BR>
   *  ( 52)[=PROPERTY_BUILDING_AREA_TOTAL] BuildingAreaTotal
   *                                                   (PositiveIntNumber) <BR>
   *  (131)[=PROPERTY_BUILDING_APEXES]  BuildingApexes (Pos.Int.Nums list) <BR>
   * <BR>
   * @param start int[] data ɤߤȤǡγϰ
   * @param data ֥ȥǡ
   * @param time Ϥǡ줿
   * @return ɤߤȤäǡ(ʬɤߤȤä)
   **/
  public int parseInfo(int start,int[] data,int time){

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    setTime(time);

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case  3 : // Building X
	offset += setX(data[start+offset+1]);
	break;
      case  4 : // Building Y
	offset += setY(data[start+offset+1]);
	break;
      case  14: // Floors
	offset += setFloors(data[start+offset+1]);
	break;
      case  15: // BuildingAttribute
	offset += setAttribute(data[start+offset+1]);
	break;
      case  48: // Ignition
	offset += setIgnition(data[start+offset+1]);
	break;
      case  16: // Fieryness
	offset += setFieryness(data[start+offset+1]);
	break;
      case  17: // Brokenness
	offset += setBrokenness(data[start+offset+1]);
	break;
      case 235: // Entrance
	int counter = 0;
	while(data[start+counter+offset+1]!=0){
	  counter++;
	}
	if(counter!=0){ // Entrance
	  int[] psHist = new int[counter];
	  try{
	    System.arraycopy(data,start+offset+1,psHist,0,counter);
	  }
	  catch(Exception e){
	    e.printStackTrace();
	  }
	  offset += setEntrance(psHist);
	}
	else{ // Entranceʤ
	  offset += setEntrance(null);
	}
	break;
      case  49: // BuildingShapeID
	offset += setShapeID(data[start+offset+1]);
	break;
      case  50: // BuildingCode
	offset += setCode(data[start+offset+1]);
	break;
      case  51: // BuildingAreaGround
	offset += setAreaGround(data[start+offset+1]);
	break;
      case  52: // BuildingAreaTotal
	offset += setAreaTotal(data[start+offset+1]);
	break;
      case 131: // BuildingApexes
        if(data[start+offset+1]/4 == 0){ // TrueˤϤʤʤϤ
  	  System.err.println("SIP.parseBuildingInfo : BA.lenght = 0");
	  return offset-1; // ꤨʤǡʤΤBuildingȤƤõλ
        }
        int[] BAlist = new int[data[start+offset+1]/4];    
        try{
	  System.arraycopy(data,start+offset+2,BAlist,0,BAlist.length);
        }
        catch(Exception e){
	  e.printStackTrace();
        }
        offset += setApexes(BAlist);
	break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    //  //
    if (time == 0){
      // ǳƻη׻
      // Todo : ® 0m/s ȲꤷƤΤ
      switch(code){
      case 0:
	// ¤ʪ
	tp_alpha = 1.0/(50*1*Math.sqrt(areaTotal/100.0));
	//System.out.println("ʪ id = " + getID() + " ǳƻ淸 = " + tp_alpha + " ¤");
	break;
      case 1:
	// Ŵʪ
	tp_alpha = 1.0/(80*1*Math.sqrt(areaTotal/100.0));
	//System.out.println("ʪ id = " + getID() + " ǳƻ淸 = " + tp_alpha + " Ŵ");
	break;
      case 2:
	// Ŵڥ󥯥꡼ȷʪ
	tp_alpha = 1.0/(120*1*Math.sqrt(areaTotal/100.0));
	//System.out.println("ʪ id = " + getID() + " ǳƻ淸 = " + tp_alpha + " Ŵڥ󥯥꡼");
	break;
      default:
	System.out.println("ʪ¤̥ɤθǤ code = " + code);
      }
    }

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  // вл
  public void setIgnitionTime(int time){
    this.ignition_time = time;
  }

  /********************************************************************/

  int setFloors(int floor){
    this.floors = floor;
    return 2;
  }

  /********************************************************************/

  int setAttribute(int attribute){
    this.attribute = attribute;
    return 2;
  }

  /********************************************************************/

  int setIgnition(int ignition){ // no entry in ver.0.31
    this.ignition = ignition;
    return 2;
  }

  /********************************************************************/

  int setFieryness(int fieryness){
    // вФϻ򥻥å
    if (this.fieryness == 0 && 0 < fieryness){
      setIgnitionTime(getTime());	
    }
    this.fieryness = fieryness;
    return 2;
  }

  /********************************************************************/

  int setBrokenness(int brokenness){
    this.brokenness = brokenness;
    return 2;
  }

  /********************************************************************/

  int setEntrance(int[] entrance){
    if(entrance == null){
      return 2;
    }
    this.entrance = entrance;
    return entrance.length + 2;
  }

  /********************************************************************/

  int setShapeID(int id){ // ʤ
    this.shapeID = id;
    return 2;
  }

  /********************************************************************/

  int setCode(int code){
    this.code = code;
    return 2;
  }

  /********************************************************************/

  int setAreaGround(int areaGround){
    this.areaGround = areaGround;
    return 2;
  }

  /********************************************************************/

  int setAreaTotal(int areaTotal){
    this.areaTotal = areaTotal;
    return 2;
  }

  /********************************************************************/

  int setApexes(int[] apexes){
    if(apexes == null){
      return 2;
    }
    this.apexes = new int[apexes.length];
    for(int i=0;i<apexes.length;i++)
      this.apexes[i] = apexes[i];
    return apexes.length + 2;
  }

  /********************************************************************/
  /**
   * ηʪвФ֤
   *<BR><BR>
   * @return вФ
   **/

  public int getIgnitionTime(){
    return ignition_time;
  }

  /********************************************************************/
  /**
   * ηʪγ֤
   *<BR><BR>
   * @return ʪγ
   **/

  public int getFloors(){
    return floors;
  }

  /********************************************************************/

  protected int getAttribute(){
    return attribute;
  }

  /********************************************************************/

  protected int getIgnition(){
    return ignition;
  }

  /********************************************************************/
  /**
   * ηʪǳ(ǳƤ)֤<BR>
   * 0 : ǳƤʤ <BR>
   * 1 : ǳƤ(ǳ 30%) <BR>
   * 2 : 빽ǳƤ(ǳ 30%60%) <BR>
   * 3 : ʤǳƤ(ǳ 60%) <BR>
   * 4 : ǳƾò<BR>
   * 5 : 빽ǳƾò<BR>
   * 6 : ʤǳƾò<BR>
   * 7 : ǳԤ<BR>
   *<BR><BR>
   * @return ηʪǳ
   **/

  public int getFieryness(){
    return fieryness;
  }

  /********************************************************************/

  public int getBrokenness(){
    return brokenness;
  }

  /********************************************************************/

  protected int getCode(){
    return code;
  }

  /********************************************************************/

  protected int getShapeID(){ // ¸ߤƤʤ!?
    return shapeID;
  }

  /********************************************************************/
  /**
   * ηʪ³Ƥ륪֥(Node)ID֤
   * ʼºݤʣ¸ߤ⤢뤬,ʳǤϰĤ
   *<BR><BR>
   * @return ³Ƥ륪֥ȤID
   **/

  public int getEntrance(){
    return entrance[0]; // tmp!!
  }

  /********************************************************************/
  /**
   * ηʪξѤ֤
   *<BR><BR>
   * @return 
   **/

  public int getAreaGround(){
    return areaGround;
  }

  /********************************************************************/
  /**
   * ηʪѤ֤
   *<BR><BR>
   * @return ????
   **/

  public int getAreaTotal(){
    return areaTotal;
  }

  /********************************************************************/

  public String getType(){
    return "Building";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println("Building ID    : " + getID());
    System.out.println("     Time      : " + getTime());
    System.out.println("     X         : " + getX());
    System.out.println("     Y         : " + getY());
    System.out.println("     Floor     : " + floors);
    System.out.println("     Attribute : " + attribute);
    System.out.println("     Ignition  : " + ignition);
    System.out.println("     Fieryness : " + fieryness);
    System.out.println("     Brokenness: " + brokenness);
    if(entrance != null)
      System.out.println("     Entrance  : " + entrance[0]); //tmp
    else
      System.out.println("     Entrance  : -1"); //tmp
    System.out.println("     ShapeID   : " + shapeID);
    System.out.println("     Code      : " + code);
    System.out.println("     AreaGround: " + areaGround);
    System.out.println("     AreaTotal : " + areaTotal);
    /*
    for(int i=0;i<apexes.length;i++)
      if(i==0)
	System.out.println("      apexes   : " + apexes[i]);
      else
	System.out.println("               : " + apexes[i]);
	*/
  }

  /********************************************************************/
  /********************************************************************/
  // äǳƤΤߤȽ

  public boolean isBurnningLittle(){
    if(fieryness == 1)
      return true;
    else
      return false;
  }

  /********************************************************************/

  public boolean isBurnning(){
    if(fieryness == 1 || fieryness == 2 || fieryness == 3 )
      return true;
    else
      return false;
  }

  /********************************************************************/

  public boolean alreadyBurnning(){
    if(fieryness >= 4)
      return true;
    else
      return false;
  }

  /********************************************************************/

  public boolean isBurnningLWithAG(){
    if(fieryness == 1)
      return true;
    else if(fieryness == 2 && areaGround < 2500)
      return true;
    else
      return false;
  }

  /********************************************************************/

  public int getApexesLength(){
    return apexes.length;
  }

  /********************************************************************/
  /*  */
  // ηʪβкòФɬפ(t) (ϤʤȲ)֤
  public double getRequiredWater(int now_time){
    if (ignition_time == -1){
      // ޤвФƤʤ
      return -1.0;
    }

    switch(code){
    case 1:
      // ¤
      return ((areaTotal*120)/60)*(1-p(tp(now_time)))*(p(tp(now_time))-p(tp(now_time-1)));
    case 2:
      // Ŵ
      return ((areaTotal*120)/60)*(1-p(tp(now_time)))*(p(tp(now_time))-p(tp(now_time-1)));
    }
    // Ŵڥ󥯥꡼
    return ((areaTotal*30)/60)*(1-p(tp(now_time)))*(p(tp(now_time))-p(tp(now_time-1)));
  }
  
  public double tp(int now_time){
    if (ignition_time == -1 && (ignition_time != -1 && now_time < ignition_time)){
      // вФƤʤ,ޤϽвФƤ뤬郎Ǥ
      return -1.0;
    }
    else if (ignition_time != -1 && now_time == ignition_time){
      // вФƱ
      return 0;
    }    
    return tp_alpha * (now_time - ignition_time);
  }

  public double p(double tp){
    if (tp == -1.0){
      return 0.0;
    }
    return 1.0/(1.0+Math.exp(-7.8*(tp-0.4)));
  }

  /********************************************************************/


}
