package rescueAgent.RescueObject;
/**
 * Rescueߥ졼ǰ̻̱ϤȤʹ(ã)ɽ
 **/

public class Civilian extends MovingObject{
  private int stamina = -1;
  private int HP = -1;
  private int damage = -1;
  private int buriedness = -1;
  private int direction = -1;
  protected int[] positionHistory = new int[48];

  /********************************************************************/
  // 󥹥ȥ饯
  /**
   * @param id   ֥ID
   * @param time ֥Ȥξ󹹿줿
   **/

  public Civilian(int id,int time){
    init(id,time);
  }

  /********************************************************************/

  public Civilian(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  void init(int id,int time){
    setID(id);
    setTime(time);
  }

  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_POSITION)
      setPosition(value[0]);
    else if(propID == PROPERTY_POSITION_EXTRA)
      setPositionExtra(value[0]);
    else if(propID == PROPERTY_STAMINA)
      setStamina(value[0]);
    else if(propID == PROPERTY_HP)
      setHP(value[0]);
    else if(propID == PROPERTY_DAMAGE)
      setDamage(value[0]);
    else if(propID == PROPERTY_BURIEDNESS)
      setBuriedness(value[0]);
    else if(propID == PROPERTY_DIRECTION)
      setDirection(value[0]);
    else if(propID == PROPERTY_POSITION_HISTORY)
      setPositionHistory(value);
  }

  /********************************************************************/

  public int parseInfo(int start,int[] data,int time){
    /*
      Civilian(232) Parser:
        Type(232),ID(ex.1521),Position,PositionExtra,Stamina,HP,Damage,
        Buriedness,Direction,PositionHistory(list)

      (NUM)[=Parameter Name]            Attribute       (Value)
      ---------------------------------------------------------------------
      (  6)[=PROPERTY_POSITION]         Position        (ObjectID or 0)
      (  7)[=PROPERTY_POSITION_EXTRA]   PositionExtra   (PositiveIntNumber)
      (  9)[=PROPERTY_STAMINA]          Stamina         (PositiveIntNumber)
      ( 10)[=PROPERTY_HP]               HP              (PositiveIntNumber)
      ( 11)[=PROPERTY_DAMAGE]           Damage          (PositiveIntNumber)
      ( 23)[=PROPERTY_BURIEDNESS]       Buriedness      (PositiveIntNumber)
      ( 27)[=PROPERTY_DIRECTION]        Direction       (0~1295999)
      (207)[=PROPERTY_POSITION_HISTORY] PositionHistory (ObjectIDs list)
    */

    // test !!!
    /*
    System.err.println();
    for(int i=0;i<30;i++){
      System.err.print(data[start+i] + " ");
    };
    System.err.println();
    */
    // test !!!

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    setTime(time);

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case  6 : // Position
	offset += setPosition(data[start+offset+1]);
	break;
      case  7 : // PositionExtra
	offset += setPositionExtra(data[start+offset+1]);
	break;
      case  9 : // Stamina
	offset += setStamina(data[start+offset+1]);
	break;
      case 10 : // HP
	offset += setHP(data[start+offset+1]);
	break;
      case 11 : // Damage
	offset += setDamage(data[start+offset+1]);
	break;
      case 23 : // Buriedness
	offset += setBuriedness(data[start+offset+1]);
	break;
      case 27 : // Direction
	offset += setDirection(data[start+offset+1]);
	break;
      case 207: // PositionHistory
	int counter = 0;
	while(data[start+counter+offset+1]!=0){
	  counter++;
	}
	if(counter!=0){ // PHist
	  int[] psHist = new int[counter];
	  try{
	    System.arraycopy(data,start+offset+1,psHist,0,counter);
	  }
	  catch(Exception e){
	    e.printStackTrace();
	  }
	  offset += setPositionHistory(psHist);
	}
	else{ // PHistʤ
	  offset += setPositionHistory(null);
	}
	break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  int setStamina(int stamina){
    this.stamina = stamina;
    return 2;
  }

  /********************************************************************/

  int setHP(int HP){
    this.HP = HP;
    return 2;
  }

  /********************************************************************/

  int setDamage(int damage){
    this.damage = damage;
    return 2;
  }

  /********************************************************************/

  int setBuriedness(int buriedness){
    this.buriedness = buriedness;
    return 2;
  }

  /********************************************************************/

  int setDirection(int direction){
    this.direction = direction;
    return 2;
  }

  /********************************************************************/

  int setPositionHistory(int[] positionHistory){
    if(positionHistory == null){
      return 2;
    }
    System.arraycopy(positionHistory,0,this.positionHistory,0,
		     positionHistory.length);
    this.positionHistory[positionHistory.length] = 0;
    return positionHistory.length + 2;
  }

  /********************************************************************/
  /**
   * ưʤ,,ϤΤȤˤʤȤ,
   * 餯̤ΥȤˤ߽줿˰㤤ʤ <BR>
   * ä, positionֶ᤯refugeIDˤ <BR>
   * , ˱Фƥ᡼Τ
   * damage 0 ˤƤޤ(äȶ) 04-04-27 <BR><BR>
   **/
  public void setPositionRefuge(int refugeid){
    setPosition(refugeid);
    setDamage(0);
  }

  /********************************************************************/
  /**
   * ΥȤΥߥʤ֤
   *<BR><BR>
   * @return ȤΥߥ
   **/

  public int getStamina(){
    return stamina;
  }

  /********************************************************************/
  /**
   * ΥȤHP(̿)֤줬0ˤʤȥȤ
   * ˴ƹưǽˤʤ롣
   *<BR><BR>
   * @return ȤHP
   **/

  public int getHP(){
    return HP;
  }

  /********************************************************************/
  /**
   * ΥȤƤ᡼礭֤1ƥå
   * οʬȤHP롣
   *<BR><BR>
   * @return ȤΥ᡼
   **/

  public int getDamage(){
    return damage;
  }

  /********************************************************************/
  /**
   * ΥȤ٤֤οͤ1ʾȥȤ
   * ưǤʤ
   *<BR><BR>
   * @return Ȥ
   **/

  public int getBuriedness(){
    return buriedness;
  }

  /********************************************************************/
  /**
   * ΥȤ1ƥåˤɤΥ֥ȤưƤ
   * ֤ưƤʤ,null֤
   *<BR><BR>
   * @return Ȥ1Υƥåפιư
   **/

  public int[] getPositionH(){
    if(positionHistory[0] != 0)
      return positionHistory;
    else
      return null;
  }

  /********************************************************************/
  /**
   * ΥȤθƤ֤ʤȻפˡ
   * ߤοͤϰ̣ʤ
   *<BR><BR>
   * @return ȤθƤ
   **/

  public int getDirection(){
    return direction;
  }

  /********************************************************************/

  public String getType(){
    return "Civilian";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println(" " + getType());    
    System.out.println("     ID        : " + getID());
    System.out.println("     Time      : " + getTime());
    System.out.println("     Position  : " + getPosition());
    System.out.println("     PositionEX: " + getPositionExtra());
    System.out.println("     Stamina   : " + getStamina());
    System.out.println("     HP        : " + getHP());
    System.out.println("     Damage    : " + getDamage());
    System.out.println("     Buriedness: " + getBuriedness());
    System.out.println("     Direction : " + getDirection());
    if(positionHistory[0] == 0){
      System.out.println("     PositionH : -");
    }
    else{
      System.out.println("     PositionH : " + positionHistory[0]);
      for(int i=1;positionHistory[i] != 0;i++){
	System.out.println("               : " + positionHistory[i]);
      };
    };
  }

  /********************************************************************/
}
