package rescueAgent.RescueObject;
/**
 * Rescueߥ졼Ǿ⥨Ȥɽ
 **/

public class FireBrigade extends Civilian{
  private int waterQuantity = -1;
  private int strechedLength = -1;

  /********************************************************************/
  // 󥹥ȥ饯

  public FireBrigade(int id,int time){
    super(id,time);
  }

  /********************************************************************/

  public FireBrigade(){
    super();
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  public void init(int id,int time){
    super.init(id,time);
  }

  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_POSITION)
      setPosition(value[0]);
    else if(propID == PROPERTY_POSITION_EXTRA)
      setPositionExtra(value[0]);
    else if(propID == PROPERTY_STAMINA)
      setStamina(value[0]);
    else if(propID == PROPERTY_HP)
      setHP(value[0]);
    else if(propID == PROPERTY_DAMAGE)
      setDamage(value[0]);
    else if(propID == PROPERTY_BURIEDNESS)
      setBuriedness(value[0]);
    else if(propID == PROPERTY_DIRECTION)
      setDirection(value[0]);
    else if(propID == PROPERTY_POSITION_HISTORY)
      setPositionHistory(value);
    else if(propID == PROPERTY_WATER_QUANTITY)
      setWaterQuantity(value[0]);
    else if(propID == PROPERTY_STRECHED_LENGTH)
      setStrechedLength(value[0]);
  }

  /********************************************************************/

  public int parseInfo(int start,int[] data,int time){
    /*
      FireBrigade(233) Parser:
        Type(233),ID(ex.1521),Position,PositionExtra,Stamina,HP,Damage,
	Buriedness,Direction,PositionHistory(list),WaterQuantity,
	StrechedLength

      (NUM)[=Parameter Name]            Attribute       (Value)
      ---------------------------------------------------------------------
      (  6)[=PROPERTY_POSITION]         Position        (ObjectID or 0)
      (  7)[=PROPERTY_POSITION_EXTRA]   PositionExtra   (PositiveIntNumber)
      (  9)[=PROPERTY_STAMINA]          Stamina         (PositiveIntNumber)
      ( 10)[=PROPERTY_HP]               HP              (PositiveIntNumber)
      ( 11)[=PROPERTY_DAMAGE]           Damage          (PositiveIntNumber)
      ( 23)[=PROPERTY_BURIEDNESS]       Buriedness      (PositiveIntNumber)
      ( 27)[=PROPERTY_DIRECTION]        Direction       (0~1295999)
      (207)[=PROPERTY_POSITION_HISTORY] PositionHistory (ObjectIDs list)
      ( 25)[=PROPERTY_WATER_QUANTITY]   WaterQuantity   (PositiveIntNumber)
      ( 26)[=PROPERTY_STRECHED_LENGTH]  StrechedLength  (PositiveIntNumber)
    */

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    setTime(time);

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case  6 : // Position
	offset += setPosition(data[start+offset+1]);
	break;
      case  7 : // PositionExtra
	offset += setPositionExtra(data[start+offset+1]);
	break;
      case  9 : // Stamina
	offset += setStamina(data[start+offset+1]);
	break;
      case 10 : // HP
	offset += setHP(data[start+offset+1]);
	break;
      case 11 : // Damage
	offset += setDamage(data[start+offset+1]);
	break;
      case 23 : // Buriedness
	offset += setBuriedness(data[start+offset+1]);
	break;
      case 27 : // Direction
	offset += setDirection(data[start+offset+1]);
	break;
      case 207: // PositionHistory
	int counter = 0;
	while(data[start+offset]==207 && data[start+counter+offset+1]!=0){
	  counter++;
	}
	if(counter!=0){ // PHist
	  int[] psHist = new int[counter];
	  try{
	    System.arraycopy(data,start+offset+1,psHist,0,counter);
	  }
	  catch(Exception e){
	    e.printStackTrace();
	  }
	  offset += setPositionHistory(psHist);
	}
	else{ // PHistʤ
	  offset += setPositionHistory(null);
	}
	break;
      case 25 : // WaterQuantity
	offset += setWaterQuantity(data[start+offset+1]);
	break;
      case 26 : // StrechedLength
	offset += setStrechedLength(data[start+offset+1]);
	break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  int setWaterQuantity(int waterQuantity){
    this.waterQuantity = waterQuantity;
    return 2;
  }

  /********************************************************************/

  int setStrechedLength(int strechedLength){
    this.strechedLength = strechedLength;
    return 2;
  }

  /********************************************************************/

  public int getWaterQuantity(){

    return waterQuantity;
  }

  /********************************************************************/

  public int getStrechedLength(){

    return strechedLength;
  }

  /********************************************************************/

  public String getType(){
    return "FireBrigade";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println(" " + getType());    
    System.out.println("     ID        : " + getID());
    System.out.println("     Time      : " + getTime());
    System.out.println("     Position  : " + getPosition());
    System.out.println("     PositionEX: " + getPositionExtra());
    System.out.println("     Stamina   : " + getStamina());
    System.out.println("     HP        : " + getHP());
    System.out.println("     Damage    : " + getDamage());
    System.out.println("     Buriedness: " + getBuriedness());
    System.out.println("     Direction : " + getDirection());
    if(positionHistory[0] == 0){
      System.out.println("     PositionH : -");
    }
    else{
      System.out.println("     PositionH : " + positionHistory[0]);
      for(int i=1;positionHistory[i] != 0;i++){
	System.out.println("               : " + positionHistory[i]);
      };
    };
    System.out.println("     WaterQuant: " + waterQuantity);
    System.out.println("     StrechLeng: " + strechedLength);
  }

  /********************************************************************/

}
