package rescueAgent.RescueObject;
/**
 * Rescueߥ졼ˤƺɸɽǽΥݥȤ򼨤
 * ֥Ȥɽ
 **/

public class Node extends Vertex{
  private int signal = -1;
  private int[] shortCutToTurn;
  private int[] pocketToTurnAcross;
  private int[] signalTiming;

  /********************************************************************/
  // 󥹥ȥ饯
  /**
   * @param id   ֥ID
   * @param time ֥Ȥξ󹹿줿
   **/

  public Node(int id,int time){
    init(id,time);
  }

  /********************************************************************/

  public Node(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  void init(int id,int time){
    setID(id);
    setTime(time);
  }

  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_X)
      setX(value[0]);
    else if(propID == PROPERTY_Y)
      setY(value[0]);
    else if(propID == PROPERTY_EDGE)
      setEdge(value);
    else if(propID == PROPERTY_SIGNAL)
      setSignal(value[0]);
    else if(propID == PROPERTY_SHORTCUT_TO_TURN)
      setShortCutToTurn(value);
    else if(propID == PROPERTY_POCKET_TO_TURN_ACROSS)
      setPocketToTurnAcross(value);
    else if(propID == PROPERTY_SIGNAL_TIMING)
      setSignalTiming(value);
  }

  /********************************************************************/

  public int parseInfo(int start,int[] data,int time){ // startNodeTIDǼƤ
    /*
      Node(200) Parser:
        Type(200),ID(ex.1521),X,Y,Edge(list),Signal,ShortCutToTurn(list),
        PocketToTurnAccross(list),SignalTiming(list)

      (NUM)[=Parameter Name]            Attribute       (Value)
      ---------------------------------------------------------------------
      (  3)[=PROPERTY_X]                X               (PositiveIntNumber)
      (  4)[=PROPERTY_Y]                Y               (PositiveIntNumber)
      (242)[=PROPERTY_EDGE]             Edge
                                          (Road or Building ObjectIDs list)
      ( 44)[=PROPERTY_SIGNAL]           Signal          (0 or 1)
      (128)[=PROPERTY_SHORTCUT_TO_TURN] ShortCutToTurn  (Pos.Int.Nums list)
      (129)[=PROPERTY_POCKET_TO_TURN_ACROSS]
                                        PocketToTurnAccross
                                                        (Pos.Int.Nums list)
      (130)[=PROPERTY_SIGNAL_TIMING]    SignalTiming    (Pos.Int.Nums list)
    */

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    setTime(time);

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case  3 : // Node X
        offset += setX(data[start+offset+1]);
        break;
      case  4 : // Node Y
        offset += setY(data[start+offset+1]);
        break;
      case 242: // Edge
	int counter = 0;
	while(data[start+counter+offset+1]!=0){
	  counter++;
	}
	if(counter!=0){ // Edge
	  int[] edgeList = new int[counter];
	  try{
	    System.arraycopy(data,start+offset+1,edgeList,0,counter);
	  }
	  catch(Exception e){
	    e.printStackTrace();
	  }
	  offset += setEdge(edgeList);
	}
	else{ // Edgeʤ
	  offset += setEdge(null);
	}
        break;
      case  44: // Signal
        offset += setSignal(data[start+offset+1]);
        break;
      case 128: // ShortCutToTurn
        if(data[start+offset+1]/4 == 0){ // 1/10Kobe PoliceOfficeǥХФ?!
  	  System.err.println("SIP.parseNodeInfo : SCTT.lenght = 0");
	  return offset-1; // ꤨʤǡʤΤNodeȤƤõλ
        }
        int[] SCTTlist = new int[data[start+offset+1]/4];
        try{
	  System.arraycopy(data,start+offset+2,SCTTlist,0,SCTTlist.length);
        }
        catch(Exception e){
	  e.printStackTrace();
        }
        offset += setShortCutToTurn(SCTTlist);
        break;
      case 129: // PocketToTurnAcross
        if(data[start+offset+1]/4 == 0){ // 1/10Kobe PoliceOfficeǥХФ?!
	  System.err.println("SIP.parseNodeInfo : PTTA.lenght = 0");
	  return offset-1; // ꤨʤǡʤΤNodeȤƤõλ
        }
        int[] PTTAlist = new int[data[start+offset+1]/4];
        try{
	  System.arraycopy(data,start+offset+2,PTTAlist,0,PTTAlist.length);
        }
        catch(Exception e){
	  e.printStackTrace();
        }
        offset += setPocketToTurnAcross(PTTAlist);
        break;
      case 130: // SignalTiming
        if(data[start+offset+1]/4 == 0){ // 1/10Kobe PoliceOfficeǥХФ?!
	  System.err.println("SIP.parseNodeInfo : ST.lenght = 0");
  	  return offset-1; // ꤨʤǡʤΤNodeȤƤõλ
        }
        int[] STlist = new int[data[start+offset+1]/4];
        try{
	  System.arraycopy(data,start+offset+2,STlist,0,STlist.length);
        }
        catch(Exception e){
	  e.printStackTrace();
        }
        offset += setSignalTiming(STlist);
        break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  int setSignal(int signal){
    this.signal = signal;
    return 2;
  }

  /********************************************************************/

  int setShortCutToTurn(int[] shortCutToTurn){
    this.shortCutToTurn = new int[shortCutToTurn.length];
    for(int i=0;i<shortCutToTurn.length;i++){
      this.shortCutToTurn[i] = shortCutToTurn[i];
    }
    return shortCutToTurn.length + 2;
  }
  
  /********************************************************************/
  
  int setPocketToTurnAcross(int[] pocketToTurnAcross){
    this.pocketToTurnAcross = new int[pocketToTurnAcross.length];
    for(int i=0;i<pocketToTurnAcross.length;i++){
      this.pocketToTurnAcross[i] = pocketToTurnAcross[i];
    }
    return pocketToTurnAcross.length+2;
  }
  
  /********************************************************************/
  
  int setSignalTiming(int[] signalTiming){
    this.signalTiming = new int[signalTiming.length];
    for(int i=0;i<signalTiming.length;i++){
      this.signalTiming[i] = signalTiming[i];
    }
    return signalTiming.length+2;
  }

  /********************************************************************/
  /**
   * Node³Ƥ륪֥ȤθĿ֤
   *<BR><BR>
   * @return Node³Ƥ륪֥Ȥο
   **/
  int getEdgeLength(){
    return edge.length;
  }

  /********************************************************************/
  /**
   * ̤
   **/

  int getShortCutToTurnLength(){
    return shortCutToTurn.length;
  }

  /********************************************************************/
  /**
   * ̤
   **/

  int getPocketToTurnAcrossLength(){
    return pocketToTurnAcross.length;
  }

  /********************************************************************/

  int getSignalTimingLength(){
    return signalTiming.length;
  }

  /********************************************************************/

  public String getType(){
    return "Node";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println(" NodeID        : " + getID());
    System.out.println("     Time      : " + getTime());
    System.out.println("     X         : " + getX());
    System.out.println("     Y         : " + getY());
    for(int i=0;i<edge.length;i++){
      if(i==0)
	System.out.println("     Edge      : " + edge[0]);
      else
	System.out.println("               : " + edge[i]);	
    };

    System.out.println("     Signal    : " + signal);

    for(int i=0;i<shortCutToTurn.length;i++)
      if(i==0)
	System.out.println("    ShortCutTT : " + shortCutToTurn[i]);
      else
	System.out.println("               : " + shortCutToTurn[i]);
    for(int i=0;i<pocketToTurnAcross.length;i++)
      if(i==0)
	System.out.println("    PocketTTA  : " + pocketToTurnAcross[i]);
      else
	System.out.println("               : " + pocketToTurnAcross[i]);
    for(int i=0;i<signalTiming.length;i++)
      if(i==0)
	System.out.println("    SignalTm   : " + signalTiming[i]);
      else
	System.out.println("               : " + signalTiming[i]);


  }

  /********************************************************************/
}
