package rescueAgent.RescueObject;
/**
 * Rescueߥ졼ƤμΥ֥Ȥɽ饹<BR>
 * RescueObject : Basic Class of Rescue simulation <BR>
 *<PRE>
 *  RescueObjectγؿ
 * RescueObject
 *   |
 *   +-- VirtualObject --- World
 *   |
 *   +-- RealObject --- MovingObject --- Civilian --- FireBrigade
 *            |                             |
 *            |                             +-- AmbulanceTeam
 *            |                             |
 *            |                             +-- PoliceForce
 *            |
 *            +-- MovelessObject --- PointObject --- Building --- Refuge
 *                     |                  |             |
 *                     |                  |             +-- FireStation
 *                     |                  |             |
 *                     |                  |             +-- PoliceOffice
 *                     |                  |             |
 *                     |                  |             +-- AmbulanceCenter
 *                     |                  |
 *                     |                  +-- Node
 *                     |
 *                     +-- Edge --- Road
 *</PRE>
 **/
public abstract class RescueObject{
  static final int PROPERTY_X = 3;
  static final int PROPERTY_Y = 4;

  static final int PROPERTY_DIRECTION = 27;
  static final int PROPERTY_POSITION = 6;
  static final int PROPERTY_POSITION_HISTORY = 207;
  static final int PROPERTY_POSITION_EXTRA = 7;

  static final int PROPERTY_STAMINA = 9;
  static final int PROPERTY_HP = 10;
  static final int PROPERTY_DAMAGE = 11;
  static final int PROPERTY_BURIEDNESS = 23;

  static final int PROPERTY_FLOORS = 14;
  static final int PROPERTY_BUILDING_ATTRIBUTES = 15;
  static final int PROPERTY_IGNITION = 48;
  static final int PROPERTY_FIERYNESS = 16;
  static final int PROPERTY_BROKENNESS = 17;
  //public static final int ENTRANCES = 21;
  static final int PROPERTY_ENTRANCES = 235; // ХID֥
  static final int PROPERTY_BUILDING_SHAPE_ID = 49; // ¸ߤʤ!?(03-06-12)
  static final int PROPERTY_BUILDING_CODE = 50;
  static final int PROPERTY_BUILDING_AREA_GROUND = 51;
  static final int PROPERTY_BUILDING_AREA_TOTAL = 52;
  //public static final int BUILDING_APEXES = 53; // ְ㤤
  static final int PROPERTY_BUILDING_APEXES = 131; // ޥ˥奢ΥХ

  static final int PROPERTY_WATER_QUANTITY = 25;
  static final int PROPERTY_STRECHED_LENGTH = 26;

  static final int PROPERTY_HEAD = 12;
  static final int PROPERTY_TAIL = 13;
  static final int PROPERTY_LENGTH = 24;

  static final int PROPERTY_ROAD_KIND = 19;
  static final int PROPERTY_CARS_PASS_TO_HEAD = 34;
  static final int PROPERTY_CARS_PASS_TO_TAIL = 35;
  static final int PROPERTY_HUMAN_PASS_TO_HEAD = 36;
  static final int PROPERTY_HUMAN_PASS_TO_TAIL = 37; //(37)
  static final int PROPERTY_WIDTH = 38;
  static final int PROPERTY_BLOCK = 22;
  static final int PROPERTY_REPAIR_COST = 39;
  static final int PROPERTY_MEDIAN_STRIP = 40;
  static final int PROPERTY_LINES_TO_HEAD = 41;
  static final int PROPERTY_LINES_TO_TAIL = 42;
  static final int PROPERTY_WIDTH_FOR_WALKS = 43;

  static final int PROPERTY_EDGE = 242;

  static final int PROPERTY_SIGNAL = 44;
  static final int PROPERTY_SIGNAL_TIMING = 130; // Man : 194(130)
  static final int PROPERTY_SHORTCUT_TO_TURN = 128; // Man : 192(128)!!!
  static final int PROPERTY_POCKET_TO_TURN_ACROSS = 129; // Man : 193(129)
  
  static final int PROPERTY_START_TIME = 29;
  static final int PROPERTY_LONGITUDE = 30;
  static final int PROPERTY_LATITUDE = 31;
  static final int PROPERTY_WIND_FORCE = 32;
  static final int PROPERTY_WIND_DIRECTION = 33;

  private int id;

  /********************************************************************/
  /**
   * ֥IDꡣ
   *<BR><BR>
   * @param id Υ֥ȤID
   **/

  protected void setID(int id){
    this.id = id;
  }

  /********************************************************************/
  /**
   * RescueObjectparsing򤪤ʤ
   *<BR><BR>
   * @param propID ץѥƥID(Ex. HP=10,DAMAGE=11,etc..)
   * @param value  ץѥƥФ(int)
   **/

  public abstract void setProperty(int propID,int[] value);

  /********************************************************************/
  /**
   * RescueObjectparsing򤪤ʤ(kernelϤľ)
   *<BR><BR>
   * @param start  ɤ߹Ƭֹ
   * @param data   kernelϤintľ
   * @param time   kernelȤäȤλ
   * @return  ǽθĿ
   **/

  public abstract int parseInfo(int start,int[] data,int time);

  /********************************************************************/
  /**
   * Υ֥ȤID֤
   *<BR><BR>
   * @return Υ֥ȤID
   **/

  public int getID(){
    return id;
  };

  /********************************************************************/
  /**
   * Υ֥ȤType(Ex: Civilian,Building,etc...)֤
   *<BR><BR>
   * @return Υ֥ȤΥפʸ
   **/

  public abstract String getType();

  /********************************************************************/
  /**
   * Υ֥Ȥξϡ
   **/

  public abstract void printInfo();

  /********************************************************************/
}

