package rescueAgent.RescueObject;
/**
 * Rescueߥ졼NodeNode֥󥯤ɽ륪֥
 **/

public class Road extends Edge{
  int roadKind = -1;
  int carPassToHead = -1;
  int carPassToTail = -1;
  int humanPassToHead = -1;
  int humanPassToTail = -1;
  int width = -1;
  int block = -1;
  int repairCost = -1;
  int medianStrip = -1;
  int linesToHead = -1;
  int linesToTail = -1;
  int widthForWalker = -1;

  /********************************************************************/
  //󥹥ȥ饯
  /**
   * @param id   ֥ID
   * @param time ֥Ȥξ󹹿줿
   **/

  public Road(int id,int time){
    init(id,time);
  }

  /********************************************************************/

  public Road(){
  }

  // 󥹥ȥ饯 ޤ
  /********************************************************************/

  void init(int id,int time){
    setID(id);
    setTime(time);
  }

  /********************************************************************/

  public void setProperty(int propID,int[] value){
    if(propID == PROPERTY_HEAD)
      setHead(value[0]);
    else if(propID == PROPERTY_TAIL)
      setTail(value[0]);
    else if(propID == PROPERTY_LENGTH)
      setLength(value[0]);
    else if(propID == PROPERTY_ROAD_KIND)
      setRoadKind(value[0]);
    else if(propID == PROPERTY_CARS_PASS_TO_HEAD)
      setCarPassToHead(value[0]);
    else if(propID == PROPERTY_CARS_PASS_TO_TAIL)
      setCarPassToTail(value[0]);
    else if(propID == PROPERTY_HUMAN_PASS_TO_HEAD)
      setHumanPassToHead(value[0]);
    else if(propID == PROPERTY_HUMAN_PASS_TO_TAIL)
      setHumanPassToTail(value[0]);
    else if(propID == PROPERTY_WIDTH)
      setWidth(value[0]);
    else if(propID == PROPERTY_BLOCK)
      setBlock(value[0]);
    else if(propID == PROPERTY_REPAIR_COST)
      setRepairCost(value[0]);
    else if(propID == PROPERTY_MEDIAN_STRIP)
      setMedianStrip(value[0]);  
    else if(propID == PROPERTY_LINES_TO_HEAD)
      setLinesToHead(value[0]);
    else if(propID == PROPERTY_LINES_TO_TAIL)
      setLinesToTail(value[0]);
    else if(propID == PROPERTY_WIDTH_FOR_WALKS)
      setWidthForWalker(value[0]);
  }

  /********************************************************************/

  public int parseInfo(int start,int[] data,int time){
    /*
      Road(168) Parser:
        Type(168),ID(ex.1521),Head,Tail,Length,RoadKind,CarPassToHead,
	CarPassToTail,HumanPassToHead,HumanPassToTail,Width,Block,
	RepairCost,MedianStrip,LinesToHead,LinesToTail,WidthForWalker

      (NUM)[=Parameter Name]              Attribute       (Value)
      -----------------------------------------------------------------------
      ( 12)[=PROPERTY_HEAD]               Head            (NodeObjectID)
      ( 13)[=PROPERTY_TAIL]               Tail            (NodeObjectID)
      ( 24)[=PROPERTY_LENGTH]             Length          (PositiveIntNumber)
      ( 19)[=PROPERTY_ROAD_KIND]          RoadKind        (PositiveIntNumber)
      ( 34)[=PROPERTY_CARS_PASS_TO_HEAD]  CarPassToHead   (PositiveIntNumber)
      ( 35)[=PROPERTY_CARS_PASS_TO_TAIL]  CarPassToTail   (PositiveIntNumber)
      ( 36)[=PROPERTY_HUMAN_PASS_TO_HEAD] HumanPassToHead (PositiveIntNumber)
      ( 37)[=PROPERTY_HUMAN_PASS_TO_TAIL] HumanPassToTail (PositiveIntNumber)
      ( 38)[=PROPERTY_WIDTH]              Width           (PositiveIntNumber)
      ( 22)[=PROPERTY_BLOCK]              Block           (PositiveIntNumber)
      ( 39)[=PROPERTY_REPAIR_COST]        RepairCost      (PositiveIntNumber)
      ( 40)[=PROPERTY_MEDIAN_STRIP]       MedianStrip     (0 or 1)
      ( 41)[=PROPERTY_LINES_TO_HEAD]      LinesToHead     (PositiveIntNumber)
      ( 42)[=PROPERTY_LINES_TO_TAIL]      LinesToTail     (PositiveIntNumber)
      ( 43)[=PROPERTY_WIDTH_FOR_WALKS]    WidthForWalks   (PositiveIntNumber)
     */

    int offset = 2; // ̵ͤͭˤ뺹ʬ׻

    setTime(time);

    while(data[start+offset] != 0){
      switch(data[start+offset]){ // °ǡŪ˲
      case  12: // Head
	offset += setHead(data[start+offset+1]);
	break;
      case  13: // Tail
	offset += setTail(data[start+offset+1]);
	break;
      case  24: // Length
	offset += setLength(data[start+offset+1]);
	break;
      case  19: // RoadKind
	offset += setRoadKind(data[start+offset+1]);
	break;
      case  34: // CarPassToHead
	offset += setCarPassToHead(data[start+offset+1]);
	break;
      case  35: // CarPassToTail
	offset += setCarPassToTail(data[start+offset+1]);
	break;
      case  36: // HumanPassToHead
	offset += setHumanPassToHead(data[start+offset+1]);
	break;
      case  37: // HumanPassToTail
	offset += setHumanPassToTail(data[start+offset+1]);
	break;
      case  38: // Width
	offset += setWidth(data[start+offset+1]);
	break;
      case  22: // Block
	offset += setBlock(data[start+offset+1]);
	break;
      case  39: // RepairCost
	offset += setRepairCost(data[start+offset+1]);
	break;
      case  40: // MedianStrip
	offset += setMedianStrip(data[start+offset+1]);
	break;
      case  41: // LinesToHead
	offset += setLinesToHead(data[start+offset+1]);
	break;
      case  42: // LinesToTail
	offset += setLinesToTail(data[start+offset+1]);
	break;
      case  43: // WidthForWalks
	offset += setWidthForWalker(data[start+offset+1]);
	break;
      default: // Illegal Data
	System.out.println("Illegal Data!! ("+start+offset+")"+data[start+offset]); // Illegal Data ʬɽ
	System.out.print("Received 30Data: ");
	for(int i=0;i<30;i++){
	  System.out.print(data[start+i] + " "); // IllegalΰDataɽ
	}
	System.out.println();
	offset++;
      } // end switch
    } // end while

    checkEndOfBuffer(data[start+offset]);

    return offset-1; // use array length in this object
  }

  /********************************************************************/

  int setRoadKind(int roadKind){
    this.roadKind = roadKind;
    return 2;
  }

  /********************************************************************/

  int setCarPassToHead(int carPassToHead){
    this.carPassToHead = carPassToHead;
    return 2;
  }

  /********************************************************************/

  int setCarPassToTail(int carPassTotail){
    this.carPassToTail = carPassToTail;
    return 2;
  }

  /********************************************************************/

  int setHumanPassToHead(int humanPassToHead){
    this.humanPassToHead = humanPassToHead;
    return 2;
  }

  /********************************************************************/

  int setHumanPassToTail(int humanPassToTail){
    this.humanPassToTail = humanPassToTail;
    return 2;
  }

  /********************************************************************/

  int setWidth(int width){
    this.width = width;
    return 2;
  }

  /********************************************************************/

  int setBlock(int block){
    this.block = block;
    return 2;
  }

  /********************************************************************/

  int setRepairCost(int repairCost){
    this.repairCost = repairCost;
    return 2;
  }

  /********************************************************************/

  int setMedianStrip(int medianStrip){
    this.medianStrip = medianStrip;
    return 2;
  }

  /********************************************************************/

  int setLinesToHead(int linesToHead){
    this.linesToHead = linesToHead;
    return 2;
  }

  /********************************************************************/

  int setLinesToTail(int linesToTail){
    this.linesToTail = linesToTail;
    return 2;
  }

  /********************************************************************/

  int setWidthForWalker(int widthForWalker){
    this.widthForWalker = widthForWalker;
    return 2;
  }

  /********************************************************************/

  public int getWidth(){
    return width;
  }

  /********************************************************************/

  public int getBlock(){
    return block;
  }

  /********************************************************************/
  /********************************************************************/

  public int getLinesToHead(){
    return linesToHead;
  }

  /********************************************************************/

  public int getLinesToTail(){
    return linesToTail;
  }

  /********************************************************************/
  /********************************************************************/

  public String getType(){
    return "Road";
  }

  /********************************************************************/

  public void printInfo(){
    System.out.println(" RoadID        : " + getID());
    System.out.println("     Time      : " + getTime());
    System.out.println("     Head      : " + head);
    System.out.println("     Tail      : " + tail);
    System.out.println("     Length    : " + length);
    System.out.println("     RoadKind  : " + roadKind);
    System.out.println("     CPToHead  : " + carPassToHead);
    System.out.println("     CPToTail  : " + carPassToTail);
    System.out.println("     HPToHead  : " + humanPassToHead);
    System.out.println("     HPToTail  : " + humanPassToTail);
    System.out.println("     Width     : " + width);
    System.out.println("     Block     : " + block);
    System.out.println("     RepairCost: " + repairCost);
    System.out.println("     MedStrip  : " + medianStrip);
    System.out.println("     LinesToH  : " + linesToHead);
    System.out.println("     LinesToT  : " + linesToTail);
    System.out.println("     WidthForW : " + widthForWalker);
    //(new Throwable()).printStackTrace(); // !!!!!!!!!!!!!!
  }

  /********************************************************************/
  /********************************************************************/

  public void setBlockForce(int val){
    this.block = val;
  }

  /********************************************************************/
  /**
   * ƻϩ̹Բǽʤtrue
   *<BR><BR>
   * @return true:̹Բǽ  false:̹ǽ
   **/

  public boolean isThroughable(){
    int aliveLaneF = getAliveLaneToTail();
    int aliveLaneR = getAliveLaneToHead();

    if(aliveLaneF==0 || aliveLaneR==0){
      return false;
    }
    else{
      return true;
    }
  }

  /********************************************************************/
  /**
   * ƻϩTail->Head̹Բǽʥ졼֤
   *<BR><BR>
   * @return Tail->Head̹Բǽʥ졼
   **/
  public int getAliveLaneToHead(){
    // ƻϩĺ٤򼨤ѿ(ͤǤ linesBlockedRateF = linesBlockedRateR)
    double linesBlockedRateF = (double)block / (double)width;
    // 졼(linesToHead)⡢̹Բǽʥ졼
    int linesBlockedF = (int)Math.floor(linesBlockedRateF*linesToHead + 0.5);
    return Math.max(linesToHead - linesBlockedF , 0);
  }

  /********************************************************************/
  /**
   * ƻϩHead->Tail̹Բǽʥ졼֤
   *<BR><BR>
   * @return Head->Tail̹Բǽʥ졼
   **/
  public int getAliveLaneToTail(){
    // ƻϩĺ٤򼨤ѿ(ͤǤ linesBlockedRateF = linesBlockedRateR)
    double linesBlockedRateR = (double)block / (double)width;
    // 졼(linesToTail)⡢̹Բǽʥ졼
    int linesBlockedR = (int)Math.floor(linesBlockedRateR*linesToTail + 0.5);
    return Math.max(linesToTail - linesBlockedR , 0);
  }

  /********************************************************************/

}
